/**
 */
package de.ubt.ai1.modGraph.example.eRefactoring;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EParameter;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EStructuralFeature;

import de.ubt.ai1.modgraph.gt.failure.GTFailure;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Refactoring</b></em>'. <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.Refactoring#getHelper <em>Helper</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.Refactoring#getReferenceToEPackage <em>Reference To EPackage</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.Refactoring#getReferenceToENamedElement <em>Reference To ENamed Element</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.Refactoring#getReferenceToEOperation <em>Reference To EOperation</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.Refactoring#getReferenceToEClass <em>Reference To EClass</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.Refactoring#getReferenceToEAttribute <em>Reference To EAttribute</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.Refactoring#getReferenceToEReference <em>Reference To EReference</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.Refactoring#getReferenceToEParameter <em>Reference To EParameter</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.Refactoring#getReferenceToEStructuralFeature <em>Reference To EStructural Feature</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.ubt.ai1.modGraph.example.eRefactoring.ERefactoringPackage#getRefactoring()
 * @model
 * @generated
 */
public interface Refactoring extends EObject {
	/**
	 * Returns the value of the '<em><b>Helper</b></em>' reference. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Helper</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Helper</em>' reference.
	 * @see #setHelper(Helper)
	 * @see de.ubt.ai1.modGraph.example.eRefactoring.ERefactoringPackage#getRefactoring_Helper()
	 * @model
	 * @generated
	 */
	Helper getHelper();

	/**
	 * Sets the value of the '
	 * {@link de.ubt.ai1.modGraph.example.eRefactoring.Refactoring#getHelper
	 * <em>Helper</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Helper</em>' reference.
	 * @see #getHelper()
	 * @generated
	 */
	void setHelper(Helper value);

	/**
	 * Returns the value of the '<em><b>Reference To EPackage</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.emf.ecore.EPackage}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Reference To EPackage</em>' reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Reference To EPackage</em>' reference list.
	 * @see de.ubt.ai1.modGraph.example.eRefactoring.ERefactoringPackage#getRefactoring_ReferenceToEPackage()
	 * @model
	 * @generated
	 */
	EList<EPackage> getReferenceToEPackage();

	/**
	 * Returns the value of the '<em><b>Reference To ENamed Element</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.emf.ecore.ENamedElement}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Reference To ENamed Element</em>' reference
	 * list isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Reference To ENamed Element</em>' reference list.
	 * @see de.ubt.ai1.modGraph.example.eRefactoring.ERefactoringPackage#getRefactoring_ReferenceToENamedElement()
	 * @model
	 * @generated
	 */
	EList<ENamedElement> getReferenceToENamedElement();

	/**
	 * Returns the value of the '<em><b>Reference To EOperation</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.emf.ecore.EOperation}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Reference To EOperation</em>' reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Reference To EOperation</em>' reference list.
	 * @see de.ubt.ai1.modGraph.example.eRefactoring.ERefactoringPackage#getRefactoring_ReferenceToEOperation()
	 * @model
	 * @generated
	 */
	EList<EOperation> getReferenceToEOperation();

	/**
	 * Returns the value of the '<em><b>Reference To EClass</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.emf.ecore.EClass}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Reference To EClass</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Reference To EClass</em>' reference list.
	 * @see de.ubt.ai1.modGraph.example.eRefactoring.ERefactoringPackage#getRefactoring_ReferenceToEClass()
	 * @model
	 * @generated
	 */
	EList<EClass> getReferenceToEClass();

	/**
	 * Returns the value of the '<em><b>Reference To EAttribute</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.emf.ecore.EAttribute}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Reference To EAttribute</em>' reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Reference To EAttribute</em>' reference list.
	 * @see de.ubt.ai1.modGraph.example.eRefactoring.ERefactoringPackage#getRefactoring_ReferenceToEAttribute()
	 * @model
	 * @generated
	 */
	EList<EAttribute> getReferenceToEAttribute();

	/**
	 * Returns the value of the '<em><b>Reference To EReference</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.emf.ecore.EReference}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Reference To EReference</em>' reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Reference To EReference</em>' reference list.
	 * @see de.ubt.ai1.modGraph.example.eRefactoring.ERefactoringPackage#getRefactoring_ReferenceToEReference()
	 * @model
	 * @generated
	 */
	EList<EReference> getReferenceToEReference();

	/**
	 * Returns the value of the '<em><b>Reference To EParameter</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.emf.ecore.EParameter}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Reference To EParameter</em>' reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Reference To EParameter</em>' reference list.
	 * @see de.ubt.ai1.modGraph.example.eRefactoring.ERefactoringPackage#getRefactoring_ReferenceToEParameter()
	 * @model
	 * @generated
	 */
	EList<EParameter> getReferenceToEParameter();

	/**
	 * Returns the value of the '<em><b>Reference To EStructural Feature</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.emf.ecore.EStructuralFeature}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Reference To EStructural Feature</em>'
	 * reference list isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Reference To EStructural Feature</em>' reference list.
	 * @see de.ubt.ai1.modGraph.example.eRefactoring.ERefactoringPackage#getRefactoring_ReferenceToEStructuralFeature()
	 * @model
	 * @generated
	 */
	EList<EStructuralFeature> getReferenceToEStructuralFeature();

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc -->
	 * Generated by ModGraph: <!-- end-model-doc -->
	 * 
	 * @model oldNameUnique="false" newNameUnique="false" annotation=
	 *        "http://www.eclipse.org/emf/2002/GenModel body='try\n{\n\t<%org.eclipse.emf.ecore.ENamedElement%> elementToRename = null;\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.ENamedElement%>> _referenceToENamedElement = this.getReferenceToENamedElement();\n\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.ENamedElement%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.ENamedElement%>, <%java.lang.Boolean%>>()\n\t{\n\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.ENamedElement%> e)\n\t\t{\n\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, oldName));\n\t\t}\n\t};\n\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.ENamedElement%>> _filter = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.ENamedElement%>>filter(_referenceToENamedElement, _function);\n\tfor (final <%org.eclipse.emf.ecore.ENamedElement%> _elementToRename : _filter)\n\t{\n\t\t{\n\t\t\tboolean _evaluateOCLCondition = <%de.ubt.ai1.modgraph.gt.ecoreFromXcore.generator.ocl.OCLHandler%>.evaluateOCLCondition(\n\t\t\t\t\"self.oclAsType(EObject).eContainer().eContents()->select(name = newName)->size()=0\", _elementToRename);\n\t\t\tif (_evaluateOCLCondition)\n\t\t\t{\n\t\t\t\tthrow new <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>();\n\t\t\t}\n\t\t\telementToRename = _elementToRename;\n\t\t}\n\t}\n\tboolean _equals = <%com.google.common.base.Objects%>.equal(elementToRename, null);\n\tif (_equals)\n\t{\n\t\tthrow new <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>();\n\t}\n\tfinal <%java.lang.String%> elementToRenameNameValue = newName;\n\telementToRename.setName(elementToRenameNameValue);\n}\ncatch (Throwable _e)\n{\n\tthrow org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);\n}'"
	 * @generated
	 */
	void renameENamedElement(String oldName, String newName);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model elementUnique="false" newNameUnique="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='<%org.eclipse.emf.ecore.EObject%> _eContainer = element.eContainer();\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EObject%>> _eContents = _eContainer.eContents();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EObject%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EObject%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EObject%> e)\n\t{\n\t\t<%org.eclipse.emf.ecore.EClass%> _eClass = e.eClass();\n\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_eClass, <%org.eclipse.emf.ecore.EClass%>.class));\n\t}\n};\n<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EObject%>> _filter = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EObject%>>filter(_eContents, _function);\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EObject%>, <%java.lang.Boolean%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EObject%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EObject%> e)\n\t{\n\t\tboolean _and = false;\n\t\t<%org.eclipse.emf.ecore.EClass%> _eClass = e.eClass();\n\t\t<%org.eclipse.emf.ecore.EClass%> _eClass_1 = element.eClass();\n\t\tboolean _equals = <%com.google.common.base.Objects%>.equal(_eClass, _eClass_1);\n\t\tif (!_equals)\n\t\t{\n\t\t\t_and = false;\n\t\t} else\n\t\t{\n\t\t\t<%java.lang.String%> _name = ((<%org.eclipse.emf.ecore.EClass%>) e).getName();\n\t\t\tboolean _equals_1 = <%com.google.common.base.Objects%>.equal(_name, newName);\n\t\t\t_and = _equals_1;\n\t\t}\n\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t}\n};\nboolean _exists = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EObject%>>exists(_filter, _function_1);\nif (_exists)\n{\n\treturn;\n}\nelse\n{\n\telement.setName(newName);\n}'"
	 * @generated
	 */
	void renameENamedElement(ENamedElement element, String newName);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc -->
	 * Generated by ModGraph. <!-- end-model-doc -->
	 * 
	 * @model operationNameUnique="false" parameterNameUnique="false"
	 *        paramTypeUnique="false" annotation=
	 *        "http://www.eclipse.org/emf/2002/GenModel body='<%org.eclipse.emf.ecore.EOperation%> op1 = null;\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _referenceToEOperation = this.getReferenceToEOperation();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EOperation%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EOperation%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EOperation%> e)\n\t{\n\t\t<%java.lang.String%> _name = e.getName();\n\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, operationName));\n\t}\n};\n<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EOperation%>> _filter = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EOperation%>>filter(_referenceToEOperation, _function);\nfor (final <%org.eclipse.emf.ecore.EOperation%> _op1 : _filter)\n{\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EParameter%>> _eParameters = _op1.getEParameters();\n\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EParameter%>, <%java.lang.Boolean%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EParameter%>, <%java.lang.Boolean%>>()\n\t{\n\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EParameter%> e)\n\t\t{\n\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, parameterName));\n\t\t}\n\t};\n\t<%org.eclipse.emf.ecore.EParameter%> _findFirst = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EParameter%>>findFirst(_eParameters, _function_1);\n\tboolean _notEquals = (!<%com.google.common.base.Objects%>.equal(_findFirst, null));\n\tboolean _not = (!_notEquals);\n\tif (_not)\n\t{\n\t\top1 = _op1;\n\t}\n}\nfinal <%java.lang.String%> newParameterNameValue = parameterName;\n<%org.eclipse.emf.ecore.EParameter%> newParameter = <%org.eclipse.emf.ecore.EcoreFactory%>.eINSTANCE.createEParameter();\nnewParameter.setName(newParameterNameValue);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EParameter%>> _eParameters_1 = op1.getEParameters();\n_eParameters_1.add(newParameter);\nnewParameter.setEType(paramType);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EParameter%>> _referenceToEParameter = this.getReferenceToEParameter();\n_referenceToEParameter.add(newParameter);'"
	 *        annotation=
	 *        "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot pre_pre1='operation.size()>0 and parameter.size()>0'"
	 * @generated
	 */
	void addEParameter(String operationName, String parameterName,
			EClassifier paramType);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc -->
	 * Generated by ModGraph: <!-- end-model-doc -->
	 * 
	 * @model operationNameUnique="false" parameterNameUnique="false"
	 *        annotation=
	 *        "http://www.eclipse.org/emf/2002/GenModel body='try\n{\n\t<%org.eclipse.emf.ecore.EOperation%> operation = null;\n\t<%org.eclipse.emf.ecore.EParameter%> parameter = null;\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _referenceToEOperation = this.getReferenceToEOperation();\n\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EOperation%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EOperation%>, <%java.lang.Boolean%>>()\n\t{\n\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EOperation%> e)\n\t\t{\n\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, operationName));\n\t\t}\n\t};\n\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EOperation%>> _filter = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EOperation%>>filter(_referenceToEOperation, _function);\n\tfor (final <%org.eclipse.emf.ecore.EOperation%> _operation : _filter)\n\t{\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EParameter%>> _referenceToEParameter = this.getReferenceToEParameter();\n\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EParameter%>, <%java.lang.Boolean%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EParameter%>, <%java.lang.Boolean%>>()\n\t\t{\n\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EParameter%> e)\n\t\t\t{\n\t\t\t\tboolean _and = false;\n\t\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\t\tboolean _equals = <%com.google.common.base.Objects%>.equal(_name, parameterName);\n\t\t\t\tif (!_equals)\n\t\t\t\t{\n\t\t\t\t\t_and = false;\n\t\t\t\t} else\n\t\t\t\t{\n\t\t\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EParameter%>> _eParameters = _operation.getEParameters();\n\t\t\t\t\tboolean _contains = _eParameters.contains(e);\n\t\t\t\t\t_and = _contains;\n\t\t\t\t}\n\t\t\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t\t\t}\n\t\t};\n\t\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EParameter%>> _filter_1 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EParameter%>>filter(_referenceToEParameter, _function_1);\n\t\tfor (final <%org.eclipse.emf.ecore.EParameter%> _parameter : _filter_1)\n\t\t{\n\t\t\t{\n\t\t\t\toperation = _operation;\n\t\t\t\tparameter = _parameter;\n\t\t\t}\n\t\t}\n\t}\n\tboolean _equals = <%com.google.common.base.Objects%>.equal(operation, null);\n\tif (_equals)\n\t{\n\t\tthrow new <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>();\n\t}\n\t<%org.eclipse.emf.ecore.util.EcoreUtil%>.remove(parameter);\n}\ncatch (Throwable _e)\n{\n\tthrow org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);\n}'"
	 * @generated
	 */
	void removeEParameter(String operationName, String parameterName);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc -->
	 * Generated by ModGraph: <!-- end-model-doc -->
	 * 
	 * @model operationNameUnique="false" targetClassNameUnique="false"
	 *        sourceClassNameUnique="false" annotation=
	 *        "http://www.eclipse.org/emf/2002/GenModel body='try\n{\n\t<%org.eclipse.emf.ecore.EClass%> sourceClass = null;\n\t<%org.eclipse.emf.ecore.EClass%> targetClass = null;\n\t<%org.eclipse.emf.ecore.EOperation%> operation = null;\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _referenceToEOperation = this.getReferenceToEOperation();\n\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EOperation%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EOperation%>, <%java.lang.Boolean%>>()\n\t{\n\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EOperation%> e)\n\t\t{\n\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, operationName));\n\t\t}\n\t};\n\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EOperation%>> _filter = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EOperation%>>filter(_referenceToEOperation, _function);\n\tfor (final <%org.eclipse.emf.ecore.EOperation%> _operation : _filter)\n\t{\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass = this.getReferenceToEClass();\n\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n\t\t{\n\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t\t\t{\n\t\t\t\tboolean _and = false;\n\t\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\t\tboolean _equals = <%com.google.common.base.Objects%>.equal(_name, sourceClassName);\n\t\t\t\tif (!_equals)\n\t\t\t\t{\n\t\t\t\t\t_and = false;\n\t\t\t\t} else\n\t\t\t\t{\n\t\t\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations = e.getEOperations();\n\t\t\t\t\tboolean _contains = _eOperations.contains(_operation);\n\t\t\t\t\t_and = _contains;\n\t\t\t\t}\n\t\t\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t\t\t}\n\t\t};\n\t\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EClass%>> _filter_1 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>filter(_referenceToEClass, _function_1);\n\t\tfor (final <%org.eclipse.emf.ecore.EClass%> _sourceClass : _filter_1)\n\t\t{\n\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass_1 = this.getReferenceToEClass();\n\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function_2 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n\t\t\t{\n\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t\t\t\t{\n\t\t\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, targetClassName));\n\t\t\t\t}\n\t\t\t};\n\t\t\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EClass%>> _filter_2 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>filter(_referenceToEClass_1, _function_2);\n\t\t\tfor (final <%org.eclipse.emf.ecore.EClass%> _targetClass : _filter_2)\n\t\t\t{\n\t\t\t\t{\n\t\t\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations = _targetClass.getEOperations();\n\t\t\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EOperation%>, <%java.lang.Boolean%>> _function_3 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EOperation%>, <%java.lang.Boolean%>>()\n\t\t\t\t\t{\n\t\t\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EOperation%> e)\n\t\t\t\t\t\t{\n\t\t\t\t\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, operationName));\n\t\t\t\t\t\t}\n\t\t\t\t\t};\n\t\t\t\t\t<%org.eclipse.emf.ecore.EOperation%> _findFirst = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EOperation%>>findFirst(_eOperations, _function_3);\n\t\t\t\t\tboolean _notEquals = (!<%com.google.common.base.Objects%>.equal(_findFirst, null));\n\t\t\t\t\tboolean _not = (!_notEquals);\n\t\t\t\t\tif (_not)\n\t\t\t\t\t{\n\t\t\t\t\t\tsourceClass = _sourceClass;\n\t\t\t\t\t}\n\t\t\t\t\ttargetClass = _targetClass;\n\t\t\t\t\toperation = _operation;\n\t\t\t\t}\n\t\t\t}\n\t\t}\n\t}\n\tboolean _equals = <%com.google.common.base.Objects%>.equal(sourceClass, null);\n\tif (_equals)\n\t{\n\t\tthrow new <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>();\n\t}\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations = sourceClass.getEOperations();\n\t_eOperations.remove(operation);\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations_1 = targetClass.getEOperations();\n\t_eOperations_1.add(operation);\n}\ncatch (Throwable _e)\n{\n\tthrow org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);\n}'"
	 *        annotation=
	 *        "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot pre_pre1='operationName->size() > 0'"
	 * @generated
	 */
	void moveEOperation(String operationName, String targetClassName,
			String sourceClassName);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc -->
	 * Generated by ModGraph: <!-- end-model-doc -->
	 * 
	 * @model attributeNameUnique="false" targetClassNameUnique="false"
	 *        sourceClassNameUnique="false" annotation=
	 *        "http://www.eclipse.org/emf/2002/GenModel body='try\n{\n\tboolean _notEquals = (!<%com.google.common.base.Objects%>.equal(attributeName, null));\n\tboolean _not = (!_notEquals);\n\tif (_not)\n\t{\n\t\tthrow new <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>();\n\t}\n\t<%org.eclipse.emf.ecore.EClass%> sourceClass = null;\n\t<%org.eclipse.emf.ecore.EClass%> targetClass = null;\n\t<%org.eclipse.emf.ecore.EAttribute%> attribute = null;\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass = this.getReferenceToEClass();\n\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n\t{\n\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t\t{\n\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, sourceClassName));\n\t\t}\n\t};\n\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EClass%>> _filter = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>filter(_referenceToEClass, _function);\n\tfor (final <%org.eclipse.emf.ecore.EClass%> _sourceClass : _filter)\n\t{\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass_1 = this.getReferenceToEClass();\n\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n\t\t{\n\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t\t\t{\n\t\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, targetClassName));\n\t\t\t}\n\t\t};\n\t\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EClass%>> _filter_1 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>filter(_referenceToEClass_1, _function_1);\n\t\tfor (final <%org.eclipse.emf.ecore.EClass%> _targetClass : _filter_1)\n\t\t{\n\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EAttribute%>> _referenceToEAttribute = this.getReferenceToEAttribute();\n\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EAttribute%>, <%java.lang.Boolean%>> _function_2 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EAttribute%>, <%java.lang.Boolean%>>()\n\t\t\t{\n\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EAttribute%> e)\n\t\t\t\t{\n\t\t\t\t\tboolean _and = false;\n\t\t\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\t\t\tboolean _equals = <%com.google.common.base.Objects%>.equal(_name, attributeName);\n\t\t\t\t\tif (!_equals)\n\t\t\t\t\t{\n\t\t\t\t\t\t_and = false;\n\t\t\t\t\t} else\n\t\t\t\t\t{\n\t\t\t\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EAttribute%>> _eAttributes = _sourceClass.getEAttributes();\n\t\t\t\t\t\tboolean _contains = _eAttributes.contains(e);\n\t\t\t\t\t\t_and = _contains;\n\t\t\t\t\t}\n\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t\t\t\t}\n\t\t\t};\n\t\t\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EAttribute%>> _filter_2 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EAttribute%>>filter(_referenceToEAttribute, _function_2);\n\t\t\tfor (final <%org.eclipse.emf.ecore.EAttribute%> _attribute : _filter_2)\n\t\t\t{\n\t\t\t\t{\n\t\t\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EAttribute%>> _eAttributes = _targetClass.getEAttributes();\n\t\t\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EAttribute%>, <%java.lang.Boolean%>> _function_3 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EAttribute%>, <%java.lang.Boolean%>>()\n\t\t\t\t\t{\n\t\t\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EAttribute%> e)\n\t\t\t\t\t\t{\n\t\t\t\t\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, attributeName));\n\t\t\t\t\t\t}\n\t\t\t\t\t};\n\t\t\t\t\t<%org.eclipse.emf.ecore.EAttribute%> _findFirst = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EAttribute%>>findFirst(_eAttributes, _function_3);\n\t\t\t\t\tboolean _notEquals_1 = (!<%com.google.common.base.Objects%>.equal(_findFirst, null));\n\t\t\t\t\tboolean _not_1 = (!_notEquals_1);\n\t\t\t\t\tif (_not_1)\n\t\t\t\t\t{\n\t\t\t\t\t\tsourceClass = _sourceClass;\n\t\t\t\t\t}\n\t\t\t\t\ttargetClass = _targetClass;\n\t\t\t\t\tattribute = _attribute;\n\t\t\t\t}\n\t\t\t}\n\t\t}\n\t}\n\tboolean _equals = <%com.google.common.base.Objects%>.equal(sourceClass, null);\n\tif (_equals)\n\t{\n\t\tthrow new <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>();\n\t}\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = sourceClass.getEStructuralFeatures();\n\t_eStructuralFeatures.remove(attribute);\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures_1 = targetClass.getEStructuralFeatures();\n\t_eStructuralFeatures_1.add(attribute);\n}\ncatch (Throwable _e)\n{\n\tthrow org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);\n}'"
	 * @generated
	 */
	void moveEAttribute(String attributeName, String targetClassName,
			String sourceClassName);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc -->
	 * Generated by ModGraph: <!-- end-model-doc -->
	 * 
	 * @model sourceClassNameUnique="false" targetClassNameUnique="false"
	 *        annotation=
	 *        "http://www.eclipse.org/emf/2002/GenModel body='<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass = this.getReferenceToEClass();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t{\n\t\t<%java.lang.String%> _name = e.getName();\n\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, targetClassName));\n\t}\n};\nfinal <%org.eclipse.emf.ecore.EClass%> existingClass = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>findFirst(_referenceToEClass, _function);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass_1 = this.getReferenceToEClass();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t{\n\t\t<%java.lang.String%> _name = e.getName();\n\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, sourceClassName));\n\t}\n};\nfinal <%org.eclipse.emf.ecore.EClass%> delitionClass = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>findFirst(_referenceToEClass_1, _function_1);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _referenceToEReference = this.getReferenceToEReference();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>> _function_2 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EReference%> e)\n\t{\n\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType = e.getEType();\n\t\treturn <%java.lang.Boolean%>.valueOf(_eType.equals(delitionClass));\n\t}\n};\n<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EReference%>> _filter = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>filter(_referenceToEReference, _function_2);\nfinal <%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> references = <%org.eclipse.emf.common.util.ECollections%>.<<%org.eclipse.emf.ecore.EReference%>>asEList(((<%org.eclipse.emf.ecore.EReference%>[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter, <%org.eclipse.emf.ecore.EReference%>.class)));\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _referenceToEReference_1 = this.getReferenceToEReference();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>> _function_3 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EReference%> e)\n\t{\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = delitionClass.getEStructuralFeatures();\n\t\treturn <%java.lang.Boolean%>.valueOf(_eStructuralFeatures.contains(e));\n\t}\n};\n<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EReference%>> _filter_1 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>filter(_referenceToEReference_1, _function_3);\nfinal <%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> containedReferences = <%org.eclipse.emf.common.util.ECollections%>.<<%org.eclipse.emf.ecore.EReference%>>asEList(((<%org.eclipse.emf.ecore.EReference%>[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter_1, <%org.eclipse.emf.ecore.EReference%>.class)));\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _referenceToEOperation = this.getReferenceToEOperation();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EOperation%>, <%java.lang.Boolean%>> _function_4 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EOperation%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EOperation%> e)\n\t{\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations = delitionClass.getEOperations();\n\t\treturn <%java.lang.Boolean%>.valueOf(_eOperations.contains(e));\n\t}\n};\n<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EOperation%>> _filter_2 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EOperation%>>filter(_referenceToEOperation, _function_4);\nfinal <%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> eOperations = <%org.eclipse.emf.common.util.ECollections%>.<<%org.eclipse.emf.ecore.EOperation%>>asEList(((<%org.eclipse.emf.ecore.EOperation%>[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter_2, <%org.eclipse.emf.ecore.EOperation%>.class)));\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EAttribute%>> _referenceToEAttribute = this.getReferenceToEAttribute();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EAttribute%>, <%java.lang.Boolean%>> _function_5 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EAttribute%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EAttribute%> e)\n\t{\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = delitionClass.getEStructuralFeatures();\n\t\treturn <%java.lang.Boolean%>.valueOf(_eStructuralFeatures.contains(e));\n\t}\n};\n<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EAttribute%>> _filter_3 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EAttribute%>>filter(_referenceToEAttribute, _function_5);\nfinal <%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EAttribute%>> attributes = <%org.eclipse.emf.common.util.ECollections%>.<<%org.eclipse.emf.ecore.EAttribute%>>asEList(((<%org.eclipse.emf.ecore.EAttribute%>[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter_3, <%org.eclipse.emf.ecore.EAttribute%>.class)));\n<%org.eclipse.emf.ecore.util.EcoreUtil%>.remove(delitionClass);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations = existingClass.getEOperations();\n_eOperations.addAll(eOperations);\nfinal <%org.eclipse.xtext.xbase.lib.Procedures.Procedure1%><<%org.eclipse.emf.ecore.EReference%>> _function_6 = new <%org.eclipse.xtext.xbase.lib.Procedures.Procedure1%><<%org.eclipse.emf.ecore.EReference%>>()\n{\n\tpublic void apply(final <%org.eclipse.emf.ecore.EReference%> e)\n\t{\n\t\te.setEType(existingClass);\n\t}\n};\n<%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>forEach(references, _function_6);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = existingClass.getEStructuralFeatures();\n_eStructuralFeatures.addAll(attributes);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures_1 = existingClass.getEStructuralFeatures();\n_eStructuralFeatures_1.addAll(containedReferences);'"
	 * @generated
	 */
	void inlineEClass(String sourceClassName, String targetClassName);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --><!--
	 * 
	 * @model existingClassUnique="false" existingClassNewNameUnique="false"
	 *        newClassNameUnique="false" newReferenceNameUnique="false"
	 *        structuralFeaturesToMoveUnique="false"
	 *        structuralFeaturesToMoveMany="true" operationsToMoveUnique="false"
	 *        operationsToMoveMany="true"
	 * @generated NOT modified by ModGraph
	 */
	EClass extractEClassNEW(EClass existingClass, String existingClassNewName,
			String newClassName, String newReferenceName,
			EList<EStructuralFeature> structuralFeaturesToMove,
			EList<EOperation> operationsToMove) throws GTFailure;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --><!--
	 * 
	 * @model existingClassUnique="false" newClassNameUnique="false"
	 *        newReferenceNameUnique="false"
	 *        structuralFeaturesToMoveUnique="false"
	 *        structuralFeaturesToMoveMany="true" operationsToMoveUnique="false"
	 *        operationsToMoveMany="true"
	 * @generated NOT modified by ModGraph
	 */
	void extractEClassNEW(EClass existingClass, String newClassName,
			String newReferenceName,
			EList<EStructuralFeature> structuralFeaturesToMove,
			EList<EOperation> operationsToMove) throws GTFailure;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc -->
	 * Generated by ModGraph: <!-- end-model-doc -->
	 * 
	 * @model existingClassNameUnique="false" attributeNamesMany="true"
	 *        referenceNamesMany="true" operationNamesMany="true"
	 *        classNameUnique="false" annotation=
	 *        "http://www.eclipse.org/emf/2002/GenModel body='try\n{\n\t<%org.eclipse.emf.ecore.EClass%> existingClass = null;\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> eOperations = null;\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> references = null;\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EAttribute%>> attributes = null;\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> containedReferences = null;\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass = this.getReferenceToEClass();\n\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n\t{\n\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t\t{\n\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, existingClassName));\n\t\t}\n\t};\n\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EClass%>> _filter = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>filter(_referenceToEClass, _function);\n\tfor (final <%org.eclipse.emf.ecore.EClass%> _existingClass : _filter)\n\t{\n\t\t{\n\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _referenceToEReference = this.getReferenceToEReference();\n\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>>()\n\t\t\t{\n\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EReference%> e)\n\t\t\t\t{\n\t\t\t\t\tboolean _and = false;\n\t\t\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType = e.getEType();\n\t\t\t\t\tboolean _equals = _eType.equals(_existingClass);\n\t\t\t\t\tif (!_equals)\n\t\t\t\t\t{\n\t\t\t\t\t\t_and = false;\n\t\t\t\t\t} else\n\t\t\t\t\t{\n\t\t\t\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\t\t\t\tboolean _contains = referenceNames.contains(_name);\n\t\t\t\t\t\t_and = _contains;\n\t\t\t\t\t}\n\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t\t\t\t}\n\t\t\t};\n\t\t\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EReference%>> _filter_1 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>filter(_referenceToEReference, _function_1);\n\t\t\tfinal <%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _references = <%org.eclipse.emf.common.util.ECollections%>.<<%org.eclipse.emf.ecore.EReference%>>asEList(((<%org.eclipse.emf.ecore.EReference%>[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter_1, <%org.eclipse.emf.ecore.EReference%>.class)));\n\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _referenceToEReference_1 = this.getReferenceToEReference();\n\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>> _function_2 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>>()\n\t\t\t{\n\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EReference%> e)\n\t\t\t\t{\n\t\t\t\t\tboolean _and = false;\n\t\t\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = _existingClass.getEStructuralFeatures();\n\t\t\t\t\tboolean _contains = _eStructuralFeatures.contains(e);\n\t\t\t\t\tif (!_contains)\n\t\t\t\t\t{\n\t\t\t\t\t\t_and = false;\n\t\t\t\t\t} else\n\t\t\t\t\t{\n\t\t\t\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\t\t\t\tboolean _contains_1 = referenceNames.contains(_name);\n\t\t\t\t\t\t_and = _contains_1;\n\t\t\t\t\t}\n\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t\t\t\t}\n\t\t\t};\n\t\t\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EReference%>> _filter_2 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>filter(_referenceToEReference_1, _function_2);\n\t\t\tfinal <%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _containedReferences = <%org.eclipse.emf.common.util.ECollections%>.<<%org.eclipse.emf.ecore.EReference%>>asEList(((<%org.eclipse.emf.ecore.EReference%>[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter_2, <%org.eclipse.emf.ecore.EReference%>.class)));\n\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _referenceToEOperation = this.getReferenceToEOperation();\n\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EOperation%>, <%java.lang.Boolean%>> _function_3 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EOperation%>, <%java.lang.Boolean%>>()\n\t\t\t{\n\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EOperation%> e)\n\t\t\t\t{\n\t\t\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations = _existingClass.getEOperations();\n\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf(_eOperations.contains(e));\n\t\t\t\t}\n\t\t\t};\n\t\t\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EOperation%>> _filter_3 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EOperation%>>filter(_referenceToEOperation, _function_3);\n\t\t\tfinal <%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations = <%org.eclipse.emf.common.util.ECollections%>.<<%org.eclipse.emf.ecore.EOperation%>>asEList(((<%org.eclipse.emf.ecore.EOperation%>[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter_3, <%org.eclipse.emf.ecore.EOperation%>.class)));\n\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EAttribute%>> _referenceToEAttribute = this.getReferenceToEAttribute();\n\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EAttribute%>, <%java.lang.Boolean%>> _function_4 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EAttribute%>, <%java.lang.Boolean%>>()\n\t\t\t{\n\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EAttribute%> e)\n\t\t\t\t{\n\t\t\t\t\tboolean _and = false;\n\t\t\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = _existingClass.getEStructuralFeatures();\n\t\t\t\t\tboolean _contains = _eStructuralFeatures.contains(e);\n\t\t\t\t\tif (!_contains)\n\t\t\t\t\t{\n\t\t\t\t\t\t_and = false;\n\t\t\t\t\t} else\n\t\t\t\t\t{\n\t\t\t\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\t\t\t\tboolean _contains_1 = attributeNames.contains(_name);\n\t\t\t\t\t\t_and = _contains_1;\n\t\t\t\t\t}\n\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t\t\t\t}\n\t\t\t};\n\t\t\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EAttribute%>> _filter_4 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EAttribute%>>filter(_referenceToEAttribute, _function_4);\n\t\t\tfinal <%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EAttribute%>> _attributes = <%org.eclipse.emf.common.util.ECollections%>.<<%org.eclipse.emf.ecore.EAttribute%>>asEList(((<%org.eclipse.emf.ecore.EAttribute%>[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter_4, <%org.eclipse.emf.ecore.EAttribute%>.class)));\n\t\t\texistingClass = _existingClass;\n\t\t\teOperations = _eOperations;\n\t\t\treferences = _references;\n\t\t\tattributes = _attributes;\n\t\t\tcontainedReferences = _containedReferences;\n\t\t}\n\t}\n\tboolean _equals = <%com.google.common.base.Objects%>.equal(existingClass, null);\n\tif (_equals)\n\t{\n\t\tthrow new <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>();\n\t}\n\tfinal <%java.lang.String%> extractedClassNameValue = className;\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations = existingClass.getEOperations();\n\t_eOperations.removeAll(eOperations);\n\tfinal <%org.eclipse.xtext.xbase.lib.Procedures.Procedure1%><<%org.eclipse.emf.ecore.EReference%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Procedures.Procedure1%><<%org.eclipse.emf.ecore.EReference%>>()\n\t{\n\t\tpublic void apply(final <%org.eclipse.emf.ecore.EReference%> node)\n\t\t{\n\t\t\tnode.setEType(null);\n\t\t}\n\t};\n\t<%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>forEach(references, _function_1);\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = existingClass.getEStructuralFeatures();\n\t_eStructuralFeatures.removeAll(attributes);\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures_1 = existingClass.getEStructuralFeatures();\n\t_eStructuralFeatures_1.removeAll(containedReferences);\n\t<%org.eclipse.emf.ecore.EClass%> extractedClass = <%org.eclipse.emf.ecore.EcoreFactory%>.eINSTANCE.createEClass();\n\textractedClass.setName(extractedClassNameValue);\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass_1 = this.getReferenceToEClass();\n\t_referenceToEClass_1.add(extractedClass);\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations_1 = extractedClass.getEOperations();\n\t_eOperations_1.addAll(eOperations);\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures_2 = extractedClass.getEStructuralFeatures();\n\t_eStructuralFeatures_2.addAll(attributes);\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures_3 = extractedClass.getEStructuralFeatures();\n\t_eStructuralFeatures_3.addAll(containedReferences);\n}\ncatch (Throwable _e)\n{\n\tthrow org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);\n}'"
	 * @generated
	 */
	void extractEClass(String existingClassName, EList<String> attributeNames,
			EList<String> referenceNames, EList<String> operationNames,
			String className);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model sourceClUnique="false" attributesMany="true" operationsMany="true" classNameUnique="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='final <%org.eclipse.emf.ecore.EClass%> newClass = <%org.eclipse.emf.ecore.EcoreFactory%>.eINSTANCE.createEClass();\n<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper = this.getHelper();\n<%org.eclipse.emf.ecore.EClass%> sourceClass = _helper.getClass(sourceCl);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass = this.getReferenceToEClass();\n_referenceToEClass.add(newClass);\nnewClass.setName(className);\nboolean _isEmpty = attributes.isEmpty();\nboolean _not = (!_isEmpty);\nif (_not)\n{\n\tfor (final <%java.lang.String%> s : attributes)\n\t{\n\t\ttry\n\t\t{\n\t\t\t<%java.lang.String%> _name = newClass.getName();\n\t\t\t<%java.lang.String%> _name_1 = sourceClass.getName();\n\t\t\tthis.moveEAttribute(s, _name, _name_1);\n\t\t}\n\t\tcatch (final Throwable _t) {\n\t\t\tif (_t instanceof <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>) {\n\t\t\t\tfinal <%de.ubt.ai1.modgraph.gt.failure.GTFailure%> f = (<%de.ubt.ai1.modgraph.gt.failure.GTFailure%>)_t;\n\t\t\t}\n\t\t\telse\n\t\t\t{\n\t\t\t\tthrow <%org.eclipse.xtext.xbase.lib.Exceptions%>.sneakyThrow(_t);\n\t\t\t}\n\t\t}\n\t}\n}\nboolean _isEmpty_1 = operations.isEmpty();\nboolean _not_1 = (!_isEmpty_1);\nif (_not_1)\n{\n\tfor (final <%java.lang.String%> s2 : operations)\n\t{\n\t\ttry\n\t\t{\n\t\t\t<%java.lang.String%> _name_2 = newClass.getName();\n\t\t\t<%java.lang.String%> _name_3 = sourceClass.getName();\n\t\t\tthis.moveEOperation(s2, _name_2, _name_3);\n\t\t}\n\t\tcatch (final Throwable _t_1) {\n\t\t\tif (_t_1 instanceof <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>) {\n\t\t\t\tfinal <%de.ubt.ai1.modgraph.gt.failure.GTFailure%> f_1 = (<%de.ubt.ai1.modgraph.gt.failure.GTFailure%>)_t_1;\n\t\t\t}\n\t\t\telse\n\t\t\t{\n\t\t\t\tthrow <%org.eclipse.xtext.xbase.lib.Exceptions%>.sneakyThrow(_t_1);\n\t\t\t}\n\t\t}\n\t}\n}\nfinal <%org.eclipse.emf.ecore.EReference%> newRef = <%org.eclipse.emf.ecore.EcoreFactory%>.eINSTANCE.createEReference();\n<%java.lang.String%> _name_4 = newClass.getName();\nnewRef.setName(_name_4);\nnewRef.setEType(newClass);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = sourceClass.getEStructuralFeatures();\n_eStructuralFeatures.add(newRef);\n<%org.eclipse.emf.ecore.EPackage%> _ePackage = sourceClass.getEPackage();\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClassifier%>> _eClassifiers = _ePackage.getEClassifiers();\n_eClassifiers.add(newClass);'"
	 * @generated
	 */
	void extractEClass2(String sourceCl, EList<String> attributes,
			EList<String> operations, String className);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model attributeToPullUpUnique="false" superClUnique="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper = this.getHelper();\n<%org.eclipse.emf.ecore.EClass%> superClass = _helper.getClass(superCl);\n<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper_1 = this.getHelper();\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> subClasses = _helper_1.getAllSubClasses(superClass);\n<%org.eclipse.emf.ecore.EClass%> sourceClass = subClasses.get(0);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = superClass.getEStructuralFeatures();\n<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper_2 = this.getHelper();\n<%org.eclipse.emf.ecore.EAttribute%> _attributeByName = _helper_2.getAttributeByName(sourceClass, attributeToPullUp);\n_eStructuralFeatures.add(_attributeByName);\nfor (final <%org.eclipse.emf.ecore.EClass%> c : subClasses)\n{\n\t<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper_3 = this.getHelper();\n\t_helper_3.removeAttributeByName(c, attributeToPullUp);\n}'"
	 * @generated
	 */
	void pullUpEAttribute(String attributeToPullUp, String superCl);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model attributeToPushDownUnique="false" superClUnique="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='final <%org.eclipse.emf.ecore.util.EcoreUtil.Copier%> copier = new <%org.eclipse.emf.ecore.util.EcoreUtil.Copier%>();\n<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper = this.getHelper();\n<%org.eclipse.emf.ecore.EClass%> superClass = _helper.getClass(superCl);\n<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper_1 = this.getHelper();\nfinal <%org.eclipse.emf.ecore.EAttribute%> b = _helper_1.getAttributeByName(superClass, attributeToPushDown);\nfinal <%org.eclipse.emf.ecore.EClassifier%> EType = b.getEType();\nfinal int lBound = b.getLowerBound();\nfinal int uBound = b.getUpperBound();\n<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper_2 = this.getHelper();\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _allSubClasses = _helper_2.getAllSubClasses(superClass);\nfor (final <%org.eclipse.emf.ecore.EClass%> c : _allSubClasses)\n{\n\t{\n\t\t<%org.eclipse.emf.ecore.EObject%> _copy = copier.copy(b);\n\t\t<%org.eclipse.emf.ecore.EAttribute%> a = ((<%org.eclipse.emf.ecore.EAttribute%>) _copy);\n\t\ta.setEType(EType);\n\t\ta.setLowerBound(lBound);\n\t\ta.setUpperBound(uBound);\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = c.getEStructuralFeatures();\n\t\t_eStructuralFeatures.add(a);\n\t}\n}\n<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper_3 = this.getHelper();\n_helper_3.removeAttributeByName(superClass, attributeToPushDown);'"
	 * @generated
	 */
	void pushDownEAttribute(String attributeToPushDown, String superCl);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model operationToPullUpUnique="false" superClUnique="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper = this.getHelper();\n<%org.eclipse.emf.ecore.EClass%> superClass = _helper.getClass(superCl);\n<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper_1 = this.getHelper();\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> subClasses = _helper_1.getAllSubClasses(superClass);\n<%org.eclipse.emf.ecore.EClass%> sourceClass = subClasses.get(0);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations = superClass.getEOperations();\n<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper_2 = this.getHelper();\n<%org.eclipse.emf.ecore.EOperation%> _operationByName = _helper_2.getOperationByName(sourceClass, operationToPullUp);\n_eOperations.add(_operationByName);\nfor (final <%org.eclipse.emf.ecore.EClass%> c : subClasses)\n{\n\t<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper_3 = this.getHelper();\n\t_helper_3.removeOperationByName(c, operationToPullUp);\n}'"
	 * @generated
	 */
	void pullUpEOperation(String operationToPullUp, String superCl);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model operationToPushDownUnique="false" superClUnique="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='final <%org.eclipse.emf.ecore.util.EcoreUtil.Copier%> copier = new <%org.eclipse.emf.ecore.util.EcoreUtil.Copier%>();\n<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper = this.getHelper();\n<%org.eclipse.emf.ecore.EClass%> superClass = _helper.getClass(superCl);\n<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper_1 = this.getHelper();\nfinal <%org.eclipse.emf.ecore.EOperation%> b = _helper_1.getOperationByName(superClass, operationToPushDown);\nfinal <%org.eclipse.emf.ecore.EClassifier%> EType = b.getEType();\nfinal int lBound = b.getLowerBound();\nfinal int uBound = b.getUpperBound();\n<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper_2 = this.getHelper();\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _allSubClasses = _helper_2.getAllSubClasses(superClass);\nfor (final <%org.eclipse.emf.ecore.EClass%> c : _allSubClasses)\n{\n\t{\n\t\t<%org.eclipse.emf.ecore.EObject%> _copy = copier.copy(b);\n\t\t<%org.eclipse.emf.ecore.EOperation%> a = ((<%org.eclipse.emf.ecore.EOperation%>) _copy);\n\t\ta.setEType(EType);\n\t\ta.setLowerBound(lBound);\n\t\ta.setUpperBound(uBound);\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations = c.getEOperations();\n\t\t_eOperations.add(a);\n\t}\n}\n<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper_3 = this.getHelper();\n_helper_3.removeOperationByName(superClass, operationToPushDown);'"
	 * @generated
	 */
	void pushDownEOperation(String operationToPushDown, String superCl);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model classesUnique="false" classesMany="true" nameUnique="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='<%java.util.List%><<%org.eclipse.emf.ecore.EOperation%>> sharedOperations = new <%java.util.LinkedList%><<%org.eclipse.emf.ecore.EOperation%>>();\n<%java.util.List%><<%org.eclipse.emf.ecore.EAttribute%>> sharedAttributes = new <%java.util.LinkedList%><<%org.eclipse.emf.ecore.EAttribute%>>();\n<%java.util.List%><<%org.eclipse.emf.ecore.EReference%>> sharedReferences = new <%java.util.LinkedList%><<%org.eclipse.emf.ecore.EReference%>>();\n<%org.eclipse.emf.ecore.EClass%> _get = classes.get(0);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EAttribute%>> _eAttributes = _get.getEAttributes();\nsharedAttributes.addAll(_eAttributes);\n<%org.eclipse.emf.ecore.EClass%> _get_1 = classes.get(0);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations = _get_1.getEOperations();\nsharedOperations.addAll(_eOperations);\n<%org.eclipse.emf.ecore.EClass%> _get_2 = classes.get(0);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _eReferences = _get_2.getEReferences();\nsharedReferences.addAll(_eReferences);\nfor (final <%org.eclipse.emf.ecore.EClass%> c : classes)\n{\n\t{\n\t\t<%org.eclipse.emf.ecore.EClass%> _get_3 = classes.get(0);\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EAttribute%>> _eAttributes_1 = _get_3.getEAttributes();\n\t\tfor (final <%org.eclipse.emf.ecore.EAttribute%> a : _eAttributes_1)\n\t\t{\n\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EAttribute%>> _eAttributes_2 = c.getEAttributes();\n\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EAttribute%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EAttribute%>, <%java.lang.Boolean%>>()\n\t\t\t{\n\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EAttribute%> ca)\n\t\t\t\t{\n\t\t\t\t\tboolean _and = false;\n\t\t\t\t\t<%java.lang.String%> _name = ca.getName();\n\t\t\t\t\t<%java.lang.String%> _name_1 = a.getName();\n\t\t\t\t\tboolean _equals = <%com.google.common.base.Objects%>.equal(_name, _name_1);\n\t\t\t\t\tif (!_equals)\n\t\t\t\t\t{\n\t\t\t\t\t\t_and = false;\n\t\t\t\t\t} else\n\t\t\t\t\t{\n\t\t\t\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType = ca.getEType();\n\t\t\t\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType_1 = a.getEType();\n\t\t\t\t\t\tboolean _equals_1 = <%com.google.common.base.Objects%>.equal(_eType, _eType_1);\n\t\t\t\t\t\t_and = _equals_1;\n\t\t\t\t\t}\n\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t\t\t\t}\n\t\t\t};\n\t\t\t<%org.eclipse.emf.ecore.EAttribute%> _findFirst = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EAttribute%>>findFirst(_eAttributes_2, _function);\n\t\t\tboolean _equals = <%com.google.common.base.Objects%>.equal(_findFirst, null);\n\t\t\tif (_equals)\n\t\t\t{\n\t\t\t\tsharedAttributes.remove(a);\n\t\t\t}\n\t\t}\n\t\t<%org.eclipse.emf.ecore.EClass%> _get_4 = classes.get(0);\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations_1 = _get_4.getEOperations();\n\t\tfor (final <%org.eclipse.emf.ecore.EOperation%> o : _eOperations_1)\n\t\t{\n\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations_2 = c.getEOperations();\n\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EOperation%>, <%java.lang.Boolean%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EOperation%>, <%java.lang.Boolean%>>()\n\t\t\t{\n\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EOperation%> co)\n\t\t\t\t{\n\t\t\t\t\tboolean _and = false;\n\t\t\t\t\t<%java.lang.String%> _name = co.getName();\n\t\t\t\t\t<%java.lang.String%> _name_1 = o.getName();\n\t\t\t\t\tboolean _equals = <%com.google.common.base.Objects%>.equal(_name, _name_1);\n\t\t\t\t\tif (!_equals)\n\t\t\t\t\t{\n\t\t\t\t\t\t_and = false;\n\t\t\t\t\t} else\n\t\t\t\t\t{\n\t\t\t\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType = co.getEType();\n\t\t\t\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType_1 = o.getEType();\n\t\t\t\t\t\tboolean _equals_1 = <%com.google.common.base.Objects%>.equal(_eType, _eType_1);\n\t\t\t\t\t\t_and = _equals_1;\n\t\t\t\t\t}\n\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t\t\t\t}\n\t\t\t};\n\t\t\t<%org.eclipse.emf.ecore.EOperation%> _findFirst_1 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EOperation%>>findFirst(_eOperations_2, _function_1);\n\t\t\tboolean _equals_1 = <%com.google.common.base.Objects%>.equal(_findFirst_1, null);\n\t\t\tif (_equals_1)\n\t\t\t{\n\t\t\t\tsharedOperations.remove(o);\n\t\t\t}\n\t\t\telse\n\t\t\t{\n\t\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations_3 = c.getEOperations();\n\t\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EOperation%>, <%java.lang.Boolean%>> _function_2 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EOperation%>, <%java.lang.Boolean%>>()\n\t\t\t\t{\n\t\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EOperation%> co)\n\t\t\t\t\t{\n\t\t\t\t\t\tboolean _and = false;\n\t\t\t\t\t\t<%java.lang.String%> _name = co.getName();\n\t\t\t\t\t\t<%java.lang.String%> _name_1 = o.getName();\n\t\t\t\t\t\tboolean _equals = <%com.google.common.base.Objects%>.equal(_name, _name_1);\n\t\t\t\t\t\tif (!_equals)\n\t\t\t\t\t\t{\n\t\t\t\t\t\t\t_and = false;\n\t\t\t\t\t\t} else\n\t\t\t\t\t\t{\n\t\t\t\t\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType = co.getEType();\n\t\t\t\t\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType_1 = o.getEType();\n\t\t\t\t\t\t\tboolean _equals_1 = <%com.google.common.base.Objects%>.equal(_eType, _eType_1);\n\t\t\t\t\t\t\t_and = _equals_1;\n\t\t\t\t\t\t}\n\t\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t\t\t\t\t}\n\t\t\t\t};\n\t\t\t\t<%org.eclipse.emf.ecore.EOperation%> _findFirst_2 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EOperation%>>findFirst(_eOperations_3, _function_2);\n\t\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EParameter%>> _eParameters = _findFirst_2.getEParameters();\n\t\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EParameter%>, <%java.lang.Boolean%>> _function_3 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EParameter%>, <%java.lang.Boolean%>>()\n\t\t\t\t{\n\t\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EParameter%> p)\n\t\t\t\t\t{\n\t\t\t\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EParameter%>> _eParameters = o.getEParameters();\n\t\t\t\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EParameter%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EParameter%>, <%java.lang.Boolean%>>()\n\t\t\t\t\t\t{\n\t\t\t\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EParameter%> sp)\n\t\t\t\t\t\t\t{\n\t\t\t\t\t\t\t\tboolean _and = false;\n\t\t\t\t\t\t\t\t<%java.lang.String%> _name = sp.getName();\n\t\t\t\t\t\t\t\t<%java.lang.String%> _name_1 = p.getName();\n\t\t\t\t\t\t\t\tboolean _equals = <%com.google.common.base.Objects%>.equal(_name, _name_1);\n\t\t\t\t\t\t\t\tif (!_equals)\n\t\t\t\t\t\t\t\t{\n\t\t\t\t\t\t\t\t\t_and = false;\n\t\t\t\t\t\t\t\t} else\n\t\t\t\t\t\t\t\t{\n\t\t\t\t\t\t\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType = sp.getEType();\n\t\t\t\t\t\t\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType_1 = p.getEType();\n\t\t\t\t\t\t\t\t\tboolean _equals_1 = <%com.google.common.base.Objects%>.equal(_eType, _eType_1);\n\t\t\t\t\t\t\t\t\t_and = _equals_1;\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t};\n\t\t\t\t\t\t<%org.eclipse.emf.ecore.EParameter%> _findFirst = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EParameter%>>findFirst(_eParameters, _function);\n\t\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf((!<%com.google.common.base.Objects%>.equal(_findFirst, null)));\n\t\t\t\t\t}\n\t\t\t\t};\n\t\t\t\tboolean _forall = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EParameter%>>forall(_eParameters, _function_3);\n\t\t\t\tboolean _equals_2 = (_forall == false);\n\t\t\t\tif (_equals_2)\n\t\t\t\t{\n\t\t\t\t\tsharedOperations.remove(o);\n\t\t\t\t}\n\t\t\t}\n\t\t}\n\t\t<%org.eclipse.emf.ecore.EClass%> _get_5 = classes.get(0);\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _eReferences_1 = _get_5.getEReferences();\n\t\tfor (final <%org.eclipse.emf.ecore.EReference%> r : _eReferences_1)\n\t\t{\n\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _eReferences_2 = c.getEReferences();\n\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>> _function_4 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>>()\n\t\t\t{\n\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EReference%> cr)\n\t\t\t\t{\n\t\t\t\t\tboolean _and = false;\n\t\t\t\t\t<%java.lang.String%> _name = cr.getName();\n\t\t\t\t\tboolean _equals = <%com.google.common.base.Objects%>.equal(_name, name);\n\t\t\t\t\tif (!_equals)\n\t\t\t\t\t{\n\t\t\t\t\t\t_and = false;\n\t\t\t\t\t} else\n\t\t\t\t\t{\n\t\t\t\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType = cr.getEType();\n\t\t\t\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType_1 = r.getEType();\n\t\t\t\t\t\tboolean _equals_1 = <%com.google.common.base.Objects%>.equal(_eType, _eType_1);\n\t\t\t\t\t\t_and = _equals_1;\n\t\t\t\t\t}\n\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t\t\t\t}\n\t\t\t};\n\t\t\t<%org.eclipse.emf.ecore.EReference%> _findFirst_3 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>findFirst(_eReferences_2, _function_4);\n\t\t\tboolean _equals_3 = <%com.google.common.base.Objects%>.equal(_findFirst_3, null);\n\t\t\tif (_equals_3)\n\t\t\t{\n\t\t\t\tsharedReferences.remove(r);\n\t\t\t}\n\t\t}\n\t}\n}\ntry\n{\n\t<%org.eclipse.emf.common.util.BasicEList%><<%org.eclipse.emf.ecore.EAttribute%>> _basicEList = new <%org.eclipse.emf.common.util.BasicEList%><<%org.eclipse.emf.ecore.EAttribute%>>(sharedAttributes);\n\t<%org.eclipse.emf.common.util.BasicEList%><<%org.eclipse.emf.ecore.EOperation%>> _basicEList_1 = new <%org.eclipse.emf.common.util.BasicEList%><<%org.eclipse.emf.ecore.EOperation%>>(sharedOperations);\n\t<%org.eclipse.emf.common.util.BasicEList%><<%org.eclipse.emf.ecore.EReference%>> _basicEList_2 = new <%org.eclipse.emf.common.util.BasicEList%><<%org.eclipse.emf.ecore.EReference%>>(sharedReferences);\n\t<%org.eclipse.emf.ecore.EClass%> newSuperClass = this.extractSuperClass(name, _basicEList, _basicEList_1, _basicEList_2, classes);\n\t<%org.eclipse.emf.ecore.EClass%> _get_3 = classes.get(0);\n\t<%org.eclipse.emf.ecore.EPackage%> _ePackage = _get_3.getEPackage();\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClassifier%>> _eClassifiers = _ePackage.getEClassifiers();\n\t_eClassifiers.add(newSuperClass);\n}\ncatch (final Throwable _t) {\n\tif (_t instanceof <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>) {\n\t\tfinal <%de.ubt.ai1.modgraph.gt.failure.GTFailure%> f = (<%de.ubt.ai1.modgraph.gt.failure.GTFailure%>)_t;\n\t}\n\telse\n\t{\n\t\tthrow <%org.eclipse.xtext.xbase.lib.Exceptions%>.sneakyThrow(_t);\n\t}\n}'"
	 * @generated
	 */
	void extractSuperClassInit(EList<EClass> classes, String name);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model unique="false" nameUnique="false" sharedAttributesUnique="false" sharedAttributesMany="true" sharedOperationsUnique="false" sharedOperationsMany="true" sharedReferencesUnique="false" sharedReferencesMany="true" classesUnique="false" classesMany="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='try\n{\n\t<%org.eclipse.emf.ecore.EClass%> _get = classes.get(0);\n\t<%org.eclipse.emf.ecore.EObject%> _eContainer = _get.eContainer();\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EObject%>> _eContents = _eContainer.eContents();\n\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClassifier%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClassifier%>, <%java.lang.Boolean%>>()\n\t{\n\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClassifier%> e)\n\t\t{\n\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, name));\n\t\t}\n\t};\n\t<%org.eclipse.emf.ecore.EClassifier%> _findFirst = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClassifier%>>findFirst(((<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EClassifier%>>)org.eclipse.xtext.xbase.lib.Conversions.doWrapArray(((<%org.eclipse.emf.ecore.EClassifier%>[]) ((<%org.eclipse.emf.ecore.EClassifier%>[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_eContents, <%org.eclipse.emf.ecore.EClassifier%>.class))))), _function);\n\tboolean _equals = <%com.google.common.base.Objects%>.equal(_findFirst, null);\n\tboolean _not = (!_equals);\n\tif (_not)\n\t{\n\t\tthrow new <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>();\n\t}\n\tfinal <%java.lang.String%> superClassNameValue = name;\n\tfinal <%org.eclipse.emf.ecore.EClass%> superClass = <%org.eclipse.emf.ecore.EcoreFactory%>.eINSTANCE.createEClass();\n\tsuperClass.setName(superClassNameValue);\n\tfinal <%org.eclipse.xtext.xbase.lib.Procedures.Procedure1%><<%org.eclipse.emf.ecore.EClass%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Procedures.Procedure1%><<%org.eclipse.emf.ecore.EClass%>>()\n\t{\n\t\tpublic void apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t\t{\n\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _eSuperTypes = e.getESuperTypes();\n\t\t\t_eSuperTypes.add(superClass);\n\t\t}\n\t};\n\t<%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>forEach(classes, _function_1);\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = superClass.getEStructuralFeatures();\n\t_eStructuralFeatures.addAll(sharedAttributes);\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations = superClass.getEOperations();\n\t_eOperations.addAll(sharedOperations);\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures_1 = superClass.getEStructuralFeatures();\n\t_eStructuralFeatures_1.addAll(sharedReferences);\n\treturn superClass;\n}\ncatch (Throwable _e)\n{\n\tthrow org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);\n}'"
	 * @generated
	 */
	EClass extractSuperClass(String name, EList<EAttribute> sharedAttributes,
			EList<EOperation> sharedOperations,
			EList<EReference> sharedReferences, EList<EClass> classes);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model classesUnique="false" classesMany="true" nameUnique="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='final <%org.eclipse.emf.ecore.util.EcoreUtil.Copier%> copier = new <%org.eclipse.emf.ecore.util.EcoreUtil.Copier%>();\nfinal <%org.eclipse.emf.ecore.EClass%> newSuperClass = <%org.eclipse.emf.ecore.EcoreFactory%>.eINSTANCE.createEClass();\nnewSuperClass.setName(name);\nnewSuperClass.setAbstract(true);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> sharedAttributes = newSuperClass.getEStructuralFeatures();\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> sharedOperations = newSuperClass.getEOperations();\n<%org.eclipse.emf.ecore.EClass%> _get = classes.get(0);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EAttribute%>> checkAttributes = _get.getEAttributes();\n<%org.eclipse.emf.ecore.EClass%> _get_1 = classes.get(0);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> checkOperations = _get_1.getEOperations();\nint count = 0;\nfor (final <%org.eclipse.emf.ecore.EAttribute%> a : checkAttributes)\n{\n\t{\n\t\tfor (final <%org.eclipse.emf.ecore.EClass%> c : classes)\n\t\t{\n\t\t\t{\n\t\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EAttribute%>> cAttributes = c.getEAttributes();\n\t\t\t\tfor (final <%org.eclipse.emf.ecore.EAttribute%> b : cAttributes)\n\t\t\t\t{\n\t\t\t\t\t<%java.lang.String%> _name = b.getName();\n\t\t\t\t\t<%java.lang.String%> _name_1 = a.getName();\n\t\t\t\t\tboolean _equals = <%com.google.common.base.Objects%>.equal(_name, _name_1);\n\t\t\t\t\tif (_equals)\n\t\t\t\t\t{\n\t\t\t\t\t\tcount = (count + 1);\n\t\t\t\t\t\tint _size = classes.size();\n\t\t\t\t\t\tboolean _equals_1 = (count == _size);\n\t\t\t\t\t\tif (_equals_1)\n\t\t\t\t\t\t{\n\t\t\t\t\t\t\t<%org.eclipse.emf.ecore.EObject%> _copy = copier.copy(a);\n\t\t\t\t\t\t\t<%org.eclipse.emf.ecore.EStructuralFeature%> attr = ((<%org.eclipse.emf.ecore.EStructuralFeature%>) _copy);\n\t\t\t\t\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType = a.getEType();\n\t\t\t\t\t\t\tattr.setEType(_eType);\n\t\t\t\t\t\t\tint _lowerBound = a.getLowerBound();\n\t\t\t\t\t\t\tattr.setLowerBound(_lowerBound);\n\t\t\t\t\t\t\tint _upperBound = a.getUpperBound();\n\t\t\t\t\t\t\tattr.setUpperBound(_upperBound);\n\t\t\t\t\t\t\tboolean _isChangeable = a.isChangeable();\n\t\t\t\t\t\t\tattr.setChangeable(_isChangeable);\n\t\t\t\t\t\t\tsharedAttributes.add(attr);\n\t\t\t\t\t\t\tcount = 0;\n\t\t\t\t\t\t}\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t}\n\t\t}\n\t\tcount = 0;\n\t}\n}\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = newSuperClass.getEStructuralFeatures();\n_eStructuralFeatures.addAll(sharedAttributes);\ncount = 0;\nfor (final <%org.eclipse.emf.ecore.EOperation%> a_1 : checkOperations)\n{\n\t{\n\t\tfor (final <%org.eclipse.emf.ecore.EClass%> c : classes)\n\t\t{\n\t\t\t{\n\t\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> cOperations = c.getEOperations();\n\t\t\t\tfor (final <%org.eclipse.emf.ecore.EOperation%> b : cOperations)\n\t\t\t\t{\n\t\t\t\t\t<%java.lang.String%> _name = b.getName();\n\t\t\t\t\t<%java.lang.String%> _name_1 = a_1.getName();\n\t\t\t\t\tboolean _equals = <%com.google.common.base.Objects%>.equal(_name, _name_1);\n\t\t\t\t\tif (_equals)\n\t\t\t\t\t{\n\t\t\t\t\t\tcount = (count + 1);\n\t\t\t\t\t\tint _size = classes.size();\n\t\t\t\t\t\tboolean _equals_1 = (count == _size);\n\t\t\t\t\t\tif (_equals_1)\n\t\t\t\t\t\t{\n\t\t\t\t\t\t\t<%org.eclipse.emf.ecore.EObject%> _copy = copier.copy(a_1);\n\t\t\t\t\t\t\t<%org.eclipse.emf.ecore.EOperation%> operation = ((<%org.eclipse.emf.ecore.EOperation%>) _copy);\n\t\t\t\t\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType = a_1.getEType();\n\t\t\t\t\t\t\toperation.setEType(_eType);\n\t\t\t\t\t\t\tint _lowerBound = a_1.getLowerBound();\n\t\t\t\t\t\t\toperation.setLowerBound(_lowerBound);\n\t\t\t\t\t\t\tint _upperBound = a_1.getUpperBound();\n\t\t\t\t\t\t\toperation.setUpperBound(_upperBound);\n\t\t\t\t\t\t\tboolean _isOrdered = a_1.isOrdered();\n\t\t\t\t\t\t\toperation.setOrdered(_isOrdered);\n\t\t\t\t\t\t\tsharedOperations.add(operation);\n\t\t\t\t\t\t\tcount = 0;\n\t\t\t\t\t\t}\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t}\n\t\t}\n\t\tcount = 0;\n\t}\n}\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations = newSuperClass.getEOperations();\n_eOperations.addAll(sharedOperations);\nfor (final <%org.eclipse.emf.ecore.EClass%> c : classes)\n{\n\t{\n\t\tboolean _isEmpty = sharedAttributes.isEmpty();\n\t\tboolean _not = (!_isEmpty);\n\t\tif (_not)\n\t\t{\n\t\t\tfor (final <%org.eclipse.emf.ecore.EStructuralFeature%> a_2 : sharedAttributes)\n\t\t\t{\n\t\t\t\t<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper = this.getHelper();\n\t\t\t\t<%java.lang.String%> _name = a_2.getName();\n\t\t\t\t_helper.removeAttributeByName(c, _name);\n\t\t\t}\n\t\t}\n\t\tboolean _isEmpty_1 = sharedOperations.isEmpty();\n\t\tboolean _not_1 = (!_isEmpty_1);\n\t\tif (_not_1)\n\t\t{\n\t\t\tfor (final <%org.eclipse.emf.ecore.EOperation%> o : sharedOperations)\n\t\t\t{\n\t\t\t\t<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper_1 = this.getHelper();\n\t\t\t\t<%java.lang.String%> _name_1 = o.getName();\n\t\t\t\t_helper_1.removeOperationByName(c, _name_1);\n\t\t\t}\n\t\t}\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _eSuperTypes = c.getESuperTypes();\n\t\t_eSuperTypes.add(newSuperClass);\n\t}\n}\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass = this.getReferenceToEClass();\n_referenceToEClass.add(newSuperClass);\n<%org.eclipse.emf.ecore.EClass%> _get_2 = classes.get(0);\n<%org.eclipse.emf.ecore.EPackage%> _ePackage = _get_2.getEPackage();\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClassifier%>> _eClassifiers = _ePackage.getEClassifiers();\n_eClassifiers.add(newSuperClass);'"
	 * @generated
	 */
	void extractSuperClass2(EList<EClass> classes, String name);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model superClassUnique="false" nameUnique="false" operationsUnique="false" operationsMany="true" attributesUnique="false" attributesMany="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='final <%org.eclipse.emf.ecore.EClass%> newClass = <%org.eclipse.emf.ecore.EcoreFactory%>.eINSTANCE.createEClass();\nnewClass.setName(name);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass = this.getReferenceToEClass();\n_referenceToEClass.add(newClass);\n<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper = this.getHelper();\n<%org.eclipse.emf.ecore.EClass%> superCl = _helper.getClass(superClass);\nboolean _isEmpty = attributes.isEmpty();\nboolean _not = (!_isEmpty);\nif (_not)\n{\n\tfor (final <%java.lang.String%> s : attributes)\n\t{\n\t\ttry\n\t\t{\n\t\t\t<%java.lang.String%> _name = newClass.getName();\n\t\t\t<%java.lang.String%> _name_1 = superCl.getName();\n\t\t\tthis.moveEAttribute(s, _name, _name_1);\n\t\t}\n\t\tcatch (final Throwable _t) {\n\t\t\tif (_t instanceof <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>) {\n\t\t\t\tfinal <%de.ubt.ai1.modgraph.gt.failure.GTFailure%> f = (<%de.ubt.ai1.modgraph.gt.failure.GTFailure%>)_t;\n\t\t\t}\n\t\t\telse\n\t\t\t{\n\t\t\t\tthrow <%org.eclipse.xtext.xbase.lib.Exceptions%>.sneakyThrow(_t);\n\t\t\t}\n\t\t}\n\t}\n}\nboolean _isEmpty_1 = operations.isEmpty();\nboolean _not_1 = (!_isEmpty_1);\nif (_not_1)\n{\n\tfor (final <%java.lang.String%> s2 : operations)\n\t{\n\t\ttry\n\t\t{\n\t\t\t<%java.lang.String%> _name_2 = newClass.getName();\n\t\t\t<%java.lang.String%> _name_3 = superCl.getName();\n\t\t\tthis.moveEOperation(s2, _name_2, _name_3);\n\t\t}\n\t\tcatch (final Throwable _t_1) {\n\t\t\tif (_t_1 instanceof <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>) {\n\t\t\t\tfinal <%de.ubt.ai1.modgraph.gt.failure.GTFailure%> f_1 = (<%de.ubt.ai1.modgraph.gt.failure.GTFailure%>)_t_1;\n\t\t\t}\n\t\t\telse\n\t\t\t{\n\t\t\t\tthrow <%org.eclipse.xtext.xbase.lib.Exceptions%>.sneakyThrow(_t_1);\n\t\t\t}\n\t\t}\n\t}\n}\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _eSuperTypes = newClass.getESuperTypes();\n_eSuperTypes.add(superCl);\n<%org.eclipse.emf.ecore.EPackage%> _ePackage = superCl.getEPackage();\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClassifier%>> _eClassifiers = _ePackage.getEClassifiers();\n_eClassifiers.add(newClass);'"
	 * @generated
	 */
	void extractSubClass(String superClass, String name,
			EList<String> operations, EList<String> attributes);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model serverNameUnique="false" delegateNameUnique="false" clientNameUnique="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass = this.getReferenceToEClass();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t{\n\t\t<%java.lang.String%> _name = e.getName();\n\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, serverName));\n\t}\n};\nfinal <%org.eclipse.emf.ecore.EClass%> server = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>findFirst(_referenceToEClass, _function);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass_1 = this.getReferenceToEClass();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t{\n\t\t<%java.lang.String%> _name = e.getName();\n\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, clientName));\n\t}\n};\nfinal <%org.eclipse.emf.ecore.EClass%> client = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>findFirst(_referenceToEClass_1, _function_1);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass_2 = this.getReferenceToEClass();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function_2 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t{\n\t\t<%java.lang.String%> _name = e.getName();\n\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, delegateName));\n\t}\n};\nfinal <%org.eclipse.emf.ecore.EClass%> delegate = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>findFirst(_referenceToEClass_2, _function_2);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _referenceToEReference = this.getReferenceToEReference();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>> _function_3 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EReference%> e)\n\t{\n\t\tboolean _and = false;\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = client.getEStructuralFeatures();\n\t\tboolean _contains = _eStructuralFeatures.contains(e);\n\t\tif (!_contains)\n\t\t{\n\t\t\t_and = false;\n\t\t} else\n\t\t{\n\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType = e.getEType();\n\t\t\tboolean _equals = _eType.equals(delegate);\n\t\t\t_and = _equals;\n\t\t}\n\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t}\n};\nfinal <%org.eclipse.emf.ecore.EReference%> c2dRef = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>findFirst(_referenceToEReference, _function_3);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _referenceToEReference_1 = this.getReferenceToEReference();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>> _function_4 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EReference%> e)\n\t{\n\t\tboolean _and = false;\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = client.getEStructuralFeatures();\n\t\tboolean _contains = _eStructuralFeatures.contains(e);\n\t\tif (!_contains)\n\t\t{\n\t\t\t_and = false;\n\t\t} else\n\t\t{\n\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType = e.getEType();\n\t\t\tboolean _equals = _eType.equals(server);\n\t\t\t_and = _equals;\n\t\t}\n\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t}\n};\nfinal <%org.eclipse.emf.ecore.EReference%> c2sRef = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>findFirst(_referenceToEReference_1, _function_4);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _referenceToEReference_2 = this.getReferenceToEReference();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>> _function_5 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EReference%> e)\n\t{\n\t\tboolean _and = false;\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = server.getEStructuralFeatures();\n\t\tboolean _contains = _eStructuralFeatures.contains(e);\n\t\tif (!_contains)\n\t\t{\n\t\t\t_and = false;\n\t\t} else\n\t\t{\n\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType = e.getEType();\n\t\t\tboolean _equals = _eType.equals(delegate);\n\t\t\t_and = _equals;\n\t\t}\n\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t}\n};\nfinal <%org.eclipse.emf.ecore.EReference%> s2dRef = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>findFirst(_referenceToEReference_2, _function_5);\nboolean _and = false;\nboolean _notEquals = (!<%com.google.common.base.Objects%>.equal(c2sRef, null));\nif (!_notEquals)\n{\n\t_and = false;\n} else\n{\n\tboolean _notEquals_1 = (!<%com.google.common.base.Objects%>.equal(s2dRef, null));\n\t_and = _notEquals_1;\n}\nif (_and)\n{\n\t<%org.eclipse.emf.ecore.util.EcoreUtil%>.remove(c2dRef);\n}'"
	 * @generated
	 */
	void hideDelegate(String serverName, String delegateName, String clientName);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model serverNameUnique="false" delegateNameUnique="false" clientNameUnique="false"
	 * @generated
	 */
	void removeMiddleMan(String serverName, String delegateName,
			String clientName);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc -->
	 * Generated by ModGraph: <!-- end-model-doc -->
	 * 
	 * @model delegateNameUnique="false" superClassNameUnique="false"
	 *        annotation=
	 *        "http://www.eclipse.org/emf/2002/GenModel body='<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass = this.getReferenceToEClass();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t{\n\t\t<%java.lang.String%> _name = e.getName();\n\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, delegateName));\n\t}\n};\nfinal <%org.eclipse.emf.ecore.EClass%> delegate = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>findFirst(_referenceToEClass, _function);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass_1 = this.getReferenceToEClass();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t{\n\t\t<%java.lang.String%> _name = e.getName();\n\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, superClassName));\n\t}\n};\nfinal <%org.eclipse.emf.ecore.EClass%> superClass = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>findFirst(_referenceToEClass_1, _function_1);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _referenceToEReference = this.getReferenceToEReference();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>> _function_2 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EReference%> e)\n\t{\n\t\tboolean _and = false;\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = delegate.getEStructuralFeatures();\n\t\tboolean _contains = _eStructuralFeatures.contains(e);\n\t\tif (!_contains)\n\t\t{\n\t\t\t_and = false;\n\t\t} else\n\t\t{\n\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType = e.getEType();\n\t\t\tboolean _equals = _eType.equals(superClass);\n\t\t\t_and = _equals;\n\t\t}\n\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t}\n};\nfinal <%org.eclipse.emf.ecore.EReference%> deletionReference = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>findFirst(_referenceToEReference, _function_2);\n<%org.eclipse.emf.ecore.util.EcoreUtil%>.remove(deletionReference);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _eSuperTypes = delegate.getESuperTypes();\n_eSuperTypes.add(superClass);'"
	 * @generated
	 */
	void replaceDelegationWithInheritance(String delegateName,
			String superClassName);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc -->
	 * Generated by ModGraph: <!-- end-model-doc -->
	 * 
	 * @model subClassNameUnique="false" superClassNameUnique="false"
	 *        annotation=
	 *        "http://www.eclipse.org/emf/2002/GenModel body='<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass = this.getReferenceToEClass();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t{\n\t\t<%java.lang.String%> _name = e.getName();\n\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, subClassName));\n\t}\n};\nfinal <%org.eclipse.emf.ecore.EClass%> sourceClass = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>findFirst(_referenceToEClass, _function);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass_1 = this.getReferenceToEClass();\nfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n{\n\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t{\n\t\tboolean _and = false;\n\t\t<%java.lang.String%> _name = e.getName();\n\t\tboolean _equals = <%com.google.common.base.Objects%>.equal(_name, superClassName);\n\t\tif (!_equals)\n\t\t{\n\t\t\t_and = false;\n\t\t} else\n\t\t{\n\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _eSuperTypes = sourceClass.getESuperTypes();\n\t\t\tboolean _contains = _eSuperTypes.contains(e);\n\t\t\t_and = _contains;\n\t\t}\n\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t}\n};\nfinal <%org.eclipse.emf.ecore.EClass%> targetClass = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>findFirst(_referenceToEClass_1, _function_1);\n<%java.lang.String%> _name = sourceClass.getName();\n<%java.lang.String%> _plus = (_name + \"To\");\n<%java.lang.String%> _name_1 = targetClass.getName();\nfinal <%java.lang.String%> newReferenceNameValue = (_plus + _name_1);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _eSuperTypes = sourceClass.getESuperTypes();\n_eSuperTypes.remove(targetClass);\n<%org.eclipse.emf.ecore.EReference%> newReference = <%org.eclipse.emf.ecore.EcoreFactory%>.eINSTANCE.createEReference();\nnewReference.setName(newReferenceNameValue);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = sourceClass.getEStructuralFeatures();\n_eStructuralFeatures.add(newReference);\nnewReference.setEType(targetClass);'"
	 * @generated
	 */
	void replaceInheritanceWithDelegation(String subClassName,
			String superClassName);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc -->
	 * Generated by ModGraph. <!-- end-model-doc -->
	 * 
	 * @model sourceClassNameUnique="false" targetClassNameUnique="false"
	 *        annotation=
	 *        "http://www.eclipse.org/emf/2002/GenModel body='try\n{\n\t<%org.eclipse.emf.ecore.EClass%> sourceClass = null;\n\t<%org.eclipse.emf.ecore.EClass%> targetClass = null;\n\t<%org.eclipse.emf.ecore.EReference%> reference1 = null;\n\t<%org.eclipse.emf.ecore.EReference%> reference2 = null;\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass = this.getReferenceToEClass();\n\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n\t{\n\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t\t{\n\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, targetClassName));\n\t\t}\n\t};\n\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EClass%>> _filter = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>filter(_referenceToEClass, _function);\n\tfor (final <%org.eclipse.emf.ecore.EClass%> _targetClass : _filter)\n\t{\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass_1 = this.getReferenceToEClass();\n\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n\t\t{\n\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t\t\t{\n\t\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, sourceClassName));\n\t\t\t}\n\t\t};\n\t\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EClass%>> _filter_1 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>filter(_referenceToEClass_1, _function_1);\n\t\tfor (final <%org.eclipse.emf.ecore.EClass%> _sourceClass : _filter_1)\n\t\t{\n\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _referenceToEReference = this.getReferenceToEReference();\n\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>> _function_2 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>>()\n\t\t\t{\n\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EReference%> e)\n\t\t\t\t{\n\t\t\t\t\tboolean _and = false;\n\t\t\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _eReferences = _targetClass.getEReferences();\n\t\t\t\t\tboolean _contains = _eReferences.contains(e);\n\t\t\t\t\tif (!_contains)\n\t\t\t\t\t{\n\t\t\t\t\t\t_and = false;\n\t\t\t\t\t} else\n\t\t\t\t\t{\n\t\t\t\t\t\t<%org.eclipse.emf.ecore.EClass%> _eReferenceType = e.getEReferenceType();\n\t\t\t\t\t\tboolean _equals = _eReferenceType.equals(_sourceClass);\n\t\t\t\t\t\t_and = _equals;\n\t\t\t\t\t}\n\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t\t\t\t}\n\t\t\t};\n\t\t\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EReference%>> _filter_2 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>filter(_referenceToEReference, _function_2);\n\t\t\tfor (final <%org.eclipse.emf.ecore.EReference%> _reference2 : _filter_2)\n\t\t\t{\n\t\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _eReferences = _sourceClass.getEReferences();\n\t\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>> _function_3 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>>()\n\t\t\t\t{\n\t\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EReference%> e)\n\t\t\t\t\t{\n\t\t\t\t\t\tboolean _and = false;\n\t\t\t\t\t\tboolean _and_1 = false;\n\t\t\t\t\t\t<%org.eclipse.emf.ecore.EReference%> _eOpposite = _reference2.getEOpposite();\n\t\t\t\t\t\tboolean _equals = _eOpposite.equals(e);\n\t\t\t\t\t\tif (!_equals)\n\t\t\t\t\t\t{\n\t\t\t\t\t\t\t_and_1 = false;\n\t\t\t\t\t\t} else\n\t\t\t\t\t\t{\n\t\t\t\t\t\t\t<%org.eclipse.emf.ecore.EClass%> _eReferenceType = e.getEReferenceType();\n\t\t\t\t\t\t\tboolean _equals_1 = _eReferenceType.equals(_targetClass);\n\t\t\t\t\t\t\t_and_1 = _equals_1;\n\t\t\t\t\t\t}\n\t\t\t\t\t\tif (!_and_1)\n\t\t\t\t\t\t{\n\t\t\t\t\t\t\t_and = false;\n\t\t\t\t\t\t} else\n\t\t\t\t\t\t{\n\t\t\t\t\t\t\t<%org.eclipse.emf.ecore.EReference%> _eOpposite_1 = e.getEOpposite();\n\t\t\t\t\t\t\tboolean _equals_2 = _eOpposite_1.equals(_reference2);\n\t\t\t\t\t\t\t_and = _equals_2;\n\t\t\t\t\t\t}\n\t\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t\t\t\t\t}\n\t\t\t\t};\n\t\t\t\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EReference%>> _filter_3 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>filter(_eReferences, _function_3);\n\t\t\t\tfor (final <%org.eclipse.emf.ecore.EReference%> _reference1 : _filter_3)\n\t\t\t\t{\n\t\t\t\t\t{\n\t\t\t\t\t\tsourceClass = _sourceClass;\n\t\t\t\t\t\ttargetClass = _targetClass;\n\t\t\t\t\t\treference1 = _reference1;\n\t\t\t\t\t\treference2 = _reference2;\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t}\n\t\t}\n\t}\n\tboolean _equals = <%com.google.common.base.Objects%>.equal(sourceClass, null);\n\tif (_equals)\n\t{\n\t\tthrow new <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>();\n\t}\n\t<%org.eclipse.emf.ecore.util.EcoreUtil%>.remove(reference2);\n}\ncatch (Throwable _e)\n{\n\tthrow org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);\n}'"
	 * @generated
	 */
	void changeBidirectionalToUnidirectionalReference(String sourceClassName,
			String targetClassName);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model refUnique="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='<%org.eclipse.emf.ecore.EReference%> _eOpposite = ref.getEOpposite();\nboolean _notEquals = (!<%com.google.common.base.Objects%>.equal(_eOpposite, null));\nif (_notEquals)\n{\n\t<%org.eclipse.emf.ecore.util.EcoreUtil%>.remove(ref);\n}'"
	 * @generated
	 */
	void changeBidirectionalToUnidirectionalReferenceREF(EReference ref);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc -->
	 * Generated by ModGraph: <!-- end-model-doc -->
	 * 
	 * @model class1NameUnique="false" class2NameUnique="false" annotation=
	 *        "http://www.eclipse.org/emf/2002/GenModel body='try\n{\n\t<%org.eclipse.emf.ecore.EClass%> class1 = null;\n\t<%org.eclipse.emf.ecore.EClass%> class2 = null;\n\t<%org.eclipse.emf.ecore.EReference%> reference1 = null;\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass = this.getReferenceToEClass();\n\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n\t{\n\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t\t{\n\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, class1Name));\n\t\t}\n\t};\n\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EClass%>> _filter = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>filter(_referenceToEClass, _function);\n\tfor (final <%org.eclipse.emf.ecore.EClass%> _class1 : _filter)\n\t{\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass_1 = this.getReferenceToEClass();\n\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n\t\t{\n\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t\t\t{\n\t\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, class2Name));\n\t\t\t}\n\t\t};\n\t\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EClass%>> _filter_1 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>filter(_referenceToEClass_1, _function_1);\n\t\tfor (final <%org.eclipse.emf.ecore.EClass%> _class2 : _filter_1)\n\t\t{\n\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _eReferences = _class1.getEReferences();\n\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>> _function_2 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>>()\n\t\t\t{\n\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EReference%> e)\n\t\t\t\t{\n\t\t\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType = e.getEType();\n\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf(_eType.equals(_class2));\n\t\t\t\t}\n\t\t\t};\n\t\t\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EReference%>> _filter_2 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>filter(_eReferences, _function_2);\n\t\t\tfor (final <%org.eclipse.emf.ecore.EReference%> _reference1 : _filter_2)\n\t\t\t{\n\t\t\t\t<%org.eclipse.emf.ecore.EReference%> _eOpposite = _reference1.getEOpposite();\n\t\t\t\tboolean _notEquals = (!<%com.google.common.base.Objects%>.equal(_eOpposite, null));\n\t\t\t\tboolean _not = (!_notEquals);\n\t\t\t\tif (_not)\n\t\t\t\t{\n\t\t\t\t\tclass1 = _class1;\n\t\t\t\t\tclass2 = _class2;\n\t\t\t\t\treference1 = _reference1;\n\t\t\t\t}\n\t\t\t}\n\t\t}\n\t}\n\tboolean _equals = <%com.google.common.base.Objects%>.equal(class1, null);\n\tif (_equals)\n\t{\n\t\tthrow new <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>();\n\t}\n\tfinal <%java.lang.String%> reference2NameValue = ((class1Name + \"to\") + class2Name);\n\t<%org.eclipse.emf.ecore.EReference%> reference2 = <%org.eclipse.emf.ecore.EcoreFactory%>.eINSTANCE.createEReference();\n\treference2.setName(reference2NameValue);\n\treference2.setEOpposite(reference1);\n\treference1.setEOpposite(reference2);\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = class2.getEStructuralFeatures();\n\t_eStructuralFeatures.add(reference2);\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _referenceToEReference = this.getReferenceToEReference();\n\t_referenceToEReference.add(reference2);\n\treference2.setEType(class1);\n}\ncatch (Throwable _e)\n{\n\tthrow org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);\n}'"
	 *        annotation=
	 *        "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot pre_pre1='class1Name.size()>0 and  class2Name.size()>0 '"
	 * @generated
	 */
	void changeUnidirectionalToBidirectionalReference(String class1Name,
			String class2Name);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model classTypeUnique="false" superClassUnique="false" subClassUnique="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper = this.getHelper();\n<%org.eclipse.emf.ecore.EClass%> superCl = _helper.getClass(superClass);\n<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper_1 = this.getHelper();\n<%org.eclipse.emf.ecore.EClass%> subCl = _helper_1.getClass(subClass);\nboolean _equals = <%com.google.common.base.Objects%>.equal(classType, <%de.ubt.ai1.modGraph.example.eRefactoring.ClassType%>.SUPER_CLASS);\nif (_equals)\n{\n\ttry\n\t{\n\t\tthis.removeSuper(superCl, subCl);\n\t}\n\tcatch (final Throwable _t) {\n\t\tif (_t instanceof <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>) {\n\t\t\tfinal <%de.ubt.ai1.modgraph.gt.failure.GTFailure%> f = (<%de.ubt.ai1.modgraph.gt.failure.GTFailure%>)_t;\n\t\t}\n\t\telse\n\t\t{\n\t\t\tthrow <%org.eclipse.xtext.xbase.lib.Exceptions%>.sneakyThrow(_t);\n\t\t}\n\t}\n}\nboolean _equals_1 = <%com.google.common.base.Objects%>.equal(classType, <%de.ubt.ai1.modGraph.example.eRefactoring.ClassType%>.SUB_CLASS);\nif (_equals_1)\n{\n\ttry\n\t{\n\t\tthis.removeSub(superCl, subCl);\n\t}\n\tcatch (final Throwable _t_1) {\n\t\tif (_t_1 instanceof <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>) {\n\t\t\tfinal <%de.ubt.ai1.modgraph.gt.failure.GTFailure%> f_1 = (<%de.ubt.ai1.modgraph.gt.failure.GTFailure%>)_t_1;\n\t\t}\n\t\telse\n\t\t{\n\t\t\tthrow <%org.eclipse.xtext.xbase.lib.Exceptions%>.sneakyThrow(_t_1);\n\t\t}\n\t}\n}'"
	 * @generated
	 */
	void collapseHierararchy(ClassType classType, String superClass,
			String subClass);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc -->
	 * Generated by ModGraph. <!-- end-model-doc -->
	 * 
	 * @model superClassUnique="false" subClassUnique="false" annotation=
	 *        "http://www.eclipse.org/emf/2002/GenModel body='try\n{\n\tboolean _and = false;\n\tboolean _notEquals = (!<%com.google.common.base.Objects%>.equal(superClass, null));\n\tif (!_notEquals)\n\t{\n\t\t_and = false;\n\t} else\n\t{\n\t\tboolean _notEquals_1 = (!<%com.google.common.base.Objects%>.equal(subClass, null));\n\t\t_and = _notEquals_1;\n\t}\n\tboolean _not = (!_and);\n\tif (_not)\n\t{\n\t\tthrow new <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>();\n\t}\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> structuralFeatures = null;\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> operations = null;\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> externalReferences = null;\n\tfinal <%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _structuralFeatures = superClass.getEStructuralFeatures();\n\tfinal <%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _operations = superClass.getEOperations();\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _referenceToEReference = this.getReferenceToEReference();\n\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>>()\n\t{\n\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EReference%> e)\n\t\t{\n\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType = e.getEType();\n\t\t\treturn <%java.lang.Boolean%>.valueOf(_eType.equals(superClass));\n\t\t}\n\t};\n\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EReference%>> _filter = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>filter(_referenceToEReference, _function);\n\tfinal <%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _externalReferences = <%org.eclipse.emf.common.util.ECollections%>.<<%org.eclipse.emf.ecore.EReference%>>asEList(((<%org.eclipse.emf.ecore.EReference%>[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter, <%org.eclipse.emf.ecore.EReference%>.class)));\n\tstructuralFeatures = _structuralFeatures;\n\toperations = _operations;\n\texternalReferences = _externalReferences;\n\tboolean _equals = <%com.google.common.base.Objects%>.equal(structuralFeatures, null);\n\tif (_equals)\n\t{\n\t\tthrow new <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>();\n\t}\n\t<%org.eclipse.emf.ecore.util.EcoreUtil%>.remove(superClass);\n\tfinal <%org.eclipse.xtext.xbase.lib.Procedures.Procedure1%><<%org.eclipse.emf.ecore.EReference%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Procedures.Procedure1%><<%org.eclipse.emf.ecore.EReference%>>()\n\t{\n\t\tpublic void apply(final <%org.eclipse.emf.ecore.EReference%> e)\n\t\t{\n\t\t\te.setEType(subClass);\n\t\t}\n\t};\n\t<%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>forEach(externalReferences, _function_1);\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = subClass.getEStructuralFeatures();\n\t_eStructuralFeatures.addAll(structuralFeatures);\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations = subClass.getEOperations();\n\t_eOperations.addAll(operations);\n}\ncatch (Throwable _e)\n{\n\tthrow org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);\n}'"
	 * @generated
	 */
	void removeSuper(EClass superClass, EClass subClass);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc -->
	 * Generated by ModGraph: <!-- end-model-doc -->
	 * 
	 * @model superClassUnique="false" subClassUnique="false" annotation=
	 *        "http://www.eclipse.org/emf/2002/GenModel body='try\n{\n\tboolean _and = false;\n\tboolean _notEquals = (!<%com.google.common.base.Objects%>.equal(superClass, null));\n\tif (!_notEquals)\n\t{\n\t\t_and = false;\n\t} else\n\t{\n\t\tboolean _notEquals_1 = (!<%com.google.common.base.Objects%>.equal(subClass, null));\n\t\t_and = _notEquals_1;\n\t}\n\tboolean _not = (!_and);\n\tif (_not)\n\t{\n\t\tthrow new <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>();\n\t}\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> structuralFeatures = null;\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> operations = null;\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> externalReferences = null;\n\tfinal <%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _operations = subClass.getEOperations();\n\tfinal <%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _structuralFeatures = subClass.getEStructuralFeatures();\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _referenceToEReference = this.getReferenceToEReference();\n\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>>()\n\t{\n\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EReference%> e)\n\t\t{\n\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType = e.getEType();\n\t\t\treturn <%java.lang.Boolean%>.valueOf(_eType.equals(subClass));\n\t\t}\n\t};\n\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EReference%>> _filter = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>filter(_referenceToEReference, _function);\n\tfinal <%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _externalReferences = <%org.eclipse.emf.common.util.ECollections%>.<<%org.eclipse.emf.ecore.EReference%>>asEList(((<%org.eclipse.emf.ecore.EReference%>[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter, <%org.eclipse.emf.ecore.EReference%>.class)));\n\tstructuralFeatures = _structuralFeatures;\n\toperations = _operations;\n\texternalReferences = _externalReferences;\n\t<%org.eclipse.emf.ecore.util.EcoreUtil%>.remove(subClass);\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = superClass.getEStructuralFeatures();\n\t_eStructuralFeatures.addAll(structuralFeatures);\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EOperation%>> _eOperations = superClass.getEOperations();\n\t_eOperations.addAll(operations);\n\tfinal <%org.eclipse.xtext.xbase.lib.Procedures.Procedure1%><<%org.eclipse.emf.ecore.EReference%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Procedures.Procedure1%><<%org.eclipse.emf.ecore.EReference%>>()\n\t{\n\t\tpublic void apply(final <%org.eclipse.emf.ecore.EReference%> e)\n\t\t{\n\t\t\te.setEType(superClass);\n\t\t}\n\t};\n\t<%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>forEach(externalReferences, _function_1);\n}\ncatch (Throwable _e)\n{\n\tthrow org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);\n}'"
	 * @generated
	 */
	void removeSub(EClass superClass, EClass subClass);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc -->
	 * Generated by ModGraph: <!-- end-model-doc -->
	 * 
	 * @model class1NameUnique="false" class2NameUnique="false" annotation=
	 *        "http://www.eclipse.org/emf/2002/GenModel body='try\n{\n\tboolean _or = false;\n\tboolean _or_1 = false;\n\tboolean _or_2 = false;\n\tboolean _notEquals = (!<%com.google.common.base.Objects%>.equal(class1Name, null));\n\tif (_notEquals)\n\t{\n\t\t_or_2 = true;\n\t} else\n\t{\n\t\tboolean _notEquals_1 = (!<%com.google.common.base.Objects%>.equal(class1Name, \"\"));\n\t\t_or_2 = _notEquals_1;\n\t}\n\tif (_or_2)\n\t{\n\t\t_or_1 = true;\n\t} else\n\t{\n\t\tboolean _notEquals_2 = (!<%com.google.common.base.Objects%>.equal(class2Name, null));\n\t\t_or_1 = _notEquals_2;\n\t}\n\tif (_or_1)\n\t{\n\t\t_or = true;\n\t} else\n\t{\n\t\tboolean _notEquals_3 = (!<%com.google.common.base.Objects%>.equal(class2Name, \"\"));\n\t\t_or = _notEquals_3;\n\t}\n\tboolean _not = (!_or);\n\tif (_not)\n\t{\n\t\tthrow new <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>();\n\t}\n\t<%org.eclipse.emf.ecore.EClass%> class1 = null;\n\t<%org.eclipse.emf.ecore.EClass%> class2 = null;\n\t<%org.eclipse.emf.ecore.EReference%> reference = null;\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass = this.getReferenceToEClass();\n\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n\t{\n\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t\t{\n\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, class2Name));\n\t\t}\n\t};\n\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EClass%>> _filter = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>filter(_referenceToEClass, _function);\n\tfor (final <%org.eclipse.emf.ecore.EClass%> _class2 : _filter)\n\t{\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass_1 = this.getReferenceToEClass();\n\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n\t\t{\n\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t\t\t{\n\t\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, class1Name));\n\t\t\t}\n\t\t};\n\t\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EClass%>> _filter_1 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>filter(_referenceToEClass_1, _function_1);\n\t\tfor (final <%org.eclipse.emf.ecore.EClass%> _class1 : _filter_1)\n\t\t{\n\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _eReferences = class1.getEReferences();\n\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>> _function_2 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>>()\n\t\t\t{\n\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EReference%> e)\n\t\t\t\t{\n\t\t\t\t\tboolean _and = false;\n\t\t\t\t\tboolean _isContainment = e.isContainment();\n\t\t\t\t\tboolean _equals = (_isContainment == true);\n\t\t\t\t\tif (!_equals)\n\t\t\t\t\t{\n\t\t\t\t\t\t_and = false;\n\t\t\t\t\t} else\n\t\t\t\t\t{\n\t\t\t\t\t\t<%org.eclipse.emf.ecore.EClassifier%> _eType = e.getEType();\n\t\t\t\t\t\tboolean _equals_1 = _eType.equals(_class2);\n\t\t\t\t\t\t_and = _equals_1;\n\t\t\t\t\t}\n\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t\t\t\t}\n\t\t\t};\n\t\t\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EReference%>> _filter_2 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>filter(_eReferences, _function_2);\n\t\t\tfor (final <%org.eclipse.emf.ecore.EReference%> _reference : _filter_2)\n\t\t\t{\n\t\t\t\t{\n\t\t\t\t\tclass1 = _class1;\n\t\t\t\t\tclass2 = _class2;\n\t\t\t\t\treference = _reference;\n\t\t\t\t}\n\t\t\t}\n\t\t}\n\t}\n\tboolean _equals = <%com.google.common.base.Objects%>.equal(class1, null);\n\tif (_equals)\n\t{\n\t\tthrow new <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>();\n\t}\n}\ncatch (Throwable _e)\n{\n\tthrow org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);\n}'"
	 * @generated
	 */
	void changeValueToReference(String class1Name, String class2Name);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc -->
	 * Generated by ModGraph: <!-- end-model-doc -->
	 * 
	 * @model nameClass1Unique="false" nameClass2Unique="false" annotation=
	 *        "http://www.eclipse.org/emf/2002/GenModel body='try\n{\n\t<%org.eclipse.emf.ecore.EClass%> class1 = null;\n\t<%org.eclipse.emf.ecore.EClass%> class2 = null;\n\t<%org.eclipse.emf.ecore.EReference%> reference = null;\n\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass = this.getReferenceToEClass();\n\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n\t{\n\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t\t{\n\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, nameClass1));\n\t\t}\n\t};\n\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EClass%>> _filter = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>filter(_referenceToEClass, _function);\n\tfor (final <%org.eclipse.emf.ecore.EClass%> _class1 : _filter)\n\t{\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass_1 = this.getReferenceToEClass();\n\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>> _function_1 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EClass%>, <%java.lang.Boolean%>>()\n\t\t{\n\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EClass%> e)\n\t\t\t{\n\t\t\t\t<%java.lang.String%> _name = e.getName();\n\t\t\t\treturn <%java.lang.Boolean%>.valueOf(<%com.google.common.base.Objects%>.equal(_name, nameClass2));\n\t\t\t}\n\t\t};\n\t\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EClass%>> _filter_1 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EClass%>>filter(_referenceToEClass_1, _function_1);\n\t\tfor (final <%org.eclipse.emf.ecore.EClass%> _class2 : _filter_1)\n\t\t{\n\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _referenceToEReference = this.getReferenceToEReference();\n\t\t\tfinal <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>> _function_2 = new <%org.eclipse.xtext.xbase.lib.Functions.Function1%><<%org.eclipse.emf.ecore.EReference%>, <%java.lang.Boolean%>>()\n\t\t\t{\n\t\t\t\tpublic <%java.lang.Boolean%> apply(final <%org.eclipse.emf.ecore.EReference%> e)\n\t\t\t\t{\n\t\t\t\t\tboolean _and = false;\n\t\t\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _eReferences = _class1.getEReferences();\n\t\t\t\t\tboolean _contains = _eReferences.contains(e);\n\t\t\t\t\tif (!_contains)\n\t\t\t\t\t{\n\t\t\t\t\t\t_and = false;\n\t\t\t\t\t} else\n\t\t\t\t\t{\n\t\t\t\t\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EReference%>> _eReferences_1 = _class2.getEReferences();\n\t\t\t\t\t\tboolean _contains_1 = _eReferences_1.contains(e);\n\t\t\t\t\t\t_and = _contains_1;\n\t\t\t\t\t}\n\t\t\t\t\treturn <%java.lang.Boolean%>.valueOf(_and);\n\t\t\t\t}\n\t\t\t};\n\t\t\t<%java.lang.Iterable%><<%org.eclipse.emf.ecore.EReference%>> _filter_2 = <%org.eclipse.xtext.xbase.lib.IterableExtensions%>.<<%org.eclipse.emf.ecore.EReference%>>filter(_referenceToEReference, _function_2);\n\t\t\tfor (final <%org.eclipse.emf.ecore.EReference%> _reference : _filter_2)\n\t\t\t{\n\t\t\t\t{\n\t\t\t\t\tclass1 = _class1;\n\t\t\t\t\tclass2 = _class2;\n\t\t\t\t\treference = _reference;\n\t\t\t\t}\n\t\t\t}\n\t\t}\n\t}\n\tboolean _equals = <%com.google.common.base.Objects%>.equal(class1, null);\n\tif (_equals)\n\t{\n\t\tthrow new <%de.ubt.ai1.modgraph.gt.failure.GTFailure%>();\n\t}\n\treference.setContainment(true);\n}\ncatch (Throwable _e)\n{\n\tthrow org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);\n}'"
	 *        annotation=
	 *        "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot pre_pre1='class1.size()>0 and class2.size()>0'"
	 * @generated
	 */
	void changeReferenceToValue(String nameClass1, String nameClass2);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model superClassUnique="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper = this.getHelper();\n<%org.eclipse.emf.ecore.EClass%> superCl = _helper.getClass(superClass);\n<%de.ubt.ai1.modGraph.example.eRefactoring.Helper%> _helper_1 = this.getHelper();\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> subClasses = _helper_1.getAllSubClasses(superCl);\n<%org.eclipse.emf.ecore.EEnum%> newEnum = <%org.eclipse.emf.ecore.EcoreFactory%>.eINSTANCE.createEEnum();\nnewEnum.setName((superClass + \"Type\"));\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.ENamedElement%>> _referenceToENamedElement = this.getReferenceToENamedElement();\n_referenceToENamedElement.add(newEnum);\nint i = 0;\nfor (final <%org.eclipse.emf.ecore.EClass%> c : subClasses)\n{\n\t{\n\t\t<%org.eclipse.emf.ecore.EEnumLiteral%> newEnumLiteral = <%org.eclipse.emf.ecore.EcoreFactory%>.eINSTANCE.createEEnumLiteral();\n\t\t<%java.lang.String%> _name = c.getName();\n\t\t<%java.lang.String%> _upperCase = _name.toUpperCase();\n\t\tnewEnumLiteral.setLiteral(_upperCase);\n\t\tnewEnumLiteral.setValue(i);\n\t\t<%java.lang.String%> _name_1 = c.getName();\n\t\t<%java.lang.String%> _upperCase_1 = _name_1.toUpperCase();\n\t\tnewEnumLiteral.setName(_upperCase_1);\n\t\t<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EEnumLiteral%>> _eLiterals = newEnum.getELiterals();\n\t\t_eLiterals.add(newEnumLiteral);\n\t\ti = (i + 1);\n\t}\n}\n<%org.eclipse.emf.ecore.EAttribute%> opParam = <%org.eclipse.emf.ecore.EcoreFactory%>.eINSTANCE.createEAttribute();\nopParam.setEType(newEnum);\nopParam.setName(((\"_\" + superClass) + \"Type\"));\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EStructuralFeature%>> _eStructuralFeatures = superCl.getEStructuralFeatures();\n_eStructuralFeatures.add(opParam);\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClass%>> _referenceToEClass = this.getReferenceToEClass();\n_referenceToEClass.removeAll(subClasses);\n<%org.eclipse.emf.ecore.EPackage%> _ePackage = superCl.getEPackage();\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClassifier%>> _eClassifiers = _ePackage.getEClassifiers();\n_eClassifiers.removeAll(subClasses);\n<%org.eclipse.emf.ecore.EPackage%> _ePackage_1 = superCl.getEPackage();\n<%org.eclipse.emf.common.util.EList%><<%org.eclipse.emf.ecore.EClassifier%>> _eClassifiers_1 = _ePackage_1.getEClassifiers();\n_eClassifiers_1.add(newEnum);'"
	 * @generated
	 */
	void replaceSubclassWithFields(String superClass);

} // Refactoring
