/**
 */
package de.ubt.ai1.modGraph.example.eRefactoring.impl;

import java.lang.reflect.InvocationTargetException;
import java.util.Collection;

import org.eclipse.emf.common.util.ECollections;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EParameter;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.EcoreUtil.Copier;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;

import com.google.common.base.Objects;

import de.ubt.ai1.modGraph.example.eRefactoring.ERefactoringPackage;
import de.ubt.ai1.modGraph.example.eRefactoring.Helper;
import de.ubt.ai1.modgraph.gt.failure.GTFailure;
import java.lang.Iterable;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Helper</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.impl.HelperImpl#getReferenceToENamedElementHelper <em>Reference To ENamed Element Helper</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.impl.HelperImpl#getReferenceToEOperationHelper <em>Reference To EOperation Helper</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.impl.HelperImpl#getReferenceToEClassHelper <em>Reference To EClass Helper</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.impl.HelperImpl#getReferenceToEClassifierHelper <em>Reference To EClassifier Helper</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.impl.HelperImpl#getReferenceToEAttributeHelper <em>Reference To EAttribute Helper</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.impl.HelperImpl#getReferenceToEReferenceHelper <em>Reference To EReference Helper</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.impl.HelperImpl#getReferenceToEParameterHelper <em>Reference To EParameter Helper</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HelperImpl extends MinimalEObjectImpl.Container implements Helper {
	/**
	 * The cached value of the '{@link #getReferenceToENamedElementHelper() <em>Reference To ENamed Element Helper</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReferenceToENamedElementHelper()
	 * @generated
	 * @ordered
	 */
	protected EList<ENamedElement> referenceToENamedElementHelper;

	/**
	 * The cached value of the '{@link #getReferenceToEOperationHelper() <em>Reference To EOperation Helper</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReferenceToEOperationHelper()
	 * @generated
	 * @ordered
	 */
	protected EList<EOperation> referenceToEOperationHelper;

	/**
	 * The cached value of the '{@link #getReferenceToEClassHelper() <em>Reference To EClass Helper</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReferenceToEClassHelper()
	 * @generated
	 * @ordered
	 */
	protected EList<EClass> referenceToEClassHelper;

	/**
	 * The cached value of the '{@link #getReferenceToEClassifierHelper() <em>Reference To EClassifier Helper</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReferenceToEClassifierHelper()
	 * @generated
	 * @ordered
	 */
	protected EList<EClass> referenceToEClassifierHelper;

	/**
	 * The cached value of the '{@link #getReferenceToEAttributeHelper() <em>Reference To EAttribute Helper</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReferenceToEAttributeHelper()
	 * @generated
	 * @ordered
	 */
	protected EList<EAttribute> referenceToEAttributeHelper;

	/**
	 * The cached value of the '{@link #getReferenceToEReferenceHelper() <em>Reference To EReference Helper</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReferenceToEReferenceHelper()
	 * @generated
	 * @ordered
	 */
	protected EList<EReference> referenceToEReferenceHelper;

	/**
	 * The cached value of the '{@link #getReferenceToEParameterHelper() <em>Reference To EParameter Helper</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReferenceToEParameterHelper()
	 * @generated
	 * @ordered
	 */
	protected EList<EParameter> referenceToEParameterHelper;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HelperImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ERefactoringPackage.Literals.HELPER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ENamedElement> getReferenceToENamedElementHelper() {
		if (referenceToENamedElementHelper == null) {
			referenceToENamedElementHelper = new EObjectResolvingEList<ENamedElement>(ENamedElement.class, this, ERefactoringPackage.HELPER__REFERENCE_TO_ENAMED_ELEMENT_HELPER);
		}
		return referenceToENamedElementHelper;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EOperation> getReferenceToEOperationHelper() {
		if (referenceToEOperationHelper == null) {
			referenceToEOperationHelper = new EObjectResolvingEList<EOperation>(EOperation.class, this, ERefactoringPackage.HELPER__REFERENCE_TO_EOPERATION_HELPER);
		}
		return referenceToEOperationHelper;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EClass> getReferenceToEClassHelper() {
		if (referenceToEClassHelper == null) {
			referenceToEClassHelper = new EObjectResolvingEList<EClass>(EClass.class, this, ERefactoringPackage.HELPER__REFERENCE_TO_ECLASS_HELPER);
		}
		return referenceToEClassHelper;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EClass> getReferenceToEClassifierHelper() {
		if (referenceToEClassifierHelper == null) {
			referenceToEClassifierHelper = new EObjectResolvingEList<EClass>(EClass.class, this, ERefactoringPackage.HELPER__REFERENCE_TO_ECLASSIFIER_HELPER);
		}
		return referenceToEClassifierHelper;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EAttribute> getReferenceToEAttributeHelper() {
		if (referenceToEAttributeHelper == null) {
			referenceToEAttributeHelper = new EObjectResolvingEList<EAttribute>(EAttribute.class, this, ERefactoringPackage.HELPER__REFERENCE_TO_EATTRIBUTE_HELPER);
		}
		return referenceToEAttributeHelper;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EReference> getReferenceToEReferenceHelper() {
		if (referenceToEReferenceHelper == null) {
			referenceToEReferenceHelper = new EObjectResolvingEList<EReference>(EReference.class, this, ERefactoringPackage.HELPER__REFERENCE_TO_EREFERENCE_HELPER);
		}
		return referenceToEReferenceHelper;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EParameter> getReferenceToEParameterHelper() {
		if (referenceToEParameterHelper == null) {
			referenceToEParameterHelper = new EObjectResolvingEList<EParameter>(EParameter.class, this, ERefactoringPackage.HELPER__REFERENCE_TO_EPARAMETER_HELPER);
		}
		return referenceToEParameterHelper;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EClass> getAllClasses() {
		try {
			EList<EClass> classes = null;
			final EList<EClass> _classes = this.getReferenceToEClassHelper();
			classes = _classes;
			boolean _equals = Objects.equal(classes, null);
			if (_equals) {
				throw new GTFailure();
			}
			return classes;
		}
		catch (Throwable _e) {
			throw org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EClass> getAllSubClasses(final EClass superClass) {
		try {
			EList<EClass> classes = null;
			EList<EClass> _referenceToEClassHelper = this.getReferenceToEClassHelper();
			final Function1<EClass, Boolean> _function = new Function1<EClass, Boolean>() {
				public Boolean apply(final EClass e) {
					EList<EClass> _eSuperTypes = e.getESuperTypes();
					return Boolean.valueOf(_eSuperTypes.contains(superClass));
				}
			};
			Iterable<EClass> _filter = IterableExtensions.<EClass>filter(_referenceToEClassHelper, _function);
			final EList<EClass> _classes = ECollections.<EClass>asEList(((EClass[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter, EClass.class)));
			classes = _classes;
			boolean _equals = Objects.equal(classes, null);
			if (_equals) {
				throw new GTFailure();
			}
			return classes;
		}
		catch (Throwable _e) {
			throw org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getClass(final String name) {
		try {
			boolean _notEquals = (!Objects.equal(name, null));
			boolean _not = (!_notEquals);
			if (_not) {
				return null;
			}
			EClass clazz = null;
			EList<EClass> _referenceToEClassHelper = this.getReferenceToEClassHelper();
			final Function1<EClass, Boolean> _function = new Function1<EClass, Boolean>() {
				public Boolean apply(final EClass e) {
					String _name = e.getName();
					return Boolean.valueOf(Objects.equal(_name, name));
				}
			};
			Iterable<EClass> _filter = IterableExtensions.<EClass>filter(_referenceToEClassHelper, _function);
			for (final EClass _clazz : _filter) {
				clazz = _clazz;
			}
			boolean _equals = Objects.equal(clazz, null);
			if (_equals) {
				throw new GTFailure();
			}
			return clazz;
		}
		catch (Throwable _e) {
			throw org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAttributeByName(final EClass sourceClass, final String name) {
		final Copier copier = new Copier();
		EAttribute a = null;
		EList<EAttribute> _eAttributes = sourceClass.getEAttributes();
		for (final EAttribute b : _eAttributes) {
			String _name = b.getName();
			boolean _equals = Objects.equal(_name, name);
			if (_equals) {
				EObject _copy = copier.copy(b);
				a = ((EAttribute) _copy);
				EClassifier _eType = b.getEType();
				a.setEType(_eType);
				int _lowerBound = b.getLowerBound();
				a.setLowerBound(_lowerBound);
				int _upperBound = b.getUpperBound();
				a.setUpperBound(_upperBound);
				boolean _isChangeable = b.isChangeable();
				a.setChangeable(_isChangeable);
			}
		}
		return a;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeAttributeByName(final EClass sourceClass, final String name) {
		try {
			EAttribute attribute = null;
			EList<EAttribute> _eAttributes = sourceClass.getEAttributes();
			final Function1<EAttribute, Boolean> _function = new Function1<EAttribute, Boolean>() {
				public Boolean apply(final EAttribute e) {
					String _name = e.getName();
					return Boolean.valueOf(Objects.equal(_name, name));
				}
			};
			Iterable<EAttribute> _filter = IterableExtensions.<EAttribute>filter(_eAttributes, _function);
			for (final EAttribute _attribute : _filter) {
				attribute = _attribute;
			}
			boolean _equals = Objects.equal(attribute, null);
			if (_equals) {
				throw new GTFailure();
			}
			EcoreUtil.remove(attribute);
		}
		catch (Throwable _e) {
			throw org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getOperationByName(final EClass sourceClass, final String name) {
		final Copier copier = new Copier();
		EOperation a = null;
		EList<EOperation> _eOperations = sourceClass.getEOperations();
		for (final EOperation b : _eOperations) {
			String _name = b.getName();
			boolean _equals = Objects.equal(_name, name);
			if (_equals) {
				EObject _copy = copier.copy(b);
				a = ((EOperation) _copy);
				EClassifier _eType = b.getEType();
				a.setEType(_eType);
				int _lowerBound = b.getLowerBound();
				a.setLowerBound(_lowerBound);
				int _upperBound = b.getUpperBound();
				a.setUpperBound(_upperBound);
				boolean _isOrdered = b.isOrdered();
				a.setOrdered(_isOrdered);
			}
		}
		return a;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeOperationByName(final EClass sourceClass, final String name) {
		try {
			EOperation operation = null;
			EList<EOperation> _eOperations = sourceClass.getEOperations();
			final Function1<EOperation, Boolean> _function = new Function1<EOperation, Boolean>() {
				public Boolean apply(final EOperation e) {
					String _name = e.getName();
					return Boolean.valueOf(Objects.equal(_name, name));
				}
			};
			Iterable<EOperation> _filter = IterableExtensions.<EOperation>filter(_eOperations, _function);
			for (final EOperation _operation : _filter) {
				operation = _operation;
			}
			boolean _equals = Objects.equal(operation, null);
			if (_equals) {
				throw new GTFailure();
			}
			EcoreUtil.remove(operation);
		}
		catch (Throwable _e) {
			throw org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ERefactoringPackage.HELPER__REFERENCE_TO_ENAMED_ELEMENT_HELPER:
				return getReferenceToENamedElementHelper();
			case ERefactoringPackage.HELPER__REFERENCE_TO_EOPERATION_HELPER:
				return getReferenceToEOperationHelper();
			case ERefactoringPackage.HELPER__REFERENCE_TO_ECLASS_HELPER:
				return getReferenceToEClassHelper();
			case ERefactoringPackage.HELPER__REFERENCE_TO_ECLASSIFIER_HELPER:
				return getReferenceToEClassifierHelper();
			case ERefactoringPackage.HELPER__REFERENCE_TO_EATTRIBUTE_HELPER:
				return getReferenceToEAttributeHelper();
			case ERefactoringPackage.HELPER__REFERENCE_TO_EREFERENCE_HELPER:
				return getReferenceToEReferenceHelper();
			case ERefactoringPackage.HELPER__REFERENCE_TO_EPARAMETER_HELPER:
				return getReferenceToEParameterHelper();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ERefactoringPackage.HELPER__REFERENCE_TO_ENAMED_ELEMENT_HELPER:
				getReferenceToENamedElementHelper().clear();
				getReferenceToENamedElementHelper().addAll((Collection<? extends ENamedElement>)newValue);
				return;
			case ERefactoringPackage.HELPER__REFERENCE_TO_EOPERATION_HELPER:
				getReferenceToEOperationHelper().clear();
				getReferenceToEOperationHelper().addAll((Collection<? extends EOperation>)newValue);
				return;
			case ERefactoringPackage.HELPER__REFERENCE_TO_ECLASS_HELPER:
				getReferenceToEClassHelper().clear();
				getReferenceToEClassHelper().addAll((Collection<? extends EClass>)newValue);
				return;
			case ERefactoringPackage.HELPER__REFERENCE_TO_ECLASSIFIER_HELPER:
				getReferenceToEClassifierHelper().clear();
				getReferenceToEClassifierHelper().addAll((Collection<? extends EClass>)newValue);
				return;
			case ERefactoringPackage.HELPER__REFERENCE_TO_EATTRIBUTE_HELPER:
				getReferenceToEAttributeHelper().clear();
				getReferenceToEAttributeHelper().addAll((Collection<? extends EAttribute>)newValue);
				return;
			case ERefactoringPackage.HELPER__REFERENCE_TO_EREFERENCE_HELPER:
				getReferenceToEReferenceHelper().clear();
				getReferenceToEReferenceHelper().addAll((Collection<? extends EReference>)newValue);
				return;
			case ERefactoringPackage.HELPER__REFERENCE_TO_EPARAMETER_HELPER:
				getReferenceToEParameterHelper().clear();
				getReferenceToEParameterHelper().addAll((Collection<? extends EParameter>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ERefactoringPackage.HELPER__REFERENCE_TO_ENAMED_ELEMENT_HELPER:
				getReferenceToENamedElementHelper().clear();
				return;
			case ERefactoringPackage.HELPER__REFERENCE_TO_EOPERATION_HELPER:
				getReferenceToEOperationHelper().clear();
				return;
			case ERefactoringPackage.HELPER__REFERENCE_TO_ECLASS_HELPER:
				getReferenceToEClassHelper().clear();
				return;
			case ERefactoringPackage.HELPER__REFERENCE_TO_ECLASSIFIER_HELPER:
				getReferenceToEClassifierHelper().clear();
				return;
			case ERefactoringPackage.HELPER__REFERENCE_TO_EATTRIBUTE_HELPER:
				getReferenceToEAttributeHelper().clear();
				return;
			case ERefactoringPackage.HELPER__REFERENCE_TO_EREFERENCE_HELPER:
				getReferenceToEReferenceHelper().clear();
				return;
			case ERefactoringPackage.HELPER__REFERENCE_TO_EPARAMETER_HELPER:
				getReferenceToEParameterHelper().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ERefactoringPackage.HELPER__REFERENCE_TO_ENAMED_ELEMENT_HELPER:
				return referenceToENamedElementHelper != null && !referenceToENamedElementHelper.isEmpty();
			case ERefactoringPackage.HELPER__REFERENCE_TO_EOPERATION_HELPER:
				return referenceToEOperationHelper != null && !referenceToEOperationHelper.isEmpty();
			case ERefactoringPackage.HELPER__REFERENCE_TO_ECLASS_HELPER:
				return referenceToEClassHelper != null && !referenceToEClassHelper.isEmpty();
			case ERefactoringPackage.HELPER__REFERENCE_TO_ECLASSIFIER_HELPER:
				return referenceToEClassifierHelper != null && !referenceToEClassifierHelper.isEmpty();
			case ERefactoringPackage.HELPER__REFERENCE_TO_EATTRIBUTE_HELPER:
				return referenceToEAttributeHelper != null && !referenceToEAttributeHelper.isEmpty();
			case ERefactoringPackage.HELPER__REFERENCE_TO_EREFERENCE_HELPER:
				return referenceToEReferenceHelper != null && !referenceToEReferenceHelper.isEmpty();
			case ERefactoringPackage.HELPER__REFERENCE_TO_EPARAMETER_HELPER:
				return referenceToEParameterHelper != null && !referenceToEParameterHelper.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException {
		switch (operationID) {
			case ERefactoringPackage.HELPER___GET_ALL_CLASSES:
				return getAllClasses();
			case ERefactoringPackage.HELPER___GET_ALL_SUB_CLASSES__ECLASS:
				return getAllSubClasses((EClass)arguments.get(0));
			case ERefactoringPackage.HELPER___GET_CLASS__STRING:
				return getClass((String)arguments.get(0));
			case ERefactoringPackage.HELPER___GET_ATTRIBUTE_BY_NAME__ECLASS_STRING:
				return getAttributeByName((EClass)arguments.get(0), (String)arguments.get(1));
			case ERefactoringPackage.HELPER___REMOVE_ATTRIBUTE_BY_NAME__ECLASS_STRING:
				removeAttributeByName((EClass)arguments.get(0), (String)arguments.get(1));
				return null;
			case ERefactoringPackage.HELPER___GET_OPERATION_BY_NAME__ECLASS_STRING:
				return getOperationByName((EClass)arguments.get(0), (String)arguments.get(1));
			case ERefactoringPackage.HELPER___REMOVE_OPERATION_BY_NAME__ECLASS_STRING:
				removeOperationByName((EClass)arguments.get(0), (String)arguments.get(1));
				return null;
		}
		return super.eInvoke(operationID, arguments);
	}

} //HelperImpl
