/**
 */
package de.ubt.ai1.modGraph.example.eRefactoring.impl;

import java.lang.reflect.InvocationTargetException;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.regex.Pattern;

import javax.swing.JOptionPane;
import javax.swing.UIManager;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EParameter;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.xcore.lib.XcoreCollectionLiterals;
import org.eclipse.gmf.runtime.notation.BasicCompartment;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.Shape;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;

import com.google.common.base.Objects;

import de.ubt.ai1.modGraph.example.eRefactoring.ERefactoringPackage;
import de.ubt.ai1.modGraph.example.eRefactoring.Helper;
import de.ubt.ai1.modGraph.example.eRefactoring.Propagation;
import de.ubt.ai1.modGraph.example.eRefactoring.util.GTUtil4PropagationpropagateChangeBidirectionalToUnidirectionalReferenceGraphPattern;
import de.ubt.ai1.modGraph.example.eRefactoring.util.GTUtil4PropagationpropagateExtractClassInit;
import de.ubt.ai1.modgraph.gt.failure.GTFailure;
import de.ubt.ai1.modgraph.gt.gtEngine.GPBoundNode;
import de.ubt.ai1.modgraph.gt.gtEngine.GPElement;
import de.ubt.ai1.modgraph.gt.gtEngine.GPElementWithStatus;
import de.ubt.ai1.modgraph.gt.gtEngine.GPLink;
import de.ubt.ai1.modgraph.gt.gtEngine.GPNode;
import de.ubt.ai1.modgraph.gt.gtEngine.GPObject;
import de.ubt.ai1.modgraph.gt.gtEngine.GPUnboundNode;
import de.ubt.ai1.modgraph.gt.gtEngine.GTAttribute;
import de.ubt.ai1.modgraph.gt.gtEngine.GTEdge;
import de.ubt.ai1.modgraph.gt.gtEngine.GTField;
import de.ubt.ai1.modgraph.gt.gtEngine.GTFieldKind;
import de.ubt.ai1.modgraph.gt.gtEngine.GTGraphPattern;
import de.ubt.ai1.modgraph.gt.gtEngine.GTLink;
import de.ubt.ai1.modgraph.gt.gtEngine.GTNegativeApplicationCondition;
import de.ubt.ai1.modgraph.gt.gtEngine.GTNode;
import de.ubt.ai1.modgraph.gt.gtEngine.GTOperator;
import de.ubt.ai1.modgraph.gt.gtEngine.GTPath;
import de.ubt.ai1.modgraph.gt.gtEngine.GTStatus;
import de.ubt.ai1.modgraph.gt.gtEngine.GTThisObject;
import de.ubt.ai1.modgraph.gt.gtEngine.GraphTransformationRule;
import de.ubt.ai1.modgraph.gt.gtEngine.GtEngineFactory;
import de.ubt.ai1.modgraph.gt.gtEngine.NACBoundNode;
import de.ubt.ai1.modgraph.gt.gtEngine.NACElement;
import de.ubt.ai1.modgraph.gt.gtEngine.NACLink;
import de.ubt.ai1.modgraph.gt.gtEngine.NACNode;
import de.ubt.ai1.modgraph.gt.gtEngine.NACObject;
import de.ubt.ai1.modgraph.gt.gtEngine.NACParameter;
import java.lang.Iterable;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Propagation</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.impl.PropagationImpl#getRules <em>Rules</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.impl.PropagationImpl#getHelper <em>Helper</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class PropagationImpl extends MinimalEObjectImpl.Container implements
		Propagation {
	/**
	 * The cached value of the '{@link #getRules() <em>Rules</em>}' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getRules()
	 * @generated
	 * @ordered
	 */
	protected EList<GraphTransformationRule> rules;

	/**
	 * The cached value of the '{@link #getHelper() <em>Helper</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHelper()
	 * @generated
	 * @ordered
	 */
	protected Helper helper;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected PropagationImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ERefactoringPackage.Literals.PROPAGATION;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<GraphTransformationRule> getRules() {
		if (rules == null) {
			rules = new EObjectResolvingEList<GraphTransformationRule>(GraphTransformationRule.class, this, ERefactoringPackage.PROPAGATION__RULES);
		}
		return rules;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Helper getHelper() {
		if (helper != null && helper.eIsProxy()) {
			InternalEObject oldHelper = (InternalEObject)helper;
			helper = (Helper)eResolveProxy(oldHelper);
			if (helper != oldHelper) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ERefactoringPackage.PROPAGATION__HELPER, oldHelper, helper));
			}
		}
		return helper;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Helper basicGetHelper() {
		return helper;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setHelper(Helper newHelper) {
		Helper oldHelper = helper;
		helper = newHelper;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ERefactoringPackage.PROPAGATION__HELPER, oldHelper, helper));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String getNameFromURI(final EObject object) {
		URI objectURI = EcoreUtil.getURI(object);
		String fragment = objectURI.fragment();
		String[] temp = fragment.split("/");
		final String[] _converted_temp = (String[])temp;
		int _size = ((List<String>)org.eclipse.xtext.xbase.lib.Conversions.doWrapArray(_converted_temp)).size();
		int i = (_size - 1);
		return temp[i];
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String getSelectedFromDialog(final EList<String> pos,
			final String headding) {
		try {
			String _systemLookAndFeelClassName = UIManager.getSystemLookAndFeelClassName();
			UIManager.setLookAndFeel(_systemLookAndFeelClassName);
		}
		catch (final Throwable _t) {
			if (_t instanceof Exception) {
				final Exception e = (Exception)_t;
				System.out.println(("Error setting native look and feel: " + e));
			}
			else {
				throw Exceptions.sneakyThrow(_t);
			}
		}
		Object[] _array = pos.toArray();
		Object _showInputDialog = JOptionPane.showInputDialog(null, (headding + ":\n"), "Choose", JOptionPane.PLAIN_MESSAGE, 
			null, _array, null);
		String s = ((String) _showInputDialog);
		return s;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<GPElement> getNodesTypedOverClassFromPattern(EClass eClass,
			GTGraphPattern pattern) {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<NACElement> getNodesTypedOverClassFromNAC(EClass eClass,
			GTNegativeApplicationCondition nac) {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void cleanUpAndSave(final EList<EObject> objectsToRemove,
			final Object resObject) {
		Resource res = ((Resource) resObject);
		TreeIterator<EObject> iter = res.getAllContents();
		EList<EObject> nacsToRemove = XcoreCollectionLiterals.<EObject>newBasicEList();
		while (iter.hasNext()) {
			{
				EObject eObject = iter.next();
				if ((eObject instanceof GraphTransformationRule<?, ?>)) {
					EList _negativePattern = ((GraphTransformationRule) eObject).getNegativePattern();
					for (final Object nac : _negativePattern) {
						EList<NACElement> _elements = ((GTNegativeApplicationCondition) nac).getElements();
						boolean _isEmpty = _elements.isEmpty();
						if (_isEmpty) {
							nacsToRemove.add(((EObject) nac));
						}
					}
				}
			}
		}
		boolean _and = false;
		boolean _notEquals = (!Objects.equal(objectsToRemove, null));
		if (!_notEquals) {
			_and = false;
		} else {
			boolean _isEmpty = objectsToRemove.isEmpty();
			boolean _not = (!_isEmpty);
			_and = _not;
		}
		if (_and) {
			for (final EObject o : objectsToRemove) {
				EcoreUtil.remove(o);
			}
		}
		boolean _isEmpty_1 = nacsToRemove.isEmpty();
		boolean _not_1 = (!_isEmpty_1);
		if (_not_1) {
			for (final EObject o_1 : nacsToRemove) {
				EcoreUtil.remove(o_1);
			}
		}
		try {
			res.save(Collections.EMPTY_MAP);
		}
		catch (final Throwable _t) {
			if (_t instanceof Exception) {
				final Exception e = (Exception)_t;
				e.printStackTrace();
			}
			else {
				throw Exceptions.sneakyThrow(_t);
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void propagateChangeBidirectionalToUnidirectionalReference(
			final EReference delRef, final EReference formerOpposite,
			final GraphTransformationRule rule) {
		try {
			GTGraphPattern pattern = this.propagateChangeBidirectionalToUnidirectionalReferenceGraphPattern(delRef, formerOpposite, rule);
			EList _negativePattern = rule.getNegativePattern();
			for (final GTNegativeApplicationCondition nac : ((GTNegativeApplicationCondition[]) ((GTNegativeApplicationCondition[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_negativePattern, GTNegativeApplicationCondition.class)))) {
				this.propagateChangeBidirectionalToUnidirectionalReferenceNAC(formerOpposite, nac);
			}
		}
		catch (final Throwable _t) {
			if (_t instanceof Exception) {
				final Exception e = (Exception)_t;
				e.printStackTrace();
			}
			else {
				throw Exceptions.sneakyThrow(_t);
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --><!--
	 * 
	 * @generated NOT modified by ModGraph
	 */
	public GTGraphPattern propagateChangeBidirectionalToUnidirectionalReferenceGraphPattern(
			EReference delRef, EReference formerOpposite,
			GraphTransformationRule rule) throws GTFailure {
		GTUtil4PropagationpropagateChangeBidirectionalToUnidirectionalReferenceGraphPattern util = new GTUtil4PropagationpropagateChangeBidirectionalToUnidirectionalReferenceGraphPattern();
		try {
			util.match(delRef, formerOpposite, rule, this);
			GTGraphPattern graphPattern = (GTGraphPattern) util
					.get("graphPattern");
			GPLink delLink = (GPLink) util.get("delLink");
			GTNode node1 = (GTNode) util.get("node1");
			GTNode node2 = (GTNode) util.get("node2");
			EClass class1 = (EClass) util.get("class1");
			EClass class2 = (EClass) util.get("class2");
			final de.ubt.ai1.modgraph.gt.gtEngine.GTStatus linkStatusValue = delLink
					.getStatus();
			util.delete(delLink);
			GPLink link = GtEngineFactory.eINSTANCE.createGPLink();
			link.setStatus(linkStatusValue);
			link.setExReference(formerOpposite);
			link.setTargetNode(node1);
			link.setSourceNode(node2);
			graphPattern.getElements().add(link);
			return graphPattern;
		} catch (GTFailure fp) {
			return null;
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void propagateChangeBidirectionalToUnidirectionalReferenceNAC(
			EReference formerOpposite, GTNegativeApplicationCondition nac) {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void propagateHideDeleg_ReplDelegWInheritInit(
			final EClass sourceClass, final EClass targetClass,
			final GraphTransformationRule rule) {
		try {
			this.propagateHideDeleg_ReplDelegWInherit(sourceClass, targetClass, rule);
		}
		catch (final Throwable _t) {
			if (_t instanceof Exception) {
				final Exception e = (Exception)_t;
				e.printStackTrace();
			}
			else {
				throw Exceptions.sneakyThrow(_t);
			}
		}
		EList _negativePattern = rule.getNegativePattern();
		for (final Object nac : _negativePattern) {
			{
				GTNegativeApplicationCondition temp = ((GTNegativeApplicationCondition) nac);
				try {
					this.propagateHideDeleg_ReplDelegWInheritNAC(sourceClass, targetClass, temp);
				}
				catch (final Throwable _t_1) {
					if (_t_1 instanceof Exception) {
						final Exception e_1 = (Exception)_t_1;
						e_1.printStackTrace();
					}
					else {
						throw Exceptions.sneakyThrow(_t_1);
					}
				}
			}
		}
		Resource _eResource = rule.eResource();
		this.cleanUpAndSave(null, _eResource);
		EList<EObject> objectsToRemove = XcoreCollectionLiterals.<EObject>newBasicEList();
		Resource _eResource_1 = rule.eResource();
		TreeIterator<EObject> iter = _eResource_1.getAllContents();
		while (iter.hasNext()) {
			{
				EObject next = iter.next();
				boolean _and = false;
				if (!(next instanceof Edge)) {
					_and = false;
				} else {
					EObject _element = ((Edge) next).getElement();
					_and = (_element instanceof GraphTransformationRule);
				}
				if (_and) {
					objectsToRemove.add(next);
				}
			}
		}
		Resource _eResource_2 = rule.eResource();
		this.cleanUpAndSave(objectsToRemove, _eResource_2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void propagateHideDeleg_ReplDelegWInherit(EClass sourceClass,
			EClass targetClass, GraphTransformationRule rule) {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void propagateHideDeleg_ReplDelegWInheritNAC(EClass sourceClass,
			EClass targetClass, GTNegativeApplicationCondition nac) {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void propagateRemoveMidMan_ReplInheritWDelegInit(
			final EReference reference, final EClass sourceClass,
			final EClass targetClass, final GraphTransformationRule rule) {
		try {
			this.propagateRemoveMidMan_ReplInheritWDeleg(reference, sourceClass, targetClass, rule);
		}
		catch (final Throwable _t) {
			if (_t instanceof Exception) {
				final Exception e = (Exception)_t;
				e.printStackTrace();
			}
			else {
				throw Exceptions.sneakyThrow(_t);
			}
		}
		EList _negativePattern = rule.getNegativePattern();
		for (final Object nac : _negativePattern) {
			{
				GTNegativeApplicationCondition temp = ((GTNegativeApplicationCondition) nac);
				try {
					this.propagateRemoveMidMan_ReplInheritWDelegNAC(reference, sourceClass, targetClass, temp);
				}
				catch (final Throwable _t_1) {
					if (_t_1 instanceof Exception) {
						final Exception e_1 = (Exception)_t_1;
						e_1.printStackTrace();
					}
					else {
						throw Exceptions.sneakyThrow(_t_1);
					}
				}
			}
		}
		Resource _eResource = rule.eResource();
		this.cleanUpAndSave(null, _eResource);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void propagateRemoveMidMan_ReplInheritWDeleg(
			final EReference reference, final EClass sourceClass,
			final EClass targetClass, final GraphTransformationRule rule) {
		GTGraphPattern _pattern = rule.getPattern();
		EList<GPElement> patternElements = _pattern.getElements();
		GTNode sourceNodePattern = null;
		GTNode targetNodePattern = null;
		String sourceClassName = sourceClass.getName();
		String targetClassName = targetClass.getName();
		for (final GPElement gpe : patternElements) {
			boolean _and = false;
			if (!(gpe instanceof GTThisObject)) {
				_and = false;
			} else {
				EObject _type = ((GTThisObject) gpe).getType();
				String _name = ((EClass) _type).getName();
				boolean _equals = _name.equals(sourceClassName);
				_and = _equals;
			}
			if (_and) {
				sourceNodePattern = ((GTNode) gpe);
			}
			else {
				boolean _and_1 = false;
				if (!(gpe instanceof GPUnboundNode)) {
					_and_1 = false;
				} else {
					EObject _type_1 = ((GPUnboundNode) gpe).getType();
					String _name_1 = ((EClass) _type_1).getName();
					boolean _equals_1 = _name_1.equals(sourceClassName);
					_and_1 = _equals_1;
				}
				if (_and_1) {
					sourceNodePattern = ((GTNode) gpe);
				}
				else {
					boolean _and_2 = false;
					if (!(gpe instanceof GPBoundNode)) {
						_and_2 = false;
					} else {
						EObject _type_2 = ((GPBoundNode) gpe).getType();
						String _name_2 = ((EClass) _type_2).getName();
						boolean _equals_2 = _name_2.equals(sourceClassName);
						_and_2 = _equals_2;
					}
					if (_and_2) {
						sourceNodePattern = ((GTNode) gpe);
					}
					else {
						boolean _and_3 = false;
						if (!(gpe instanceof GTThisObject)) {
							_and_3 = false;
						} else {
							EObject _type_3 = ((GTThisObject) gpe).getType();
							String _name_3 = ((EClass) _type_3).getName();
							boolean _equals_3 = _name_3.equals(targetClassName);
							_and_3 = _equals_3;
						}
						if (_and_3) {
							targetNodePattern = ((GTNode) gpe);
						}
						else {
							boolean _and_4 = false;
							if (!(gpe instanceof GPUnboundNode)) {
								_and_4 = false;
							} else {
								EObject _type_4 = ((GPUnboundNode) gpe).getType();
								String _name_4 = ((EClass) _type_4).getName();
								boolean _equals_4 = _name_4.equals(targetClassName);
								_and_4 = _equals_4;
							}
							if (_and_4) {
								targetNodePattern = ((GTNode) gpe);
							}
							else {
								boolean _and_5 = false;
								if (!(gpe instanceof GPBoundNode)) {
									_and_5 = false;
								} else {
									EObject _type_5 = ((GPBoundNode) gpe).getType();
									String _name_5 = ((EClass) _type_5).getName();
									boolean _equals_5 = _name_5.equals(targetClassName);
									_and_5 = _equals_5;
								}
								if (_and_5) {
									targetNodePattern = ((GTNode) gpe);
								}
							}
						}
					}
				}
			}
		}
		boolean _and_6 = false;
		boolean _notEquals = (!Objects.equal(sourceNodePattern, null));
		if (!_notEquals) {
			_and_6 = false;
		} else {
			boolean _notEquals_1 = (!Objects.equal(targetNodePattern, null));
			_and_6 = _notEquals_1;
		}
		if (_and_6) {
			GPLink newLink = GtEngineFactory.eINSTANCE.<EObject>createGPLink();
			newLink.setExReference(reference);
			newLink.setSourceNode(sourceNodePattern);
			newLink.setTargetNode(targetNodePattern);
			if ((targetNodePattern instanceof GPElementWithStatus)) {
				GTStatus status = ((GPElementWithStatus) targetNodePattern).getStatus();
				String _name_6 = status.getName();
				boolean _equals_6 = _name_6.equals("CREATE");
				if (_equals_6) {
					newLink.setStatus(GTStatus.CREATE);
				}
				String _name_7 = status.getName();
				boolean _equals_7 = _name_7.equals("DELETE");
				if (_equals_7) {
					newLink.setStatus(GTStatus.DELETE);
				}
			}
			patternElements.add(newLink);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void propagateRemoveMidMan_ReplInheritWDelegNAC(
			EReference reference, EClass sourceClass, EClass targetClass,
			GTNegativeApplicationCondition nac) {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EObject> propagateExtractClassNEW(final EClass extractedClass,
			final EClass existingClass, final GraphTransformationRule rule) {
		GTGraphPattern pattern = rule.getPattern();
		EList<EObject> objectsToRemove = XcoreCollectionLiterals.<EObject>newBasicEList();
		GTNode existingNode = null;
		EList<GTField> gTFields = XcoreCollectionLiterals.<GTField>newBasicEList();
		EList<GTAttribute> gTAttributes = XcoreCollectionLiterals.<GTAttribute>newBasicEList();
		EList<GPLink> gTInLinks = XcoreCollectionLiterals.<GPLink>newBasicEList();
		EList<GPLink> gTOutLinks = XcoreCollectionLiterals.<GPLink>newBasicEList();
		EList<GPElement> _elements = pattern.getElements();
		for (final GPElement gpu : _elements) {
			boolean _and = false;
			if (!(gpu instanceof GPUnboundNode)) {
				_and = false;
			} else {
				EObject _type = ((GPUnboundNode) gpu).getType();
				String _name = ((EClass) _type).getName();
				String _name_1 = existingClass.getName();
				boolean _equals = _name.equals(_name_1);
				_and = _equals;
			}
			if (_and) {
				existingNode = ((GPUnboundNode) gpu);
			}
			else {
				boolean _and_1 = false;
				if (!(gpu instanceof GTThisObject)) {
					_and_1 = false;
				} else {
					EObject _type_1 = ((GTThisObject) gpu).getType();
					String _name_2 = ((EClass) _type_1).getName();
					String _name_3 = existingClass.getName();
					boolean _equals_1 = _name_2.equals(_name_3);
					_and_1 = _equals_1;
				}
				if (_and_1) {
					existingNode = ((GTThisObject) gpu);
				}
			}
		}
		boolean _notEquals = (!Objects.equal(existingNode, null));
		if (_notEquals) {
			EList<EAttribute> _eAttributes = extractedClass.getEAttributes();
			for (final EAttribute ea : _eAttributes) {
				EList<GTAttribute<?>> _attributes = existingNode.getAttributes();
				for (final GTAttribute gta : _attributes) {
					boolean _and_2 = false;
					EObject _exAttribute = gta.getExAttribute();
					boolean _eIsProxy = _exAttribute.eIsProxy();
					if (!_eIsProxy) {
						_and_2 = false;
					} else {
						EObject _exAttribute_1 = gta.getExAttribute();
						String _nameFromURI = this.getNameFromURI(_exAttribute_1);
						String _name_4 = ea.getName();
						boolean _equals_2 = _nameFromURI.equals(_name_4);
						_and_2 = _equals_2;
					}
					if (_and_2) {
						gTAttributes.add(gta);
					}
				}
			}
			EList<EOperation> _eOperations = extractedClass.getEOperations();
			for (final EOperation eo : _eOperations) {
				EList<GTField> _fields = existingNode.getFields();
				for (final GTField gtf : _fields) {
					GTFieldKind _kind = gtf.getKind();
					String _name_5 = _kind.getName();
					boolean _equals_3 = _name_5.equals("OPERATION_CALL");
					if (_equals_3) {
						String content = gtf.getContent();
						String _quote = Pattern.quote("(");
						String[] _split = content.split(_quote);
						String operationName = _split[0];
						String _name_6 = eo.getName();
						boolean _equals_4 = operationName.equals(_name_6);
						if (_equals_4) {
							gTFields.add(gtf);
						}
					}
				}
			}
			EList<EReference> _eReferences = extractedClass.getEReferences();
			for (final EReference er : _eReferences) {
				{
					EList<GTEdge> _outgoingEdges = existingNode.getOutgoingEdges();
					final Function1<GTEdge, Boolean> _function = new Function1<GTEdge, Boolean>() {
						public Boolean apply(final GTEdge e) {
							return Boolean.valueOf((e instanceof GPLink));
						}
					};
					Iterable<GTEdge> _filter = IterableExtensions.<GTEdge>filter(_outgoingEdges, _function);
					for (final GPLink gtl : ((GPLink[]) ((GPLink[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter, GPLink.class)))) {
						boolean _and_3 = false;
						EObject _exReference = gtl.getExReference();
						boolean _eIsProxy_1 = _exReference.eIsProxy();
						if (!_eIsProxy_1) {
							_and_3 = false;
						} else {
							EObject _exReference_1 = gtl.getExReference();
							String _nameFromURI_1 = this.getNameFromURI(_exReference_1);
							String _name_7 = er.getName();
							boolean _equals_5 = _nameFromURI_1.equals(_name_7);
							_and_3 = _equals_5;
						}
						if (_and_3) {
							gTOutLinks.add(gtl);
						}
					}
					EList<GTEdge> _incomingEdges = existingNode.getIncomingEdges();
					final Function1<GTEdge, Boolean> _function_1 = new Function1<GTEdge, Boolean>() {
						public Boolean apply(final GTEdge e) {
							return Boolean.valueOf((e instanceof GPLink));
						}
					};
					Iterable<GTEdge> _filter_1 = IterableExtensions.<GTEdge>filter(_incomingEdges, _function_1);
					for (final GPLink gtl_1 : ((GPLink[]) ((GPLink[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter_1, GPLink.class)))) {
						boolean _and_4 = false;
						EObject _exReference_2 = gtl_1.getExReference();
						boolean _eIsProxy_2 = _exReference_2.eIsProxy();
						if (!_eIsProxy_2) {
							_and_4 = false;
						} else {
							EObject _exReference_3 = gtl_1.getExReference();
							String _nameFromURI_2 = this.getNameFromURI(_exReference_3);
							String _name_8 = er.getName();
							boolean _equals_6 = _nameFromURI_2.equals(_name_8);
							_and_4 = _equals_6;
						}
						if (_and_4) {
							gTInLinks.add(gtl_1);
						}
					}
				}
			}
			try {
				boolean _or = false;
				boolean _or_1 = false;
				boolean _or_2 = false;
				boolean _isEmpty = gTAttributes.isEmpty();
				boolean _not = (!_isEmpty);
				if (_not) {
					_or_2 = true;
				} else {
					boolean _isEmpty_1 = gTFields.isEmpty();
					boolean _not_1 = (!_isEmpty_1);
					_or_2 = _not_1;
				}
				if (_or_2) {
					_or_1 = true;
				} else {
					boolean _isEmpty_2 = gTInLinks.isEmpty();
					boolean _not_2 = (!_isEmpty_2);
					_or_1 = _not_2;
				}
				if (_or_1) {
					_or = true;
				} else {
					boolean _isEmpty_3 = gTOutLinks.isEmpty();
					boolean _not_3 = (!_isEmpty_3);
					_or = _not_3;
				}
				if (_or) {
					this.propagateExtractClassSF(extractedClass, existingClass, rule, ((GPNode) existingNode), gTAttributes, gTInLinks, gTOutLinks, gTFields);
				}
			}
			catch (final Throwable _t) {
				if (_t instanceof GTFailure) {
					final GTFailure f = (GTFailure)_t;
				}
				else {
					throw Exceptions.sneakyThrow(_t);
				}
			}
			this.markShapesToRemove(rule, ((EList) gTAttributes), objectsToRemove);
			this.markShapesToRemove(rule, ((EList) gTFields), objectsToRemove);
			EList<EObject> changedFeatures = new BasicEList<EObject>(gTAttributes);
			changedFeatures.addAll(gTFields);
			changedFeatures.addAll(gTInLinks);
			changedFeatures.addAll(gTOutLinks);
			return changedFeatures;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GPNode propagateExtractClassSF(EClass extractedClass, EClass existingClass, GraphTransformationRule rule, GPNode node, EList<GTAttribute> gTAttributes, EList<GPLink> gTInLinks, EList<GPLink> gTOutLinks, EList<GTField> gTFields) {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GPNode propagateExtractClassSFNAC(EClass extractedClass, EClass existingClass, GTNegativeApplicationCondition nac, NACNode node, EList<GTAttribute> gTAttributes, EList<NACLink> gtInLinks, EList<NACLink> gTOutLinks, EList<GTField> gTFields) {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --><!--
	 * 
	 * @generated NOT modified by ModGraph
	 */
	public GPNode propagateExtractClassInit(EClass extractedClass,
			EClass existingClass, GraphTransformationRule rule,
			EList<GTAttribute> tempGTA, EList<GPLink> tempGTiL,
			EList<GPLink> tempGToL, EList<GTField> tempGTF) throws GTFailure {
		GTUtil4PropagationpropagateExtractClassInit util = new GTUtil4PropagationpropagateExtractClassInit();
		try {
			util.match(extractedClass, existingClass, rule, tempGTA, tempGTiL,
					tempGToL, tempGTF, this);
			EReference createdReference = (EReference) util
					.get("createdReference");
			GTGraphPattern pattern = (GTGraphPattern) util.get("pattern");
			GPNode node = (GPNode) util.get("node");
			final de.ubt.ai1.modgraph.gt.gtEngine.GTStatus newNodeStatusValue = node
					.getStatus();
			final java.lang.String newNodeNameValue = "newNode";
			final de.ubt.ai1.modgraph.gt.gtEngine.GTStatus newLinkStatusValue = node
					.getStatus();
			GPObject newNode = GtEngineFactory.eINSTANCE.createGPObject();
			newNode.setStatus(newNodeStatusValue);
			newNode.setName(newNodeNameValue);
			GPLink newLink = GtEngineFactory.eINSTANCE.createGPLink();
			newLink.setStatus(newLinkStatusValue);
			newNode.setType(extractedClass);
			newNode.getIncomingEdges().add(newLink);
			node.getOutgoingEdges().add(newLink);
			newLink.setExReference(createdReference);
			pattern.getElements().add(newNode);
			newNode.getFields().addAll(tempGTF);
			newNode.getAttributes().addAll((Collection<? extends GTAttribute<?>>) tempGTA);
			newNode.getIncomingEdges().addAll(tempGTiL);
			newNode.getOutgoingEdges().addAll(tempGToL);
			pattern.getElements().add(newLink);
			return newNode;
		} catch (GTFailure fp) {
			return null;
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EObject> propagateExtractClass(final EClass extractedClass,
			final EClass existingClass, final GraphTransformationRule rule) {
		GTGraphPattern pattern = rule.getPattern();
		EList<EObject> objectsToRemove = XcoreCollectionLiterals.<EObject>newBasicEList();
		GTNode existingNode = null;
		EList<GPElement> _elements = pattern.getElements();
		for (final GPElement gpu : _elements) {
			boolean _and = false;
			if (!(gpu instanceof GPUnboundNode)) {
				_and = false;
			} else {
				EObject _type = ((GPUnboundNode) gpu).getType();
				String _name = ((EClass) _type).getName();
				String _name_1 = existingClass.getName();
				boolean _equals = _name.equals(_name_1);
				_and = _equals;
			}
			if (_and) {
				existingNode = ((GPUnboundNode) gpu);
			}
			else {
				boolean _and_1 = false;
				if (!(gpu instanceof GTThisObject)) {
					_and_1 = false;
				} else {
					EObject _type_1 = ((GTThisObject) gpu).getType();
					String _name_2 = ((EClass) _type_1).getName();
					String _name_3 = existingClass.getName();
					boolean _equals_1 = _name_2.equals(_name_3);
					_and_1 = _equals_1;
				}
				if (_and_1) {
					existingNode = ((GTThisObject) gpu);
				}
			}
		}
		boolean _notEquals = (!Objects.equal(existingNode, null));
		if (_notEquals) {
			GPObject newGPObject = GtEngineFactory.eINSTANCE.<EObject>createGPObject();
			newGPObject.setType(extractedClass);
			String _name_4 = extractedClass.getName();
			newGPObject.setName(_name_4);
			EList<GPElement> _elements_1 = pattern.getElements();
			_elements_1.add(newGPObject);
			EList<EObject> tempGTA = XcoreCollectionLiterals.<EObject>newBasicEList();
			EList<EAttribute> _eAttributes = extractedClass.getEAttributes();
			for (final EAttribute ea : _eAttributes) {
				EList<GTAttribute<?>> _attributes = existingNode.getAttributes();
				for (final GTAttribute gta : _attributes) {
					boolean _and_2 = false;
					EObject _exAttribute = gta.getExAttribute();
					boolean _eIsProxy = _exAttribute.eIsProxy();
					if (!_eIsProxy) {
						_and_2 = false;
					} else {
						EObject _exAttribute_1 = gta.getExAttribute();
						String _nameFromURI = this.getNameFromURI(_exAttribute_1);
						String _name_5 = ea.getName();
						boolean _equals_2 = _nameFromURI.equals(_name_5);
						_and_2 = _equals_2;
					}
					if (_and_2) {
						tempGTA.add(gta);
						gta.setExAttribute(ea);
					}
				}
			}
			EList _attributes_1 = newGPObject.getAttributes();
			_attributes_1.addAll(tempGTA);
			this.markShapesToRemove(rule, tempGTA, objectsToRemove);
			EList<EObject> tempGTF = XcoreCollectionLiterals.<EObject>newBasicEList();
			EList<EOperation> _eOperations = extractedClass.getEOperations();
			for (final EOperation eo : _eOperations) {
				EList<GTField> _fields = existingNode.getFields();
				for (final GTField gtf : _fields) {
					GTFieldKind _kind = gtf.getKind();
					String _name_6 = _kind.getName();
					boolean _equals_3 = _name_6.equals("OPERATION_CALL");
					if (_equals_3) {
						String content = gtf.getContent();
						String _quote = Pattern.quote("(");
						String[] _split = content.split(_quote);
						String operationName = _split[0];
						String _name_7 = eo.getName();
						boolean _equals_4 = operationName.equals(_name_7);
						if (_equals_4) {
							tempGTF.add(gtf);
						}
					}
				}
			}
			EList _fields_1 = newGPObject.getFields();
			_fields_1.addAll(tempGTF);
			this.markShapesToRemove(rule, tempGTF, objectsToRemove);
			EList<EReference> _eReferences = existingClass.getEReferences();
			for (final EReference er : _eReferences) {
				String _name_8 = er.getName();
				String _name_9 = extractedClass.getName();
				boolean _equals_5 = _name_8.equals(_name_9);
				if (_equals_5) {
					GPLink newGPLink = GtEngineFactory.eINSTANCE.<EObject>createGPLink();
					newGPLink.setExReference(er);
					newGPLink.setSourceNode(existingNode);
					newGPLink.setTargetNode(newGPObject);
					newGPLink.setStatus(GTStatus.PRESERVE);
					EList<GTEdge> _outgoingEdges = existingNode.getOutgoingEdges();
					_outgoingEdges.add(newGPLink);
					EList _incomingEdges = newGPObject.getIncomingEdges();
					_incomingEdges.add(newGPLink);
					EList<GPElement> _elements_2 = pattern.getElements();
					_elements_2.add(newGPLink);
				}
			}
		}
		EList<GTNegativeApplicationCondition> nacList = rule.getNegativePattern();
		for (final GTNegativeApplicationCondition nac : nacList) {
			{
				NACNode sourceNodeNAC = null;
				EList<NACElement> _elements_3 = nac.getElements();
				for (final NACElement nacNode : _elements_3) {
					boolean _and_3 = false;
					if (!(nacNode instanceof NACBoundNode)) {
						_and_3 = false;
					} else {
						GPUnboundNode _gPUnboundNode = ((NACBoundNode) nacNode).getGPUnboundNode();
						EObject _type_2 = _gPUnboundNode.getType();
						String _name_10 = ((EClass) _type_2).getName();
						String _name_11 = existingClass.getName();
						boolean _equals_6 = _name_10.equals(_name_11);
						_and_3 = _equals_6;
					}
					if (_and_3) {
						sourceNodeNAC = ((NACNode) nacNode);
					}
					else {
						boolean _and_4 = false;
						if (!(nacNode instanceof NACObject)) {
							_and_4 = false;
						} else {
							EObject _type_3 = ((NACObject) nacNode).getType();
							String _name_12 = ((EClass) _type_3).getName();
							String _name_13 = existingClass.getName();
							boolean _equals_7 = _name_12.equals(_name_13);
							_and_4 = _equals_7;
						}
						if (_and_4) {
							sourceNodeNAC = ((NACNode) nacNode);
						}
						else {
							boolean _and_5 = false;
							if (!(nacNode instanceof GTThisObject)) {
								_and_5 = false;
							} else {
								EObject _type_4 = ((GTThisObject) nacNode).getType();
								String _name_14 = ((EClass) _type_4).getName();
								String _name_15 = existingClass.getName();
								boolean _equals_8 = _name_14.equals(_name_15);
								_and_5 = _equals_8;
							}
							if (_and_5) {
								sourceNodeNAC = ((NACNode) nacNode);
							}
						}
					}
				}
				boolean _notEquals_1 = (!Objects.equal(sourceNodeNAC, null));
				if (_notEquals_1) {
					NACObject newNACObject = GtEngineFactory.eINSTANCE.<EObject>createNACObject();
					String _name_16 = extractedClass.getName();
					newNACObject.setName(_name_16);
					newNACObject.setType(extractedClass);
					EList<NACElement> _elements_4 = nac.getElements();
					_elements_4.add(newNACObject);
					EList<EObject> tempGTA_1 = XcoreCollectionLiterals.<EObject>newBasicEList();
					EList<EAttribute> _eAttributes_1 = extractedClass.getEAttributes();
					for (final EAttribute ea_1 : _eAttributes_1) {
						EList<GTAttribute<?>> _attributes_2 = sourceNodeNAC.getAttributes();
						for (final GTAttribute gta_1 : _attributes_2) {
							boolean _and_6 = false;
							EObject _exAttribute_2 = gta_1.getExAttribute();
							boolean _eIsProxy_1 = _exAttribute_2.eIsProxy();
							if (!_eIsProxy_1) {
								_and_6 = false;
							} else {
								EObject _exAttribute_3 = gta_1.getExAttribute();
								String _nameFromURI_1 = this.getNameFromURI(_exAttribute_3);
								String _name_17 = ea_1.getName();
								boolean _equals_9 = _nameFromURI_1.equals(_name_17);
								_and_6 = _equals_9;
							}
							if (_and_6) {
								tempGTA_1.add(gta_1);
								gta_1.setExAttribute(ea_1);
							}
						}
					}
					EList _attributes_3 = newNACObject.getAttributes();
					_attributes_3.addAll(tempGTA_1);
					this.markShapesToRemove(rule, tempGTA_1, objectsToRemove);
					EList<EReference> _eReferences_1 = existingClass.getEReferences();
					for (final EReference er_1 : _eReferences_1) {
						String _name_18 = er_1.getName();
						String _name_19 = extractedClass.getName();
						boolean _equals_10 = _name_18.equals(_name_19);
						if (_equals_10) {
							NACLink newNACLink = GtEngineFactory.eINSTANCE.<EObject>createNACLink();
							newNACLink.setExReference(er_1);
							newNACLink.setSourceNode(sourceNodeNAC);
							newNACLink.setTargetNode(newNACObject);
							EList<GTEdge> _outgoingEdges_1 = sourceNodeNAC.getOutgoingEdges();
							_outgoingEdges_1.add(newNACLink);
							EList _incomingEdges_1 = newNACObject.getIncomingEdges();
							_incomingEdges_1.add(newNACLink);
							EList<NACElement> _elements_5 = nac.getElements();
							_elements_5.add(newNACLink);
						}
					}
				}
			}
		}
		return objectsToRemove;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void markShapesToRemove(final GraphTransformationRule rule,
			final EList<EObject> elements, final EList<EObject> objectsToRemove) {
		Resource res = rule.eResource();
		TreeIterator<EObject> iter2 = res.getAllContents();
		while (iter2.hasNext()) {
			{
				EObject eObject = iter2.next();
				boolean _and = false;
				if (!(eObject instanceof Shape)) {
					_and = false;
				} else {
					EObject _element = ((Shape) eObject).getElement();
					boolean _contains = elements.contains(_element);
					_and = _contains;
				}
				if (_and) {
					objectsToRemove.add(((Shape) eObject));
				}
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EObject> propagateExtractSubClass(final EClass extractedClass,
			final EClass existingClass, final GraphTransformationRule rule) {
		GTGraphPattern pattern = rule.getPattern();
		EList<EObject> objectsToRemove = XcoreCollectionLiterals.<EObject>newBasicEList();
		GTNode existingNode = null;
		EList<GPElement> _elements = pattern.getElements();
		for (final GPElement gpu : _elements) {
			boolean _and = false;
			if (!(gpu instanceof GPUnboundNode)) {
				_and = false;
			} else {
				EObject _type = ((GPUnboundNode) gpu).getType();
				String _name = ((EClass) _type).getName();
				String _name_1 = existingClass.getName();
				boolean _equals = _name.equals(_name_1);
				_and = _equals;
			}
			if (_and) {
				existingNode = ((GPUnboundNode) gpu);
			}
			else {
				boolean _and_1 = false;
				if (!(gpu instanceof GTThisObject)) {
					_and_1 = false;
				} else {
					EObject _type_1 = ((GTThisObject) gpu).getType();
					String _name_2 = ((EClass) _type_1).getName();
					String _name_3 = existingClass.getName();
					boolean _equals_1 = _name_2.equals(_name_3);
					_and_1 = _equals_1;
				}
				if (_and_1) {
					existingNode = ((GTThisObject) gpu);
				}
			}
		}
		boolean _notEquals = (!Objects.equal(existingNode, null));
		if (_notEquals) {
			GPObject newGPObject = GtEngineFactory.eINSTANCE.<EObject>createGPObject();
			newGPObject.setType(extractedClass);
			String _name_4 = extractedClass.getName();
			newGPObject.setName(_name_4);
			EList<GPElement> _elements_1 = pattern.getElements();
			_elements_1.add(newGPObject);
			EList<EObject> tempGTA = XcoreCollectionLiterals.<EObject>newBasicEList();
			EList<EAttribute> _eAttributes = extractedClass.getEAttributes();
			for (final EAttribute ea : _eAttributes) {
				EList<GTAttribute<?>> _attributes = existingNode.getAttributes();
				for (final GTAttribute gta : _attributes) {
					boolean _and_2 = false;
					EObject _exAttribute = gta.getExAttribute();
					boolean _eIsProxy = _exAttribute.eIsProxy();
					if (!_eIsProxy) {
						_and_2 = false;
					} else {
						EObject _exAttribute_1 = gta.getExAttribute();
						String _nameFromURI = this.getNameFromURI(_exAttribute_1);
						String _name_5 = ea.getName();
						boolean _equals_2 = _nameFromURI.equals(_name_5);
						_and_2 = _equals_2;
					}
					if (_and_2) {
						tempGTA.add(gta);
						gta.setExAttribute(ea);
					}
				}
			}
			EList _attributes_1 = newGPObject.getAttributes();
			_attributes_1.addAll(tempGTA);
			this.markShapesToRemove(rule, tempGTA, objectsToRemove);
			EList<EObject> tempGTF = XcoreCollectionLiterals.<EObject>newBasicEList();
			EList<EOperation> _eOperations = extractedClass.getEOperations();
			for (final EOperation eo : _eOperations) {
				EList<GTField> _fields = existingNode.getFields();
				for (final GTField gtf : _fields) {
					GTFieldKind _kind = gtf.getKind();
					String _name_6 = _kind.getName();
					boolean _equals_3 = _name_6.equals("OPERATION_CALL");
					if (_equals_3) {
						String content = gtf.getContent();
						String _quote = Pattern.quote("(");
						String[] _split = content.split(_quote);
						String operationName = _split[0];
						String _name_7 = eo.getName();
						boolean _equals_4 = operationName.equals(_name_7);
						if (_equals_4) {
							tempGTF.add(gtf);
						}
					}
				}
			}
			EList _fields_1 = newGPObject.getFields();
			_fields_1.addAll(tempGTF);
			this.markShapesToRemove(rule, tempGTF, objectsToRemove);
		}
		EList<GTNegativeApplicationCondition> nacList = rule.getNegativePattern();
		for (final GTNegativeApplicationCondition nac : nacList) {
			{
				NACNode sourceNodeNAC = null;
				EList<NACElement> _elements_2 = nac.getElements();
				for (final NACElement nacNode : _elements_2) {
					boolean _and_3 = false;
					if (!(nacNode instanceof NACBoundNode)) {
						_and_3 = false;
					} else {
						GPUnboundNode _gPUnboundNode = ((NACBoundNode) nacNode).getGPUnboundNode();
						EObject _type_2 = _gPUnboundNode.getType();
						String _name_8 = ((EClass) _type_2).getName();
						String _name_9 = existingClass.getName();
						boolean _equals_5 = _name_8.equals(_name_9);
						_and_3 = _equals_5;
					}
					if (_and_3) {
						sourceNodeNAC = ((NACNode) nacNode);
					}
					else {
						boolean _and_4 = false;
						if (!(nacNode instanceof NACObject)) {
							_and_4 = false;
						} else {
							EObject _type_3 = ((NACObject) nacNode).getType();
							String _name_10 = ((EClass) _type_3).getName();
							String _name_11 = existingClass.getName();
							boolean _equals_6 = _name_10.equals(_name_11);
							_and_4 = _equals_6;
						}
						if (_and_4) {
							sourceNodeNAC = ((NACNode) nacNode);
						}
						else {
							boolean _and_5 = false;
							if (!(nacNode instanceof GTThisObject)) {
								_and_5 = false;
							} else {
								EObject _type_4 = ((GTThisObject) nacNode).getType();
								String _name_12 = ((EClass) _type_4).getName();
								String _name_13 = existingClass.getName();
								boolean _equals_7 = _name_12.equals(_name_13);
								_and_5 = _equals_7;
							}
							if (_and_5) {
								sourceNodeNAC = ((NACNode) nacNode);
							}
						}
					}
				}
				boolean _notEquals_1 = (!Objects.equal(sourceNodeNAC, null));
				if (_notEquals_1) {
					NACObject newNACObject = GtEngineFactory.eINSTANCE.<EObject>createNACObject();
					String _name_14 = extractedClass.getName();
					newNACObject.setName(_name_14);
					newNACObject.setType(extractedClass);
					EList<NACElement> _elements_3 = nac.getElements();
					_elements_3.add(newNACObject);
					EList<EObject> tempGTA_1 = XcoreCollectionLiterals.<EObject>newBasicEList();
					EList<EAttribute> _eAttributes_1 = extractedClass.getEAttributes();
					for (final EAttribute ea_1 : _eAttributes_1) {
						EList<GTAttribute<?>> _attributes_2 = sourceNodeNAC.getAttributes();
						for (final GTAttribute gta_1 : _attributes_2) {
							boolean _and_6 = false;
							EObject _exAttribute_2 = gta_1.getExAttribute();
							boolean _eIsProxy_1 = _exAttribute_2.eIsProxy();
							if (!_eIsProxy_1) {
								_and_6 = false;
							} else {
								EObject _exAttribute_3 = gta_1.getExAttribute();
								String _nameFromURI_1 = this.getNameFromURI(_exAttribute_3);
								String _name_15 = ea_1.getName();
								boolean _equals_8 = _nameFromURI_1.equals(_name_15);
								_and_6 = _equals_8;
							}
							if (_and_6) {
								tempGTA_1.add(gta_1);
								gta_1.setExAttribute(ea_1);
							}
						}
					}
					EList _attributes_3 = newNACObject.getAttributes();
					_attributes_3.addAll(tempGTA_1);
					this.markShapesToRemove(rule, tempGTA_1, objectsToRemove);
				}
			}
		}
		return objectsToRemove;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EObject> propagateInlineClass_CollapseHierarchy(
			final EClass sourceClass, final EClass targetClass,
			final GraphTransformationRule rule,
			final EList<EObject> objectsToRemove) {
		EObject _implementedOperation = rule.getImplementedOperation();
		boolean _eIsProxy = _implementedOperation.eIsProxy();
		if (_eIsProxy) {
			EObject _implementedOperation_1 = rule.getImplementedOperation();
			String implOpName = this.getNameFromURI(_implementedOperation_1);
			EList<EOperation> _eOperations = targetClass.getEOperations();
			for (final EOperation o : _eOperations) {
				String _name = o.getName();
				boolean _equals = _name.equals(implOpName);
				if (_equals) {
					rule.setCorrespondingClass(targetClass);
					rule.setImplementedOperation(o);
				}
			}
		}
		GTGraphPattern pattern = rule.getPattern();
		GPElement sourceNode = null;
		GPElement targetNode = null;
		EList<GPElement> _elements = pattern.getElements();
		for (final GPElement gtNode : _elements) {
			boolean _and = false;
			if (!(gtNode instanceof GPUnboundNode)) {
				_and = false;
			} else {
				EObject _type = ((GPUnboundNode) gtNode).getType();
				boolean _eIsProxy_1 = _type.eIsProxy();
				_and = _eIsProxy_1;
			}
			if (_and) {
				sourceNode = gtNode;
			}
			else {
				boolean _and_1 = false;
				if (!(gtNode instanceof GTThisObject)) {
					_and_1 = false;
				} else {
					EObject _type_1 = ((GTThisObject) gtNode).getType();
					boolean _eIsProxy_2 = _type_1.eIsProxy();
					_and_1 = _eIsProxy_2;
				}
				if (_and_1) {
					sourceNode = gtNode;
				}
				else {
					boolean _and_2 = false;
					if (!(gtNode instanceof GPBoundNode)) {
						_and_2 = false;
					} else {
						EObject _type_2 = ((GPBoundNode) gtNode).getType();
						boolean _eIsProxy_3 = _type_2.eIsProxy();
						_and_2 = _eIsProxy_3;
					}
					if (_and_2) {
						sourceNode = gtNode;
					}
					else {
						boolean _and_3 = false;
						if (!(gtNode instanceof GPUnboundNode)) {
							_and_3 = false;
						} else {
							EObject _type_3 = ((GPUnboundNode) gtNode).getType();
							String _name_1 = ((EClass) _type_3).getName();
							String _name_2 = targetClass.getName();
							boolean _equals_1 = _name_1.equals(_name_2);
							_and_3 = _equals_1;
						}
						if (_and_3) {
							targetNode = gtNode;
						}
						else {
							boolean _and_4 = false;
							if (!(gtNode instanceof GTThisObject)) {
								_and_4 = false;
							} else {
								EObject _type_4 = ((GTThisObject) gtNode).getType();
								String _name_3 = ((EClass) _type_4).getName();
								String _name_4 = targetClass.getName();
								boolean _equals_2 = _name_3.equals(_name_4);
								_and_4 = _equals_2;
							}
							if (_and_4) {
								targetNode = gtNode;
							}
						}
					}
				}
			}
		}
		boolean _and_5 = false;
		boolean _notEquals = (!Objects.equal(sourceNode, null));
		if (!_notEquals) {
			_and_5 = false;
		} else {
			boolean _notEquals_1 = (!Objects.equal(targetNode, null));
			_and_5 = _notEquals_1;
		}
		if (_and_5) {
			this.moveElements(((GTNode) sourceNode), ((GTNode) targetNode), objectsToRemove, targetClass, rule);
		}
		else {
			boolean _and_6 = false;
			boolean _notEquals_2 = (!Objects.equal(sourceNode, null));
			if (!_notEquals_2) {
				_and_6 = false;
			} else {
				boolean _equals_3 = Objects.equal(targetNode, null);
				_and_6 = _equals_3;
			}
			if (_and_6) {
				if ((sourceNode instanceof GPUnboundNode)) {
					((GPObject) sourceNode).setType(targetClass);
					this.retypeElements(((GTNode) sourceNode), objectsToRemove, targetClass);
				}
				else {
					if ((sourceNode instanceof GTThisObject)) {
						((GTThisObject) sourceNode).setType(targetClass);
						this.retypeElements(((GTNode) sourceNode), objectsToRemove, targetClass);
					}
				}
			}
		}
		EList<GTNegativeApplicationCondition> nacList = rule.getNegativePattern();
		for (final GTNegativeApplicationCondition nac : nacList) {
			{
				NACElement sourceNodeNAC = null;
				NACElement targetNodeNAC = null;
				EList<NACElement> _elements_1 = nac.getElements();
				for (final NACElement nacNode : _elements_1) {
					boolean _and_7 = false;
					if (!(nacNode instanceof NACBoundNode)) {
						_and_7 = false;
					} else {
						GPUnboundNode _gPUnboundNode = ((NACBoundNode) nacNode).getGPUnboundNode();
						EObject _type_5 = _gPUnboundNode.getType();
						boolean _eIsProxy_4 = _type_5.eIsProxy();
						_and_7 = _eIsProxy_4;
					}
					if (_and_7) {
						sourceNodeNAC = nacNode;
					}
					else {
						boolean _and_8 = false;
						if (!(nacNode instanceof NACObject)) {
							_and_8 = false;
						} else {
							EObject _type_6 = ((NACObject) nacNode).getType();
							boolean _eIsProxy_5 = _type_6.eIsProxy();
							_and_8 = _eIsProxy_5;
						}
						if (_and_8) {
							sourceNodeNAC = nacNode;
						}
						else {
							boolean _and_9 = false;
							if (!(nacNode instanceof NACParameter)) {
								_and_9 = false;
							} else {
								EObject _type_7 = ((NACParameter) nacNode).getType();
								boolean _eIsProxy_6 = _type_7.eIsProxy();
								_and_9 = _eIsProxy_6;
							}
							if (_and_9) {
								sourceNodeNAC = nacNode;
							}
							else {
								boolean _and_10 = false;
								if (!(nacNode instanceof GTThisObject)) {
									_and_10 = false;
								} else {
									EObject _type_8 = ((GTThisObject) nacNode).getType();
									boolean _eIsProxy_7 = _type_8.eIsProxy();
									_and_10 = _eIsProxy_7;
								}
								if (_and_10) {
									sourceNodeNAC = nacNode;
								}
								else {
									boolean _and_11 = false;
									if (!(nacNode instanceof NACBoundNode)) {
										_and_11 = false;
									} else {
										GPUnboundNode _gPUnboundNode_1 = ((NACBoundNode) nacNode).getGPUnboundNode();
										EObject _type_9 = _gPUnboundNode_1.getType();
										String _name_5 = ((EClass) _type_9).getName();
										String _name_6 = targetClass.getName();
										boolean _equals_4 = _name_5.equals(_name_6);
										_and_11 = _equals_4;
									}
									if (_and_11) {
										targetNodeNAC = nacNode;
									}
									else {
										boolean _and_12 = false;
										if (!(nacNode instanceof NACObject)) {
											_and_12 = false;
										} else {
											EObject _type_10 = ((NACObject) nacNode).getType();
											String _name_7 = ((EClass) _type_10).getName();
											String _name_8 = targetClass.getName();
											boolean _equals_5 = _name_7.equals(_name_8);
											_and_12 = _equals_5;
										}
										if (_and_12) {
											targetNodeNAC = nacNode;
										}
										else {
											boolean _and_13 = false;
											if (!(nacNode instanceof GTThisObject)) {
												_and_13 = false;
											} else {
												EObject _type_11 = ((GTThisObject) nacNode).getType();
												String _name_9 = ((EClass) _type_11).getName();
												String _name_10 = targetClass.getName();
												boolean _equals_6 = _name_9.equals(_name_10);
												_and_13 = _equals_6;
											}
											if (_and_13) {
												targetNodeNAC = nacNode;
											}
										}
									}
								}
							}
						}
					}
				}
				boolean _and_14 = false;
				boolean _notEquals_3 = (!Objects.equal(sourceNodeNAC, null));
				if (!_notEquals_3) {
					_and_14 = false;
				} else {
					boolean _notEquals_4 = (!Objects.equal(targetNodeNAC, null));
					_and_14 = _notEquals_4;
				}
				if (_and_14) {
					this.moveElements(((GTNode) sourceNodeNAC), ((GTNode) targetNodeNAC), objectsToRemove, targetClass, rule);
				}
				else {
					boolean _and_15 = false;
					boolean _notEquals_5 = (!Objects.equal(sourceNodeNAC, null));
					if (!_notEquals_5) {
						_and_15 = false;
					} else {
						boolean _equals_7 = Objects.equal(targetNodeNAC, null);
						_and_15 = _equals_7;
					}
					if (_and_15) {
						if ((sourceNodeNAC instanceof NACBoundNode)) {
							if ((targetNode instanceof GPUnboundNode)) {
								((NACBoundNode) sourceNodeNAC).setGPUnboundNode(((GPUnboundNode) targetNode));
								this.retypeElements(((GTNode) sourceNodeNAC), objectsToRemove, targetClass);
							}
							else {
								if ((targetNode instanceof GTThisObject)) {
									objectsToRemove.add(sourceNodeNAC);
								}
							}
						}
						else {
							if ((sourceNodeNAC instanceof NACObject)) {
								((NACObject) sourceNodeNAC).setType(targetClass);
								this.retypeElements(((GTNode) sourceNodeNAC), objectsToRemove, targetClass);
							}
							else {
								if ((sourceNodeNAC instanceof GTThisObject)) {
									((GTThisObject) sourceNodeNAC).setType(targetClass);
									this.retypeElements(((GTNode) sourceNodeNAC), objectsToRemove, targetClass);
								}
							}
						}
					}
				}
			}
		}
		return objectsToRemove;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void retypeElements(final GTNode sourceNode,
			final EList<EObject> objectsToRemove, final EClass targetClass) {
		EList<GTAttribute<?>> _attributes = ((GTNode) sourceNode).getAttributes();
		for (final GTAttribute gta : _attributes) {
			EObject _exAttribute = gta.getExAttribute();
			boolean _eIsProxy = _exAttribute.eIsProxy();
			if (_eIsProxy) {
				EObject _exAttribute_1 = gta.getExAttribute();
				String gtaName = this.getNameFromURI(_exAttribute_1);
				EList<EAttribute> _eAttributes = targetClass.getEAttributes();
				for (final EAttribute ea : _eAttributes) {
					String _name = ea.getName();
					boolean _equals = _name.equals(gtaName);
					if (_equals) {
						gta.setExAttribute(ea);
					}
				}
			}
		}
		EList<GTEdge> _incomingEdges = ((GTNode) sourceNode).getIncomingEdges();
		for (final GTEdge gtl : _incomingEdges) {
			boolean _or = false;
			GTNode _sourceNode = gtl.getSourceNode();
			boolean _eIsProxy_1 = _sourceNode.eIsProxy();
			if (_eIsProxy_1) {
				_or = true;
			} else {
				GTNode _targetNode = gtl.getTargetNode();
				boolean _eIsProxy_2 = _targetNode.eIsProxy();
				_or = _eIsProxy_2;
			}
			if (_or) {
				objectsToRemove.add(gtl);
			}
		}
		EList<GTEdge> _outgoingEdges = ((GTNode) sourceNode).getOutgoingEdges();
		for (final GTEdge gtl_1 : _outgoingEdges) {
			boolean _or_1 = false;
			GTNode _sourceNode_1 = gtl_1.getSourceNode();
			boolean _eIsProxy_3 = _sourceNode_1.eIsProxy();
			if (_eIsProxy_3) {
				_or_1 = true;
			} else {
				GTNode _targetNode_1 = gtl_1.getTargetNode();
				boolean _eIsProxy_4 = _targetNode_1.eIsProxy();
				_or_1 = _eIsProxy_4;
			}
			if (_or_1) {
				objectsToRemove.add(gtl_1);
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void moveElements(final GTNode sourceNode, final GTNode targetNode,
			final EList<EObject> objectsToRemove, final EClass targetClass,
			final GraphTransformationRule rule) {
		boolean _and = false;
		boolean _notEquals = (!Objects.equal(sourceNode, null));
		if (!_notEquals) {
			_and = false;
		} else {
			boolean _equals = Objects.equal(targetNode, null);
			_and = _equals;
		}
		if (_and) {
			objectsToRemove.add(sourceNode);
			EList<GTAttribute<?>> _attributes = sourceNode.getAttributes();
			objectsToRemove.addAll(_attributes);
			EList<GTField> _fields = sourceNode.getFields();
			objectsToRemove.addAll(_fields);
			EList<GTEdge> _incomingEdges = sourceNode.getIncomingEdges();
			objectsToRemove.addAll(_incomingEdges);
			EList<GTEdge> _outgoingEdges = sourceNode.getOutgoingEdges();
			objectsToRemove.addAll(_outgoingEdges);
		}
		else {
			boolean _and_1 = false;
			boolean _notEquals_1 = (!Objects.equal(sourceNode, null));
			if (!_notEquals_1) {
				_and_1 = false;
			} else {
				boolean _notEquals_2 = (!Objects.equal(targetNode, null));
				_and_1 = _notEquals_2;
			}
			if (_and_1) {
				objectsToRemove.add(sourceNode);
				EList<GTAttribute<?>> _attributes_1 = sourceNode.getAttributes();
				EList<GTAttribute<EAttribute>> attributes = ((EList<GTAttribute<EAttribute>>) ((EList<?>) _attributes_1));
				int size = attributes.size();
				int i = (size - 1);
				while ((i >= 0)) {
					{
						GTAttribute<EAttribute> a = attributes.get(i);
						EList<GTAttribute<?>> _attributes_2 = targetNode.getAttributes();
						_attributes_2.add(a);
						boolean _and_2 = false;
						if (!(targetNode instanceof GTThisObject)) {
							_and_2 = false;
						} else {
							EObject _eContainer = targetNode.eContainer();
							_and_2 = (_eContainer instanceof GTGraphPattern);
						}
						if (_and_2) {
							this.moveShape(a, targetNode, "2001", rule);
						}
						else {
							if ((targetNode instanceof GPObject)) {
								GTStatus _status = ((GPObject) targetNode).getStatus();
								String status = _status.name();
								boolean _equals_1 = status.equals("CREATE");
								if (_equals_1) {
									this.moveShape(a, targetNode, "2013", rule);
								}
								else {
									boolean _equals_2 = status.equals("DELETE");
									if (_equals_2) {
										this.moveShape(a, targetNode, "2012", rule);
									}
									else {
										this.moveShape(a, targetNode, "2011", rule);
									}
								}
							}
							else {
								if ((targetNode instanceof NACObject)) {
									this.moveShape(a, targetNode, "2017", rule);
								}
								else {
									boolean _and_3 = false;
									if (!(targetNode instanceof GTThisObject)) {
										_and_3 = false;
									} else {
										EObject _eContainer_1 = targetNode.eContainer();
										_and_3 = (_eContainer_1 instanceof GTNegativeApplicationCondition);
									}
									if (_and_3) {
										this.moveShape(a, targetNode, "2018", rule);
									}
								}
							}
						}
						EAttribute exAttr = a.getExAttribute();
						boolean _eIsProxy = exAttr.eIsProxy();
						if (_eIsProxy) {
							String exAttrName = this.getNameFromURI(exAttr);
							EList<EAttribute> _eAttributes = targetClass.getEAttributes();
							for (final EAttribute eAttr : _eAttributes) {
								String _name = eAttr.getName();
								boolean _equals_3 = _name.equals(exAttrName);
								if (_equals_3) {
									a.setExAttribute(eAttr);
								}
							}
						}
						i = (i - 1);
					}
				}
				EList<GTField> fields = sourceNode.getFields();
				int _size = fields.size();
				size = _size;
				i = (size - 1);
				while ((i >= 0)) {
					{
						GTField f = fields.get(i);
						EList<GTField> _fields_1 = targetNode.getFields();
						_fields_1.add(f);
						boolean _and_2 = false;
						if (!(targetNode instanceof GTThisObject)) {
							_and_2 = false;
						} else {
							EObject _eContainer = targetNode.eContainer();
							_and_2 = (_eContainer instanceof GTGraphPattern);
						}
						if (_and_2) {
							this.moveShape(f, targetNode, "2001", rule);
						}
						else {
							if ((targetNode instanceof GPObject)) {
								GTStatus _status = ((GPObject) targetNode).getStatus();
								String status = _status.name();
								boolean _equals_1 = status.equals("CREATE");
								if (_equals_1) {
									this.moveShape(f, targetNode, "2013", rule);
								}
								else {
									boolean _equals_2 = status.equals("DELETE");
									if (_equals_2) {
										this.moveShape(f, targetNode, "2012", rule);
									}
									else {
										this.moveShape(f, targetNode, "2011", rule);
									}
								}
							}
							else {
								if ((targetNode instanceof NACObject)) {
									this.moveShape(f, targetNode, "2017", rule);
								}
								else {
									boolean _and_3 = false;
									if (!(targetNode instanceof GTThisObject)) {
										_and_3 = false;
									} else {
										EObject _eContainer_1 = targetNode.eContainer();
										_and_3 = (_eContainer_1 instanceof GTNegativeApplicationCondition);
									}
									if (_and_3) {
										this.moveShape(f, targetNode, "2018", rule);
									}
								}
							}
						}
						i = (i - 1);
					}
				}
				EList<GTEdge> _incomingEdges_1 = sourceNode.getIncomingEdges();
				EList<GTLink<EReference>> incomingLinks = ((EList<GTLink<EReference>>) ((EList<?>) _incomingEdges_1));
				int _size_1 = incomingLinks.size();
				size = _size_1;
				i = (size - 1);
				while ((i >= 0)) {
					{
						GTLink<EReference> l = incomingLinks.get(i);
						objectsToRemove.add(l);
						i = (i - 1);
					}
				}
				EList<GTEdge> _outgoingEdges_1 = sourceNode.getOutgoingEdges();
				EList<GTLink<EReference>> outgoingLinks = ((EList<GTLink<EReference>>) ((EList<?>) _outgoingEdges_1));
				int _size_2 = outgoingLinks.size();
				size = _size_2;
				i = (size - 1);
				while ((i >= 0)) {
					{
						GTLink<EReference> l = outgoingLinks.get(i);
						l.setSourceNode(targetNode);
						EReference exRef = l.getExReference();
						boolean _eIsProxy = exRef.eIsProxy();
						if (_eIsProxy) {
							String exRefName = this.getNameFromURI(exRef);
							EList<EReference> _eReferences = targetClass.getEReferences();
							for (final EReference r : _eReferences) {
								String _name = r.getName();
								boolean _equals_1 = _name.equals(exRefName);
								if (_equals_1) {
									l.setExReference(r);
								}
							}
						}
						i = (i - 1);
					}
				}
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void moveShape(final EObject movedObject,
			final EObject newContainer, final String nodeType,
			final GraphTransformationRule rule) {
		Resource _eResource = rule.eResource();
		TreeIterator<EObject> iter2 = _eResource.getAllContents();
		Shape shape = null;
		Node targetNode = null;
		while (iter2.hasNext()) {
			{
				EObject next = iter2.next();
				boolean _and = false;
				if (!(next instanceof Shape)) {
					_and = false;
				} else {
					EObject _element = ((Shape) next).getElement();
					boolean _equals = _element.equals(movedObject);
					_and = _equals;
				}
				if (_and) {
					shape = ((Shape) next);
				}
				boolean _and_1 = false;
				boolean _and_2 = false;
				if (!(next instanceof Node)) {
					_and_2 = false;
				} else {
					String _type = ((Node) next).getType();
					boolean _equals_1 = _type.equals(nodeType);
					_and_2 = _equals_1;
				}
				if (!_and_2) {
					_and_1 = false;
				} else {
					EObject _element_1 = ((Node) next).getElement();
					boolean _equals_2 = _element_1.equals(newContainer);
					_and_1 = _equals_2;
				}
				if (_and_1) {
					targetNode = ((Node) next);
				}
			}
		}
		boolean _and = false;
		boolean _notEquals = (!Objects.equal(shape, null));
		if (!_notEquals) {
			_and = false;
		} else {
			boolean _notEquals_1 = (!Objects.equal(targetNode, null));
			_and = _notEquals_1;
		}
		if (_and) {
			EObject _eContainer = shape.eContainer();
			EObject _eContainer_1 = _eContainer.eContainer();
			EObject _eContainer_2 = _eContainer_1.eContainer();
			EObject _eContainer_3 = targetNode.eContainer();
			boolean _equals = _eContainer_2.equals(_eContainer_3);
			if (_equals) {
				EList _persistedChildren = targetNode.getPersistedChildren();
				for (final Object o : _persistedChildren) {
					boolean _and_1 = false;
					if (!(o instanceof BasicCompartment)) {
						_and_1 = false;
					} else {
						boolean _or = false;
						boolean _and_2 = false;
						EObject _element = shape.getElement();
						if (!(_element instanceof GTAttribute)) {
							_and_2 = false;
						} else {
							EObject _element_1 = shape.getElement();
							GTOperator _operator = ((GTAttribute) _element_1).getOperator();
							String _literal = _operator.getLiteral();
							boolean _equals_1 = _literal.equals("=");
							boolean _not = (!_equals_1);
							_and_2 = _not;
						}
						if (_and_2) {
							_or = true;
						} else {
							boolean _and_3 = false;
							EObject _element_2 = shape.getElement();
							if (!(_element_2 instanceof GTField)) {
								_and_3 = false;
							} else {
								EObject _element_3 = shape.getElement();
								GTFieldKind _kind = ((GTField) _element_3).getKind();
								String _name = _kind.getName();
								boolean _equals_2 = _name.equals("OCL_CONSTRAINT");
								_and_3 = _equals_2;
							}
							_or = _and_3;
						}
						_and_1 = _or;
					}
					if (_and_1) {
						EList _persistedChildren_1 = ((BasicCompartment) o).getPersistedChildren();
						_persistedChildren_1.add(shape);
						return;
					}
					else {
						boolean _and_4 = false;
						if (!(o instanceof BasicCompartment)) {
							_and_4 = false;
						} else {
							boolean _or_1 = false;
							boolean _and_5 = false;
							EObject _element_4 = shape.getElement();
							if (!(_element_4 instanceof GTAttribute)) {
								_and_5 = false;
							} else {
								EObject _element_5 = shape.getElement();
								GTOperator _operator_1 = ((GTAttribute) _element_5).getOperator();
								String _literal_1 = _operator_1.getLiteral();
								boolean _equals_3 = _literal_1.equals("=");
								_and_5 = _equals_3;
							}
							if (_and_5) {
								_or_1 = true;
							} else {
								boolean _and_6 = false;
								EObject _element_6 = shape.getElement();
								if (!(_element_6 instanceof GTField)) {
									_and_6 = false;
								} else {
									EObject _element_7 = shape.getElement();
									GTFieldKind _kind_1 = ((GTField) _element_7).getKind();
									String _name_1 = _kind_1.getName();
									boolean _equals_4 = _name_1.equals("OPERATION_CALL");
									_and_6 = _equals_4;
								}
								_or_1 = _and_6;
							}
							_and_4 = _or_1;
						}
						if (_and_4) {
							EList _persistedChildren_2 = ((BasicCompartment) o).getPersistedChildren();
							_persistedChildren_2.add(shape);
						}
					}
				}
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void propagateReplaceSubclassesWithFields(final EClass superClass,
			final GraphTransformationRule rule) {
		try {
			EcoreUtil.resolveAll(rule);
			GTGraphPattern pattern = rule.getPattern();
			EAttribute enumAttribute = null;
			EList<EAttribute> _eAttributes = superClass.getEAttributes();
			for (final EAttribute eAttribute : _eAttributes) {
				String _name = eAttribute.getName();
				String _name_1 = superClass.getName();
				String _plus = ("_" + _name_1);
				String _plus_1 = (_plus + "Type");
				boolean _equals = _name.equals(_plus_1);
				if (_equals) {
					enumAttribute = eAttribute;
				}
			}
			boolean _notEquals = (!Objects.equal(enumAttribute, null));
			if (_notEquals) {
				EList<GPElement> _elements = pattern.getElements();
				for (final GPElement gpElement : _elements) {
					boolean _and = false;
					if (!(gpElement instanceof GPUnboundNode)) {
						_and = false;
					} else {
						EObject _type = ((GPUnboundNode) gpElement).getType();
						boolean _eIsProxy = _type.eIsProxy();
						_and = _eIsProxy;
					}
					if (_and) {
						EObject _type_1 = ((GPUnboundNode) gpElement).getType();
						String name = this.getNameFromURI(_type_1);
						((GPUnboundNode) gpElement).setType(superClass);
						GTAttribute newGTAttribute = GtEngineFactory.eINSTANCE.<EObject>createGTAttribute();
						newGTAttribute.setExAttribute(enumAttribute);
						newGTAttribute.setValue(name);
						newGTAttribute.setOperator(GTOperator.EQEQ);
						EList _attributes = ((GPUnboundNode) gpElement).getAttributes();
						_attributes.add(newGTAttribute);
					}
					else {
						boolean _and_1 = false;
						if (!(gpElement instanceof GTThisObject)) {
							_and_1 = false;
						} else {
							EObject _type_2 = ((GTThisObject) gpElement).getType();
							boolean _eIsProxy_1 = _type_2.eIsProxy();
							_and_1 = _eIsProxy_1;
						}
						if (_and_1) {
							EObject _type_3 = ((GTThisObject) gpElement).getType();
							String name_1 = this.getNameFromURI(_type_3);
							((GTThisObject) gpElement).setType(superClass);
							GTAttribute newGTAttribute_1 = GtEngineFactory.eINSTANCE.<EObject>createGTAttribute();
							newGTAttribute_1.setExAttribute(enumAttribute);
							newGTAttribute_1.setValue(name_1);
							newGTAttribute_1.setOperator(GTOperator.EQEQ);
							EList _attributes_1 = ((GTThisObject) gpElement).getAttributes();
							_attributes_1.add(newGTAttribute_1);
						}
						else {
							boolean _and_2 = false;
							if (!(gpElement instanceof GPBoundNode)) {
								_and_2 = false;
							} else {
								EObject _type_4 = ((GPBoundNode) gpElement).getType();
								boolean _eIsProxy_2 = _type_4.eIsProxy();
								_and_2 = _eIsProxy_2;
							}
							if (_and_2) {
								EObject _type_5 = ((GPBoundNode) gpElement).getType();
								String name_2 = this.getNameFromURI(_type_5);
								((GPBoundNode) gpElement).setType(superClass);
								GTAttribute newGTAttribute_2 = GtEngineFactory.eINSTANCE.<EObject>createGTAttribute();
								newGTAttribute_2.setExAttribute(enumAttribute);
								newGTAttribute_2.setValue(name_2);
								newGTAttribute_2.setOperator(GTOperator.EQEQ);
								EList _attributes_2 = ((GPBoundNode) gpElement).getAttributes();
								_attributes_2.add(newGTAttribute_2);
							}
						}
					}
				}
				EList _negativePattern = rule.getNegativePattern();
				for (final Object object : _negativePattern) {
					{
						GTNegativeApplicationCondition nac = ((GTNegativeApplicationCondition) object);
						EList<NACElement> _elements_1 = nac.getElements();
						for (final NACElement nacElement : _elements_1) {
							boolean _and_3 = false;
							if (!(nacElement instanceof NACObject)) {
								_and_3 = false;
							} else {
								EObject _type_6 = ((NACObject) nacElement).getType();
								boolean _eIsProxy_3 = _type_6.eIsProxy();
								_and_3 = _eIsProxy_3;
							}
							if (_and_3) {
								EObject _type_7 = ((NACObject) nacElement).getType();
								String name_3 = this.getNameFromURI(_type_7);
								((NACObject) nacElement).setType(superClass);
								GTAttribute newGTAttribute_3 = GtEngineFactory.eINSTANCE.<EObject>createGTAttribute();
								newGTAttribute_3.setExAttribute(enumAttribute);
								newGTAttribute_3.setValue(name_3);
								newGTAttribute_3.setOperator(GTOperator.EQEQ);
								EList _attributes_3 = ((NACObject) nacElement).getAttributes();
								_attributes_3.add(newGTAttribute_3);
							}
							else {
								boolean _and_4 = false;
								if (!(nacElement instanceof NACParameter)) {
									_and_4 = false;
								} else {
									EObject _type_8 = ((NACParameter) nacElement).getType();
									boolean _eIsProxy_4 = _type_8.eIsProxy();
									_and_4 = _eIsProxy_4;
								}
								if (_and_4) {
									EObject _type_9 = ((NACParameter) nacElement).getType();
									String name_4 = this.getNameFromURI(_type_9);
									((NACParameter) nacElement).setType(superClass);
									GTAttribute newGTAttribute_4 = GtEngineFactory.eINSTANCE.<EObject>createGTAttribute();
									newGTAttribute_4.setExAttribute(enumAttribute);
									newGTAttribute_4.setValue(name_4);
									newGTAttribute_4.setOperator(GTOperator.EQEQ);
									EList _attributes_4 = ((NACParameter) nacElement).getAttributes();
									_attributes_4.add(newGTAttribute_4);
								}
							}
						}
					}
				}
			}
		}
		catch (final Throwable _t) {
			if (_t instanceof GTFailure) {
				final GTFailure e = (GTFailure)_t;
				e.printStackTrace();
			}
			else {
				throw Exceptions.sneakyThrow(_t);
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void propagateRemoveParameterInit(final String paramName,
			final String opName, final GraphTransformationRule rule) {
		EObject _implementedOperation = rule.getImplementedOperation();
		EOperation ruleOperation = ((EOperation) _implementedOperation);
		String _name = ruleOperation.getName();
		boolean _equals = _name.equals(opName);
		if (_equals) {
			try {
				this.propagateRemoveParameter(paramName, rule);
			}
			catch (final Throwable _t) {
				if (_t instanceof GTFailure) {
					final GTFailure e = (GTFailure)_t;
					e.printStackTrace();
				}
				else {
					throw Exceptions.sneakyThrow(_t);
				}
			}
			EList _negativePattern = rule.getNegativePattern();
			for (final Object nac : _negativePattern) {
				{
					GTNegativeApplicationCondition temp = ((GTNegativeApplicationCondition) nac);
					try {
						this.propagateRemoveParameterNAC(paramName, temp);
					}
					catch (final Throwable _t_1) {
						if (_t_1 instanceof GTFailure) {
							final GTFailure e1 = (GTFailure)_t_1;
							e1.printStackTrace();
						}
						else {
							throw Exceptions.sneakyThrow(_t_1);
						}
					}
				}
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void propagateRemoveParameter(String paramName,
			GraphTransformationRule rule) {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void propagateRemoveParameterNAC(String paramName,
			GTNegativeApplicationCondition nac) {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<GTAttribute> propagateMoveAttributeInit(
			final EAttribute eAttribute, final EClass sourceClass,
			final EClass targetClass, final GraphTransformationRule rule) {
		EcoreUtil.resolveAll(rule);
		EList<GTAttribute> gtAttributes = XcoreCollectionLiterals.<GTAttribute>newBasicEList();
		EList<GTAttribute> patternAttributes = XcoreCollectionLiterals.<GTAttribute>newBasicEList();
		try {
			EList<GTAttribute> _propagateMoveAttribute = this.propagateMoveAttribute(eAttribute, sourceClass, targetClass, rule);
			patternAttributes = _propagateMoveAttribute;
			boolean _and = false;
			boolean _notEquals = (!Objects.equal(patternAttributes, null));
			if (!_notEquals) {
				_and = false;
			} else {
				boolean _isEmpty = patternAttributes.isEmpty();
				boolean _not = (!_isEmpty);
				_and = _not;
			}
			if (_and) {
				gtAttributes.addAll(patternAttributes);
			}
		}
		catch (final Throwable _t) {
			if (_t instanceof Throwable) {
				final Throwable e = (Throwable)_t;
				e.printStackTrace();
			}
			else {
				throw Exceptions.sneakyThrow(_t);
			}
		}
		EList<GTAttribute> nacAttributes = XcoreCollectionLiterals.<GTAttribute>newBasicEList();
		EList _negativePattern = rule.getNegativePattern();
		for (final Object nac : _negativePattern) {
			{
				GTNegativeApplicationCondition temp = ((GTNegativeApplicationCondition) nac);
				try {
					EList<GTAttribute> nacAttributesTemp = this.propagateMoveAttributeNAC(eAttribute, sourceClass, targetClass, temp);
					boolean _and_1 = false;
					boolean _notEquals_1 = (!Objects.equal(nacAttributesTemp, null));
					if (!_notEquals_1) {
						_and_1 = false;
					} else {
						boolean _isEmpty_1 = nacAttributesTemp.isEmpty();
						boolean _not_1 = (!_isEmpty_1);
						_and_1 = _not_1;
					}
					if (_and_1) {
						nacAttributes.addAll(nacAttributesTemp);
					}
				}
				catch (final Throwable _t_1) {
					if (_t_1 instanceof GTFailure) {
						final GTFailure e1 = (GTFailure)_t_1;
						e1.printStackTrace();
					}
					else {
						throw Exceptions.sneakyThrow(_t_1);
					}
				}
			}
		}
		gtAttributes.addAll(nacAttributes);
		Resource _eResource = rule.eResource();
		TreeIterator<EObject> iter = _eResource.getAllContents();
		EList<EObject> objectsToRemove = XcoreCollectionLiterals.<EObject>newBasicEList();
		try {
			while (iter.hasNext()) {
				{
					EObject eObject = iter.next();
					boolean _and_1 = false;
					boolean _isEmpty_1 = gtAttributes.isEmpty();
					boolean _not_1 = (!_isEmpty_1);
					if (!_not_1) {
						_and_1 = false;
					} else {
						_and_1 = (eObject instanceof Shape);
					}
					if (_and_1) {
						EObject element = ((Shape) eObject).getElement();
						boolean _contains = gtAttributes.contains(element);
						if (_contains) {
							EObject targetNode = element.eContainer();
							boolean _and_2 = false;
							boolean _and_3 = false;
							boolean _notEquals_1 = (!Objects.equal(patternAttributes, null));
							if (!_notEquals_1) {
								_and_3 = false;
							} else {
								_and_3 = (targetNode instanceof GTThisObject);
							}
							if (!_and_3) {
								_and_2 = false;
							} else {
								EObject _eContainer = targetNode.eContainer();
								_and_2 = (_eContainer instanceof GTGraphPattern);
							}
							if (_and_2) {
								for (final GTAttribute gtAttribute : patternAttributes) {
									this.moveShape(gtAttribute, targetNode, "2001", rule);
								}
							}
							boolean _and_4 = false;
							boolean _notEquals_2 = (!Objects.equal(patternAttributes, null));
							if (!_notEquals_2) {
								_and_4 = false;
							} else {
								_and_4 = (targetNode instanceof GPObject);
							}
							if (_and_4) {
								for (final GTAttribute gtAttribute_1 : patternAttributes) {
									{
										GTStatus _status = ((GPObject) targetNode).getStatus();
										String status = _status.name();
										boolean _equals = status.equals("CREATE");
										if (_equals) {
											this.moveShape(gtAttribute_1, targetNode, "2013", rule);
										}
										else {
											boolean _equals_1 = status.equals("DELETE");
											if (_equals_1) {
												this.moveShape(gtAttribute_1, targetNode, "2012", rule);
											}
											else {
												this.moveShape(gtAttribute_1, targetNode, "2011", rule);
											}
										}
									}
								}
							}
							boolean _and_5 = false;
							boolean _and_6 = false;
							boolean _notEquals_3 = (!Objects.equal(nacAttributes, null));
							if (!_notEquals_3) {
								_and_6 = false;
							} else {
								_and_6 = (targetNode instanceof GTThisObject);
							}
							if (!_and_6) {
								_and_5 = false;
							} else {
								EObject _eContainer_1 = targetNode.eContainer();
								_and_5 = (_eContainer_1 instanceof GTNegativeApplicationCondition);
							}
							if (_and_5) {
								for (final GTAttribute gtAttribute_2 : nacAttributes) {
									this.moveShape(gtAttribute_2, targetNode, "2018", rule);
								}
							}
							boolean _and_7 = false;
							boolean _notEquals_4 = (!Objects.equal(nacAttributes, null));
							if (!_notEquals_4) {
								_and_7 = false;
							} else {
								_and_7 = (targetNode instanceof NACObject);
							}
							if (_and_7) {
								for (final GTAttribute gtAttribute_3 : nacAttributes) {
									this.moveShape(gtAttribute_3, targetNode, "2017", rule);
								}
							}
						}
					}
					boolean _and_8 = false;
					boolean _and_9 = false;
					boolean _and_10 = false;
					boolean _notEquals_5 = (!Objects.equal(patternAttributes, null));
					if (!_notEquals_5) {
						_and_10 = false;
					} else {
						boolean _isEmpty_2 = patternAttributes.isEmpty();
						_and_10 = _isEmpty_2;
					}
					if (!_and_10) {
						_and_9 = false;
					} else {
						_and_9 = (eObject instanceof GTAttribute<?>);
					}
					if (!_and_9) {
						_and_8 = false;
					} else {
						EObject _exAttribute = ((GTAttribute) eObject).getExAttribute();
						boolean _eIsProxy = _exAttribute.eIsProxy();
						_and_8 = _eIsProxy;
					}
					if (_and_8) {
						objectsToRemove.add(eObject);
					}
					boolean _and_11 = false;
					boolean _and_12 = false;
					boolean _and_13 = false;
					boolean _notEquals_6 = (!Objects.equal(patternAttributes, null));
					if (!_notEquals_6) {
						_and_13 = false;
					} else {
						boolean _isEmpty_3 = patternAttributes.isEmpty();
						_and_13 = _isEmpty_3;
					}
					if (!_and_13) {
						_and_12 = false;
					} else {
						_and_12 = (eObject instanceof Shape);
					}
					if (!_and_12) {
						_and_11 = false;
					} else {
						EObject _element = ((Shape) eObject).getElement();
						boolean _contains_1 = objectsToRemove.contains(_element);
						_and_11 = _contains_1;
					}
					if (_and_11) {
						objectsToRemove.add(eObject);
					}
					boolean _and_14 = false;
					boolean _and_15 = false;
					boolean _and_16 = false;
					boolean _notEquals_7 = (!Objects.equal(nacAttributes, null));
					if (!_notEquals_7) {
						_and_16 = false;
					} else {
						boolean _isEmpty_4 = nacAttributes.isEmpty();
						_and_16 = _isEmpty_4;
					}
					if (!_and_16) {
						_and_15 = false;
					} else {
						_and_15 = (eObject instanceof GTAttribute<?>);
					}
					if (!_and_15) {
						_and_14 = false;
					} else {
						EObject _exAttribute_1 = ((GTAttribute) eObject).getExAttribute();
						boolean _eIsProxy_1 = _exAttribute_1.eIsProxy();
						_and_14 = _eIsProxy_1;
					}
					if (_and_14) {
						objectsToRemove.add(eObject);
					}
					boolean _and_17 = false;
					boolean _and_18 = false;
					boolean _and_19 = false;
					boolean _notEquals_8 = (!Objects.equal(nacAttributes, null));
					if (!_notEquals_8) {
						_and_19 = false;
					} else {
						boolean _isEmpty_5 = nacAttributes.isEmpty();
						_and_19 = _isEmpty_5;
					}
					if (!_and_19) {
						_and_18 = false;
					} else {
						_and_18 = (eObject instanceof Shape);
					}
					if (!_and_18) {
						_and_17 = false;
					} else {
						EObject _element_1 = ((Shape) eObject).getElement();
						boolean _contains_2 = objectsToRemove.contains(_element_1);
						_and_17 = _contains_2;
					}
					if (_and_17) {
						objectsToRemove.add(eObject);
					}
				}
			}
		}
		catch (final Throwable _t_1) {
			if (_t_1 instanceof Throwable) {
				final Throwable e_1 = (Throwable)_t_1;
			}
			else {
				throw Exceptions.sneakyThrow(_t_1);
			}
		}
		Resource _eResource_1 = rule.eResource();
		this.cleanUpAndSave(objectsToRemove, _eResource_1);
		return gtAttributes;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<GTAttribute> propagateMoveAttribute(EAttribute eAttribute,
			EClass sourceClass, EClass targetClass, GraphTransformationRule rule) {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<GTAttribute> propagateMoveAttributeNAC(EAttribute eAttribute,
			EClass sourceClass, EClass targetClass,
			GTNegativeApplicationCondition nac) {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void propagatePushDownAttribute(final EAttribute eAttribute,
			final EClass superClass, final EClass subClass,
			final GraphTransformationRule rule) {
		EList<GTNegativeApplicationCondition> nacList = rule.getNegativePattern();
		Helper _helper = this.getHelper();
		EList<EClass> subClasses = _helper.getAllSubClasses(superClass);
		EList<String> subClassesNames = XcoreCollectionLiterals.<String>newBasicEList();
		for (final EClass c : subClasses) {
			String _name = c.getName();
			subClassesNames.add(_name);
		}
		GTGraphPattern _pattern = rule.getPattern();
		EList<GPElement> patternElements = this.getNodesTypedOverClassFromPattern(superClass, _pattern);
		boolean _notEquals = (!Objects.equal(patternElements, null));
		if (_notEquals) {
			for (final GPElement e : patternElements) {
				if ((e instanceof GPUnboundNode)) {
					EList _attributes = ((GPUnboundNode) e).getAttributes();
					for (final Object temp : _attributes) {
						{
							GTAttribute a = ((GTAttribute) temp);
							EObject _exAttribute = a.getExAttribute();
							boolean _eIsProxy = _exAttribute.eIsProxy();
							if (_eIsProxy) {
								String _name_1 = ((GPUnboundNode) e).getName();
								String _plus = ("Choose the new type for the node " + _name_1);
								String _plus_1 = (_plus + " in the ");
								String _name_2 = rule.getName();
								String _plus_2 = (_plus_1 + _name_2);
								String _plus_3 = (_plus_2 + " GTRule");
								String targetClassName = this.getSelectedFromDialog(subClassesNames, _plus_3);
								Helper _helper_1 = this.getHelper();
								EClass targetClass = _helper_1.getClass(targetClassName);
								((GPUnboundNode) e).setType(targetClass);
								EObject _type = ((GPUnboundNode) e).getType();
								EList<EAttribute> _eAttributes = ((EClass) _type).getEAttributes();
								for (final EAttribute eAttr : _eAttributes) {
									String _name_3 = eAttr.getName();
									String _name_4 = eAttribute.getName();
									boolean _equals = _name_3.equals(_name_4);
									if (_equals) {
										a.setExAttribute(eAttr);
									}
								}
							}
						}
					}
				}
				else {
					if ((e instanceof GTThisObject)) {
						EList _attributes_1 = ((GTThisObject) e).getAttributes();
						for (final Object temp_1 : _attributes_1) {
							{
								GTAttribute a = ((GTAttribute) temp_1);
								EObject _exAttribute = a.getExAttribute();
								boolean _eIsProxy = _exAttribute.eIsProxy();
								if (_eIsProxy) {
									String _name_1 = ((GTThisObject) e).getName();
									String _plus = ("Choose the new type for the node " + _name_1);
									String _plus_1 = (_plus + " in the ");
									String _name_2 = rule.getName();
									String _plus_2 = (_plus_1 + _name_2);
									String _plus_3 = (_plus_2 + " GTRule");
									String targetClassName = this.getSelectedFromDialog(subClassesNames, _plus_3);
									Helper _helper_1 = this.getHelper();
									EClass targetClass = _helper_1.getClass(targetClassName);
									((GTThisObject) e).setType(targetClass);
									EObject _type = ((GTThisObject) e).getType();
									EList<EAttribute> _eAttributes = ((EClass) _type).getEAttributes();
									for (final EAttribute eAttr : _eAttributes) {
										String _name_3 = eAttr.getName();
										String _name_4 = eAttribute.getName();
										boolean _equals = _name_3.equals(_name_4);
										if (_equals) {
											a.setExAttribute(eAttr);
										}
									}
								}
							}
						}
					}
					else {
						if ((e instanceof GPBoundNode)) {
							EList _attributes_2 = ((GPBoundNode) e).getAttributes();
							for (final Object temp_2 : _attributes_2) {
								{
									GTAttribute a = ((GTAttribute) temp_2);
									EObject _exAttribute = a.getExAttribute();
									boolean _eIsProxy = _exAttribute.eIsProxy();
									if (_eIsProxy) {
										String _name_1 = ((GPBoundNode) e).getName();
										String _plus = ("Choose the new type for the node " + _name_1);
										String _plus_1 = (_plus + " in the ");
										String _name_2 = rule.getName();
										String _plus_2 = (_plus_1 + _name_2);
										String _plus_3 = (_plus_2 + " GTRule");
										String targetClassName = this.getSelectedFromDialog(subClassesNames, _plus_3);
										Helper _helper_1 = this.getHelper();
										EClass targetClass = _helper_1.getClass(targetClassName);
										((GPBoundNode) e).setType(targetClass);
										EObject _type = ((GPBoundNode) e).getType();
										EList<EAttribute> _eAttributes = ((EClass) _type).getEAttributes();
										for (final EAttribute eAttr : _eAttributes) {
											String _name_3 = eAttr.getName();
											String _name_4 = eAttribute.getName();
											boolean _equals = _name_3.equals(_name_4);
											if (_equals) {
												a.setExAttribute(eAttr);
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
		for (final GTNegativeApplicationCondition nac : nacList) {
			{
				EList<NACElement> nacElements = this.getNodesTypedOverClassFromNAC(superClass, nac);
				boolean _notEquals_1 = (!Objects.equal(nacElements, null));
				if (_notEquals_1) {
					for (final NACElement e_1 : nacElements) {
						if ((e_1 instanceof NACObject)) {
							EList _attributes_3 = ((NACObject) e_1).getAttributes();
							for (final Object temp_3 : _attributes_3) {
								{
									GTAttribute a = ((GTAttribute) temp_3);
									EObject _exAttribute = a.getExAttribute();
									boolean _eIsProxy = _exAttribute.eIsProxy();
									if (_eIsProxy) {
										String _name_1 = ((NACObject) e_1).getName();
										String _plus = ("Choose the new type for the node " + _name_1);
										String _plus_1 = (_plus + " in the ");
										String _name_2 = rule.getName();
										String _plus_2 = (_plus_1 + _name_2);
										String _plus_3 = (_plus_2 + " GTRule");
										String targetClassName = this.getSelectedFromDialog(subClassesNames, _plus_3);
										Helper _helper_1 = this.getHelper();
										EClass targetClass = _helper_1.getClass(targetClassName);
										((NACObject) e_1).setType(targetClass);
										EObject _type = ((NACObject) e_1).getType();
										EList<EAttribute> _eAttributes = ((EClass) _type).getEAttributes();
										for (final EAttribute eAttr : _eAttributes) {
											String _name_3 = eAttr.getName();
											String _name_4 = eAttribute.getName();
											boolean _equals = _name_3.equals(_name_4);
											if (_equals) {
												a.setExAttribute(eAttr);
											}
										}
									}
								}
							}
						}
						else {
							if ((e_1 instanceof NACParameter)) {
								EList _attributes_4 = ((NACParameter) e_1).getAttributes();
								for (final Object temp_4 : _attributes_4) {
									{
										GTAttribute a = ((GTAttribute) temp_4);
										EObject _exAttribute = a.getExAttribute();
										boolean _eIsProxy = _exAttribute.eIsProxy();
										if (_eIsProxy) {
											String _name_1 = ((NACParameter) e_1).getName();
											String _plus = ("Choose the new type for the node " + _name_1);
											String _plus_1 = (_plus + " in the ");
											String _name_2 = rule.getName();
											String _plus_2 = (_plus_1 + _name_2);
											String _plus_3 = (_plus_2 + " GTRule");
											String targetClassName = this.getSelectedFromDialog(subClassesNames, _plus_3);
											Helper _helper_1 = this.getHelper();
											EClass targetClass = _helper_1.getClass(targetClassName);
											((NACParameter) e_1).setType(targetClass);
											EObject _type = ((NACParameter) e_1).getType();
											EList<EAttribute> _eAttributes = ((EClass) _type).getEAttributes();
											for (final EAttribute eAttr : _eAttributes) {
												String _name_3 = eAttr.getName();
												String _name_4 = eAttribute.getName();
												boolean _equals = _name_3.equals(_name_4);
												if (_equals) {
													a.setExAttribute(eAttr);
												}
											}
										}
									}
								}
							}
							else {
								if ((e_1 instanceof NACBoundNode)) {
									EList _attributes_5 = ((NACBoundNode) e_1).getAttributes();
									for (final Object temp_5 : _attributes_5) {
										{
											GTAttribute a = ((GTAttribute) temp_5);
											EObject _exAttribute = a.getExAttribute();
											boolean _eIsProxy = _exAttribute.eIsProxy();
											if (_eIsProxy) {
												GPUnboundNode _gPUnboundNode = ((NACBoundNode) e_1).getGPUnboundNode();
												EObject _type = _gPUnboundNode.getType();
												EList<EAttribute> _eAttributes = ((EClass) _type).getEAttributes();
												for (final EAttribute eAttr : _eAttributes) {
													String _name_1 = eAttr.getName();
													String _name_2 = eAttribute.getName();
													boolean _equals = _name_1.equals(_name_2);
													if (_equals) {
														a.setExAttribute(eAttr);
													}
												}
											}
										}
									}
								}
								else {
									if ((e_1 instanceof GTThisObject)) {
										EList _attributes_6 = ((GTThisObject) e_1).getAttributes();
										for (final Object temp_6 : _attributes_6) {
											{
												GTAttribute a = ((GTAttribute) temp_6);
												EObject _exAttribute = a.getExAttribute();
												boolean _eIsProxy = _exAttribute.eIsProxy();
												if (_eIsProxy) {
													String _name_1 = ((GTThisObject) e_1).getName();
													String _plus = ("Choose the new type for the node " + _name_1);
													String _plus_1 = (_plus + " in the ");
													String _name_2 = rule.getName();
													String _plus_2 = (_plus_1 + _name_2);
													String _plus_3 = (_plus_2 + " GTRule");
													String targetClassName = this.getSelectedFromDialog(subClassesNames, _plus_3);
													Helper _helper_1 = this.getHelper();
													EClass targetClass = _helper_1.getClass(targetClassName);
													((GTThisObject) e_1).setType(targetClass);
													EObject _type = ((GTThisObject) e_1).getType();
													EList<EAttribute> _eAttributes = ((EClass) _type).getEAttributes();
													for (final EAttribute eAttr : _eAttributes) {
														String _name_3 = eAttr.getName();
														String _name_4 = eAttribute.getName();
														boolean _equals = _name_3.equals(_name_4);
														if (_equals) {
															a.setExAttribute(eAttr);
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EObject> propagateMoveOperation(final EOperation eOperation,
			final EClass sourceClass, final EClass targetClass,
			final GraphTransformationRule rule,
			final EList<EObject> objectsToRemove) {
		EObject _implementedOperation = rule.getImplementedOperation();
		boolean _eIsProxy = _implementedOperation.eIsProxy();
		if (_eIsProxy) {
			rule.setCorrespondingClass(targetClass);
			this.resetImplementedOperation(rule, targetClass);
		}
		TreeIterator iter = rule.eAllContents();
		Boolean moved = Boolean.valueOf(false);
		while (iter.hasNext()) {
			{
				if ((moved).booleanValue()) {
					return objectsToRemove;
				}
				Object _next = iter.next();
				EObject eObject = ((EObject) _next);
				boolean _and = false;
				if (!(eObject instanceof GTField)) {
					_and = false;
				} else {
					GTFieldKind _kind = ((GTField) eObject).getKind();
					String _name = _kind.getName();
					boolean _equals = _name.equals("OPERATION_CALL");
					_and = _equals;
				}
				if (_and) {
					String _content = ((GTField) eObject).getContent();
					String _quote = Pattern.quote("(");
					String[] _split = _content.split(_quote);
					String operationName = _split[0];
					String _name_1 = eOperation.getName();
					boolean _equals_1 = operationName.equals(_name_1);
					if (_equals_1) {
						GTGraphPattern _pattern = rule.getPattern();
						EList<GPElement> _elements = _pattern.getElements();
						for (final EObject ruleObject : _elements) {
							boolean _and_1 = false;
							if (!(ruleObject instanceof GPObject)) {
								_and_1 = false;
							} else {
								_and_1 = (!(moved).booleanValue());
							}
							if (_and_1) {
								EObject _type = ((GPObject) ruleObject).getType();
								EClass eClass = ((EClass) _type);
								String name = eClass.getName();
								String _name_2 = targetClass.getName();
								boolean _equals_2 = name.equals(_name_2);
								if (_equals_2) {
									EList _fields = ((GPObject) ruleObject).getFields();
									_fields.add(((GTField) eObject));
									GTStatus _status = ((GPObject) ruleObject).getStatus();
									String status = _status.name();
									boolean _equals_3 = status.equals("CREATE");
									if (_equals_3) {
										this.moveShape(eObject, ruleObject, "2013", rule);
									}
									else {
										boolean _equals_4 = status.equals("DELETE");
										if (_equals_4) {
											this.moveShape(eObject, ruleObject, "2012", rule);
										}
										else {
											this.moveShape(eObject, ruleObject, "2011", rule);
										}
									}
									moved = Boolean.valueOf(true);
								}
							}
							else {
								boolean _and_2 = false;
								if (!(ruleObject instanceof GTThisObject)) {
									_and_2 = false;
								} else {
									_and_2 = (!(moved).booleanValue());
								}
								if (_and_2) {
									EObject _type_1 = ((GTThisObject) ruleObject).getType();
									EClass eClass_1 = ((EClass) _type_1);
									String name_1 = eClass_1.getName();
									String _name_3 = targetClass.getName();
									boolean _equals_5 = name_1.equals(_name_3);
									if (_equals_5) {
										EList _fields_1 = ((GTThisObject) ruleObject).getFields();
										_fields_1.add(((GTField) eObject));
										this.moveShape(eObject, ruleObject, "2001", rule);
										moved = Boolean.valueOf(true);
									}
								}
							}
						}
						if ((!(moved).booleanValue())) {
							objectsToRemove.add(eObject);
							moved = Boolean.valueOf(true);
						}
					}
				}
			}
		}
		return objectsToRemove;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void propagatePushDownOperation(final EOperation eOperation,
			final EClass superClass, final EClass subClass,
			final GraphTransformationRule rule) {
		Helper _helper = this.getHelper();
		EList<EClass> subClasses = _helper.getAllSubClasses(superClass);
		EList<String> subClassesNames = XcoreCollectionLiterals.<String>newBasicEList();
		for (final EClass c : subClasses) {
			String _name = c.getName();
			subClassesNames.add(_name);
		}
		EObject implOp = rule.getImplementedOperation();
		String implOpName = "";
		boolean _eIsProxy = implOp.eIsProxy();
		if (_eIsProxy) {
			String _nameFromURI = this.getNameFromURI(implOp);
			implOpName = _nameFromURI;
			String _name_1 = rule.getName();
			String _plus = ("Choose the new CorrespondingClass for the " + _name_1);
			String _plus_1 = (_plus + " GTRule");
			String targetClassName = this.getSelectedFromDialog(subClassesNames, _plus_1);
			Helper _helper_1 = this.getHelper();
			EClass targetClass = _helper_1.getClass(targetClassName);
			rule.setCorrespondingClass(targetClass);
			EList<EOperation> _eOperations = targetClass.getEOperations();
			for (final EOperation eOp : _eOperations) {
				String _name_2 = eOp.getName();
				boolean _equals = _name_2.equals(implOpName);
				if (_equals) {
					rule.setImplementedOperation(eOp);
				}
			}
		}
		GTGraphPattern _pattern = rule.getPattern();
		EList<GPElement> patternElements = this.getNodesTypedOverClassFromPattern(superClass, _pattern);
		for (final GPElement e : patternElements) {
			if ((e instanceof GPUnboundNode)) {
				EList _fields = ((GPUnboundNode) e).getFields();
				for (final Object temp : _fields) {
					{
						GTField f = ((GTField) temp);
						GTFieldKind _kind = ((GTField) f).getKind();
						String _name_3 = _kind.getName();
						boolean _equals_1 = _name_3.equals("OPERATION_CALL");
						if (_equals_1) {
							String content = ((GTField) f).getContent();
							String _quote = Pattern.quote("(");
							String[] _split = content.split(_quote);
							String operationName = _split[0];
							String _name_4 = eOperation.getName();
							boolean _equals_2 = operationName.equals(_name_4);
							if (_equals_2) {
								String _name_5 = ((GPUnboundNode) e).getName();
								String _plus_2 = ("Choose the new type for the node " + _name_5);
								String _plus_3 = (_plus_2 + " in the ");
								String _name_6 = rule.getName();
								String _plus_4 = (_plus_3 + _name_6);
								String _plus_5 = (_plus_4 + " GTRule");
								String targetClassName_1 = this.getSelectedFromDialog(subClassesNames, _plus_5);
								Helper _helper_2 = this.getHelper();
								EClass targetClass_1 = _helper_2.getClass(targetClassName_1);
								((GPUnboundNode) e).setType(targetClass_1);
							}
						}
					}
				}
			}
			else {
				if ((e instanceof GTThisObject)) {
					EList _fields_1 = ((GTThisObject) e).getFields();
					for (final Object temp_1 : _fields_1) {
						{
							GTField f = ((GTField) temp_1);
							GTFieldKind _kind = ((GTField) f).getKind();
							String _name_3 = _kind.getName();
							boolean _equals_1 = _name_3.equals("OPERATION_CALL");
							if (_equals_1) {
								String content = ((GTField) f).getContent();
								String _quote = Pattern.quote("(");
								String[] _split = content.split(_quote);
								String operationName = _split[0];
								String _name_4 = eOperation.getName();
								boolean _equals_2 = operationName.equals(_name_4);
								if (_equals_2) {
									EObject _correspondingClass = rule.getCorrespondingClass();
									((GTThisObject) e).setType(_correspondingClass);
								}
							}
						}
					}
				}
				else {
					if ((e instanceof GPBoundNode)) {
						EList _fields_2 = ((GPBoundNode) e).getFields();
						for (final Object temp_2 : _fields_2) {
							{
								GTField f = ((GTField) temp_2);
								GTFieldKind _kind = ((GTField) f).getKind();
								String _name_3 = _kind.getName();
								boolean _equals_1 = _name_3.equals("OPERATION_CALL");
								if (_equals_1) {
									String content = ((GTField) f).getContent();
									String _quote = Pattern.quote("(");
									String[] _split = content.split(_quote);
									String operationName = _split[0];
									String _name_4 = eOperation.getName();
									boolean _equals_2 = operationName.equals(_name_4);
									if (_equals_2) {
										String _name_5 = ((GPBoundNode) e).getName();
										String _plus_2 = ("Choose the new type for the node " + _name_5);
										String _plus_3 = (_plus_2 + " in the ");
										String _name_6 = rule.getName();
										String _plus_4 = (_plus_3 + _name_6);
										String _plus_5 = (_plus_4 + " GTRule");
										String targetClassName_1 = this.getSelectedFromDialog(subClassesNames, _plus_5);
										Helper _helper_2 = this.getHelper();
										EClass targetClass_1 = _helper_2.getClass(targetClassName_1);
										((GPBoundNode) e).setType(targetClass_1);
									}
								}
							}
						}
					}
				}
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void propagateRenameElement(final ENamedElement eNamedElement,
			final String oldName, final GraphTransformationRule rule) {
		try {
			EcoreUtil.resolveAll(rule);
			GTGraphPattern pattern = rule.getPattern();
			if ((eNamedElement instanceof EClass)) {
				EClass eClass = ((EClass) eNamedElement);
				EObject _correspondingClass = rule.getCorrespondingClass();
				boolean _eIsProxy = _correspondingClass.eIsProxy();
				if (_eIsProxy) {
					this.propagateEClassNameChanged(eClass, rule);
				}
				EList<GPElement> _elements = pattern.getElements();
				for (final GPElement gpElement : _elements) {
					{
						if ((gpElement instanceof GPUnboundNode)) {
							GPUnboundNode node = ((GPUnboundNode) gpElement);
							EObject _type = node.getType();
							boolean _eIsProxy_1 = _type.eIsProxy();
							if (_eIsProxy_1) {
								node.setType(eNamedElement);
								this.retypeAttributes(node, eClass);
							}
						}
						if ((gpElement instanceof GPBoundNode)) {
							GPBoundNode node_1 = ((GPBoundNode) gpElement);
							EObject _type_1 = node_1.getType();
							boolean _eIsProxy_2 = _type_1.eIsProxy();
							if (_eIsProxy_2) {
								node_1.setType(eNamedElement);
								this.retypeAttributes(node_1, eClass);
							}
						}
						if ((gpElement instanceof GTThisObject)) {
							GTThisObject node_2 = ((GTThisObject) gpElement);
							EObject _type_2 = node_2.getType();
							boolean _eIsProxy_3 = _type_2.eIsProxy();
							if (_eIsProxy_3) {
								node_2.setType(eNamedElement);
								this.retypeAttributes(node_2, eClass);
							}
						}
					}
				}
				EList _negativePattern = rule.getNegativePattern();
				for (final Object object : _negativePattern) {
					{
						GTNegativeApplicationCondition nac = ((GTNegativeApplicationCondition) object);
						EList<NACElement> _elements_1 = nac.getElements();
						for (final NACElement nacElement : _elements_1) {
							{
								if ((nacElement instanceof NACObject)) {
									NACObject node = ((NACObject) nacElement);
									EObject _type = node.getType();
									boolean _eIsProxy_1 = _type.eIsProxy();
									if (_eIsProxy_1) {
										node.setType(eNamedElement);
										this.retypeAttributes(node, eClass);
									}
								}
								if ((nacElement instanceof NACParameter)) {
									NACParameter node_1 = ((NACParameter) nacElement);
									EObject _type_1 = node_1.getType();
									boolean _eIsProxy_2 = _type_1.eIsProxy();
									if (_eIsProxy_2) {
										node_1.setType(eNamedElement);
										this.retypeAttributes(node_1, eClass);
									}
								}
								if ((nacElement instanceof GTThisObject)) {
									GTThisObject node_2 = ((GTThisObject) nacElement);
									EObject _type_2 = node_2.getType();
									boolean _eIsProxy_3 = _type_2.eIsProxy();
									if (_eIsProxy_3) {
										node_2.setType(eNamedElement);
										this.retypeAttributes(node_2, eClass);
									}
								}
							}
						}
					}
				}
			}
			else {
				if ((eNamedElement instanceof EAttribute)) {
					EList<GPElement> _elements_1 = pattern.getElements();
					for (final GPElement gpElement_1 : _elements_1) {
						if ((gpElement_1 instanceof GTNode)) {
							GTNode gtNode = ((GTNode) gpElement_1);
							EList<GTAttribute<?>> _attributes = gtNode.getAttributes();
							for (final GTAttribute gtAttribute : _attributes) {
								EObject _exAttribute = gtAttribute.getExAttribute();
								boolean _eIsProxy_1 = _exAttribute.eIsProxy();
								if (_eIsProxy_1) {
									gtAttribute.setExAttribute(eNamedElement);
								}
							}
						}
					}
					EList _negativePattern_1 = rule.getNegativePattern();
					for (final Object object_1 : _negativePattern_1) {
						{
							GTNegativeApplicationCondition nac = ((GTNegativeApplicationCondition) object_1);
							EList<NACElement> _elements_2 = nac.getElements();
							for (final NACElement nacElement : _elements_2) {
								if ((nacElement instanceof NACNode)) {
									NACNode nacNode = ((NACNode) nacElement);
									EList<GTAttribute<?>> _attributes_1 = nacNode.getAttributes();
									for (final GTAttribute gtAttribute_1 : _attributes_1) {
										EObject _exAttribute_1 = gtAttribute_1.getExAttribute();
										boolean _eIsProxy_2 = _exAttribute_1.eIsProxy();
										if (_eIsProxy_2) {
											gtAttribute_1.setExAttribute(eNamedElement);
										}
									}
								}
							}
						}
					}
				}
				else {
					if ((eNamedElement instanceof EReference)) {
						EReference eReference = ((EReference) eNamedElement);
						EList<GPElement> _elements_2 = pattern.getElements();
						for (final GPElement gpElement_2 : _elements_2) {
							if ((gpElement_2 instanceof GPLink)) {
								GPLink gpLink = ((GPLink) gpElement_2);
								EObject _exReference = gpLink.getExReference();
								boolean _eIsProxy_2 = _exReference.eIsProxy();
								if (_eIsProxy_2) {
									gpLink.setExReference(eReference);
								}
							}
						}
						EList _negativePattern_2 = rule.getNegativePattern();
						for (final Object object_2 : _negativePattern_2) {
							{
								GTNegativeApplicationCondition nac = ((GTNegativeApplicationCondition) object_2);
								EList<NACElement> _elements_3 = nac.getElements();
								for (final NACElement nacElement : _elements_3) {
									if ((nacElement instanceof NACLink)) {
										NACLink nacLink = ((NACLink) nacElement);
										EObject _exReference_1 = nacLink.getExReference();
										boolean _eIsProxy_3 = _exReference_1.eIsProxy();
										if (_eIsProxy_3) {
											nacLink.setExReference(eReference);
										}
									}
								}
							}
						}
					}
					else {
						if ((eNamedElement instanceof EParameter)) {
							EParameter temp = ((EParameter) eNamedElement);
							EObject _implementedOperation = rule.getImplementedOperation();
							EOperation ruleOperation = ((EOperation) _implementedOperation);
							EOperation paramOperation = temp.getEOperation();
							boolean _compareOperations = this.compareOperations(ruleOperation, paramOperation);
							if (_compareOperations) {
								EList<GPElement> _elements_3 = pattern.getElements();
								for (final GPElement gpElement_3 : _elements_3) {
									if ((gpElement_3 instanceof GPBoundNode)) {
										GPBoundNode gpBoundNode = ((GPBoundNode) gpElement_3);
										String _name = gpBoundNode.getName();
										boolean _equals = _name.equals(oldName);
										if (_equals) {
											String _name_1 = ((EParameter)eNamedElement).getName();
											gpBoundNode.setName(_name_1);
										}
									}
								}
								EList _negativePattern_3 = rule.getNegativePattern();
								for (final Object object_3 : _negativePattern_3) {
									{
										GTNegativeApplicationCondition nac = ((GTNegativeApplicationCondition) object_3);
										EList<NACElement> _elements_4 = nac.getElements();
										for (final NACElement nacElement : _elements_4) {
											if ((nacElement instanceof NACParameter)) {
												NACParameter nacParameter = ((NACParameter) nacElement);
												String _name_2 = nacParameter.getName();
												boolean _equals_1 = _name_2.equals(oldName);
												if (_equals_1) {
													String _name_3 = ((EParameter)eNamedElement).getName();
													nacParameter.setName(_name_3);
												}
											}
										}
									}
								}
							}
						}
						else {
							boolean _and = false;
							if (!(eNamedElement instanceof EOperation)) {
								_and = false;
							} else {
								EObject _implementedOperation_1 = rule.getImplementedOperation();
								boolean _eIsProxy_3 = _implementedOperation_1.eIsProxy();
								_and = _eIsProxy_3;
							}
							if (_and) {
								EOperation eOperation = ((EOperation) eNamedElement);
								rule.setImplementedOperation(eOperation);
							}
						}
					}
				}
			}
		}
		catch (final Throwable _t) {
			if (_t instanceof GTFailure) {
				final GTFailure e = (GTFailure)_t;
				e.printStackTrace();
			}
			else {
				throw Exceptions.sneakyThrow(_t);
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void retypeAttributes(final GTNode node, final EClass eClass) {
		EList<GTAttribute<?>> _attributes = node.getAttributes();
		for (final GTAttribute gta : _attributes) {
			EObject _exAttribute = gta.getExAttribute();
			boolean _eIsProxy = _exAttribute.eIsProxy();
			if (_eIsProxy) {
				EObject _exAttribute_1 = gta.getExAttribute();
				String gtaName = this.getNameFromURI(_exAttribute_1);
				EList<EAttribute> _eAttributes = eClass.getEAttributes();
				for (final EAttribute ea : _eAttributes) {
					String _name = ea.getName();
					boolean _equals = _name.equals(gtaName);
					if (_equals) {
						gta.setExAttribute(ea);
					}
				}
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void retypeReferencesTypedOverClass(final EClass eClass,
			final GraphTransformationRule rule) {
		GTGraphPattern _pattern = rule.getPattern();
		EList<GPElement> _elements = _pattern.getElements();
		for (final GPElement temp : _elements) {
			if ((temp instanceof GTLink)) {
				GTLink gte = ((GTLink) temp);
				EObject _exReference = gte.getExReference();
				boolean _eIsProxy = _exReference.eIsProxy();
				if (_eIsProxy) {
					EObject _exReference_1 = gte.getExReference();
					String gteName = this.getNameFromURI(_exReference_1);
					EList<EReference> _eReferences = eClass.getEReferences();
					for (final EReference er : _eReferences) {
						String _name = er.getName();
						boolean _equals = _name.equals(gteName);
						if (_equals) {
							gte.setExReference(er);
						}
					}
				}
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void handleInnerNodes(final EList<GPUnboundNode> innerNodes,
			final EClass eClass) {
		for (final GPElement gpElement : innerNodes) {
			{
				GPUnboundNode node = ((GPUnboundNode) gpElement);
				EObject _type = node.getType();
				boolean _eIsProxy = _type.eIsProxy();
				if (_eIsProxy) {
					node.setType(eClass);
					this.retypeAttributes(node, eClass);
				}
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void resetImplementedOperation(final GraphTransformationRule rule,
			final EClass eClass) {
		EObject _implementedOperation = rule.getImplementedOperation();
		EOperation implOp = ((EOperation) _implementedOperation);
		boolean _eIsProxy = implOp.eIsProxy();
		if (_eIsProxy) {
			String implOpName = this.getNameFromURI(implOp);
			EList<EOperation> _eOperations = eClass.getEOperations();
			for (final EOperation eOp : _eOperations) {
				String _name = eOp.getName();
				boolean _equals = _name.equals(implOpName);
				if (_equals) {
					rule.setImplementedOperation(eOp);
				}
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void updateAttributeValue(final GTAttribute gtAttribute,
			final ENamedElement eNamedElement, final String oldName) {
		String value = gtAttribute.getValue();
		boolean _contains = value.contains(oldName);
		if (_contains) {
			String[] temp = value.split("\\s+");
			String newValue = "";
			final String[] _converted_temp = (String[])temp;
			int size = ((List<String>)org.eclipse.xtext.xbase.lib.Conversions.doWrapArray(_converted_temp)).size();
			int i = 0;
			while ((i < size)) {
				{
					String _get = temp[i];
					boolean _equals = _get.equals(oldName);
					if (_equals) {
						String _name = eNamedElement.getName();
						String _plus = (newValue + _name);
						String _plus_1 = (_plus + " ");
						newValue = _plus_1;
					}
					else {
						String _get_1 = temp[i];
						String _plus_2 = (newValue + _get_1);
						String _plus_3 = (_plus_2 + " ");
						newValue = _plus_3;
					}
					i = (i + 1);
				}
			}
			gtAttribute.setValue(newValue);
		}
		else {
			boolean _equals = value.equals(oldName);
			if (_equals) {
				String _name = eNamedElement.getName();
				gtAttribute.setValue(_name);
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void updateOperationCallWithNewName(
			final ENamedElement eNamedElement, final EObject eObject,
			final String oldName) {
		String content = ((GTField) eObject).getContent();
		String _quote = Pattern.quote("(");
		String[] _split = content.split(_quote);
		String operationName = _split[0];
		boolean _equals = operationName.equals(oldName);
		if (_equals) {
			String newParamNames = "";
			EList<EParameter> _eParameters = ((EOperation) eNamedElement).getEParameters();
			for (final EParameter p : _eParameters) {
				boolean _and = false;
				boolean _notEquals = (!Objects.equal(p, null));
				if (!_notEquals) {
					_and = false;
				} else {
					boolean _equals_1 = newParamNames.equals("");
					_and = _equals_1;
				}
				if (_and) {
					String _name = p.getName();
					newParamNames = _name;
				}
				else {
					boolean _and_1 = false;
					boolean _notEquals_1 = (!Objects.equal(p, null));
					if (!_notEquals_1) {
						_and_1 = false;
					} else {
						boolean _equals_2 = newParamNames.equals("");
						boolean _not = (!_equals_2);
						_and_1 = _not;
					}
					if (_and_1) {
						String _name_1 = p.getName();
						String _plus = ((newParamNames + ",") + _name_1);
						newParamNames = _plus;
					}
				}
			}
			String _name_2 = eNamedElement.getName();
			String _plus_1 = (_name_2 + "(");
			String _plus_2 = (_plus_1 + newParamNames);
			String newName = (_plus_2 + ")");
			((GTField) eObject).setContent(newName);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void updateOperationCalls(final EList<Object> gtResources) {
		for (final Object res : gtResources) {
			{
				Resource temp = ((Resource) res);
				TreeIterator<EObject> iter = temp.getAllContents();
				while (iter.hasNext()) {
					{
						EObject eObject = iter.next();
						boolean _and = false;
						if (!(eObject instanceof GTField)) {
							_and = false;
						} else {
							GTFieldKind _kind = ((GTField) eObject).getKind();
							String _name = _kind.getName();
							boolean _equals = _name.equals("OPERATION_CALL");
							_and = _equals;
						}
						if (_and) {
							String content = ((GTField) eObject).getContent();
							String _quote = Pattern.quote("(");
							String[] _split = content.split(_quote);
							String operationName = _split[0];
							EObject fieldContainer = eObject.eContainer();
							EClass containingClass = null;
							if ((fieldContainer instanceof GPUnboundNode)) {
								EObject _type = ((GPUnboundNode) fieldContainer).getType();
								containingClass = ((EClass) _type);
							}
							else {
								if ((fieldContainer instanceof GTThisObject)) {
									EObject _type_1 = ((GTThisObject) fieldContainer).getType();
									containingClass = ((EClass) _type_1);
								}
							}
							EList<EOperation> _eOperations = containingClass.getEOperations();
							for (final EOperation eOperation : _eOperations) {
								String _name_1 = eOperation.getName();
								boolean _equals_1 = _name_1.equals(operationName);
								if (_equals_1) {
									String newParameters = "";
									int i = 0;
									EList<EParameter> _eParameters = eOperation.getEParameters();
									for (final EParameter p : _eParameters) {
										{
											i = (i + 1);
											EList<EParameter> _eParameters_1 = eOperation.getEParameters();
											int _size = _eParameters_1.size();
											boolean _equals_2 = (i == _size);
											if (_equals_2) {
												String _name_2 = p.getName();
												String _plus = (newParameters + _name_2);
												newParameters = _plus;
											}
											else {
												String _name_3 = p.getName();
												String _plus_1 = (newParameters + _name_3);
												String _plus_2 = (_plus_1 + ",");
												newParameters = _plus_2;
											}
										}
									}
									String newContent = (((operationName + "(") + newParameters) + ")");
									((GTField) eObject).setContent(newContent);
								}
							}
						}
					}
				}
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void updateOCLExpressions(final EList<Object> gtResources,
			final String newName, final String oldName) {
		for (final Object res : gtResources) {
			{
				Resource temp = ((Resource) res);
				TreeIterator<EObject> iter = temp.getAllContents();
				while (iter.hasNext()) {
					{
						EObject eObject = iter.next();
						boolean _and = false;
						if (!(eObject instanceof GTField)) {
							_and = false;
						} else {
							GTFieldKind _kind = ((GTField) eObject).getKind();
							String _name = _kind.getName();
							boolean _equals = _name.equals("OCL_CONSTRAINT");
							_and = _equals;
						}
						if (_and) {
							String condition = ((GTField) eObject).getContent();
							String newCondition = this.updateOCLExpressionWithNewName(condition, newName, oldName);
							boolean _notEquals = (!Objects.equal(newCondition, null));
							if (_notEquals) {
								((GTField) eObject).setContent(newCondition);
							}
						}
						else {
							if ((eObject instanceof GTPath)) {
								String condition_1 = ((GTPath) eObject).getExpression();
								String newCondition_1 = this.updateOCLExpressionWithNewName(condition_1, newName, oldName);
								boolean _notEquals_1 = (!Objects.equal(newCondition_1, null));
								if (_notEquals_1) {
									((GTPath) eObject).setExpression(newCondition_1);
								}
							}
						}
					}
				}
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String updateOCLExpressionWithNewName(final String condition,
			final String newName, final String oldName) {
		boolean _contains = condition.contains(oldName);
		if (_contains) {
			String[] temp = condition.split(oldName);
			EList<String> conditionSubStrings = XcoreCollectionLiterals.<String>newBasicEList();
			for (final String s : temp) {
				boolean _equals = s.equals("");
				if (_equals) {
					conditionSubStrings.add(" ");
				}
				else {
					conditionSubStrings.add(s);
				}
			}
			String newCondition = "";
			String testString = "_1234567890qwertzuiopasdfghjklyxcvbnmQWERTZUIOPASDFGHJKLYXCVBNM";
			int i = 0;
			while ((i < (conditionSubStrings.size() - 1))) {
				{
					String _get = conditionSubStrings.get(i);
					String _get_1 = conditionSubStrings.get(i);
					int _length = _get_1.length();
					int _minus = (_length - 1);
					char _charAt = _get.charAt(_minus);
					String beforeString = ("" + Character.valueOf(_charAt));
					String _get_2 = conditionSubStrings.get((i + 1));
					char _charAt_1 = _get_2.charAt(0);
					String afterString = ("" + Character.valueOf(_charAt_1));
					boolean before = false;
					boolean _contains_1 = testString.contains(beforeString);
					if (_contains_1) {
						before = true;
					}
					boolean after = false;
					boolean _contains_2 = testString.contains(afterString);
					if (_contains_2) {
						after = true;
					}
					if (((i == 0) && ((!before) && (!after)))) {
						String _get_3 = conditionSubStrings.get(i);
						String _plus = (newCondition + _get_3);
						String _plus_1 = (_plus + newName);
						String _get_4 = conditionSubStrings.get((i + 1));
						String _plus_2 = (_plus_1 + _get_4);
						newCondition = _plus_2;
					}
					else {
						if (((i == 0) && (before || after))) {
							String _get_5 = conditionSubStrings.get(i);
							String _plus_3 = (newCondition + _get_5);
							String _plus_4 = (_plus_3 + oldName);
							String _get_6 = conditionSubStrings.get((i + 1));
							String _plus_5 = (_plus_4 + _get_6);
							newCondition = _plus_5;
						}
						else {
							if (((i != 0) && ((!before) && (!after)))) {
								String _get_7 = conditionSubStrings.get((i + 1));
								String _plus_6 = ((newCondition + newName) + _get_7);
								newCondition = _plus_6;
							}
							else {
								if (((i != 0) && (before || after))) {
									String _get_8 = conditionSubStrings.get((i + 1));
									String _plus_7 = ((newCondition + oldName) + _get_8);
									newCondition = _plus_7;
								}
							}
						}
					}
					i = (i + 1);
				}
			}
			return newCondition;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String updateOCLExpressionWithUserInteraction(final String ruleName,
			final String expression, final String objectName,
			final String containerName) {
		boolean _contains = expression.contains(objectName);
		if (_contains) {
			int result = JOptionPane.showConfirmDialog(null, 
				(((((("This OCL Expression might be affected by the performed refactoring Operation:\n" + expression) + 
					"\nin the rule ") + ruleName) + " \ncontained in a ") + containerName) + 
					"\nPress YES if you want to input a new OCL Expression.\n"), "Please verify the OCL Expression", 
				JOptionPane.YES_NO_OPTION);
			if ((result == 0)) {
				String newExpression = JOptionPane.showInputDialog(null, 
					(("WARNING: Empty input will result in the deletion of the constraint.\nOld expression:\n" + expression) + "\n"), "Please enter the new Expression.", JOptionPane.OK_OPTION);
				return newExpression;
			}
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public GTGraphPattern propagateEClassNameChanged(EClass eClass,
			GraphTransformationRule rule) {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void retypeGTAttributeInPattern(EAttribute eAttribute,
			GraphTransformationRule rule) {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void retypeGTAttributeInNAC(EAttribute eAttribute,
			GTNegativeApplicationCondition nac) {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean compareOperations(final EOperation ruleOperation,
			final EOperation paramOperation) {
		EList<EParameter> ruleOpParams = ruleOperation.getEParameters();
		EList<EParameter> paramOpParams = paramOperation.getEParameters();
		EList<String> ruleOpParamsNames = XcoreCollectionLiterals.<String>newBasicEList();
		for (final EParameter p : ruleOpParams) {
			String _name = p.getName();
			ruleOpParamsNames.add(_name);
		}
		for (final EParameter p_1 : paramOpParams) {
			String _name_1 = p_1.getName();
			boolean _contains = ruleOpParamsNames.contains(_name_1);
			boolean _not = (!_contains);
			if (_not) {
				return false;
			}
		}
		String _name_2 = ruleOperation.getName();
		String _name_3 = paramOperation.getName();
		boolean _equals = _name_2.equals(_name_3);
		if (_equals) {
			return true;
		}
		return false;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ERefactoringPackage.PROPAGATION__RULES:
				return getRules();
			case ERefactoringPackage.PROPAGATION__HELPER:
				if (resolve) return getHelper();
				return basicGetHelper();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ERefactoringPackage.PROPAGATION__RULES:
				getRules().clear();
				getRules().addAll((Collection<? extends GraphTransformationRule>)newValue);
				return;
			case ERefactoringPackage.PROPAGATION__HELPER:
				setHelper((Helper)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ERefactoringPackage.PROPAGATION__RULES:
				getRules().clear();
				return;
			case ERefactoringPackage.PROPAGATION__HELPER:
				setHelper((Helper)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ERefactoringPackage.PROPAGATION__RULES:
				return rules != null && !rules.isEmpty();
			case ERefactoringPackage.PROPAGATION__HELPER:
				return helper != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments)
			throws InvocationTargetException {
		switch (operationID) {
		case ERefactoringPackage.PROPAGATION___GET_NAME_FROM_URI__EOBJECT:
			return getNameFromURI((EObject) arguments.get(0));
		case ERefactoringPackage.PROPAGATION___GET_SELECTED_FROM_DIALOG__ELIST_STRING:
			return getSelectedFromDialog((EList<String>) arguments.get(0),
					(String) arguments.get(1));
		case ERefactoringPackage.PROPAGATION___GET_NODES_TYPED_OVER_CLASS_FROM_PATTERN__ECLASS_GTGRAPHPATTERN:
			return getNodesTypedOverClassFromPattern((EClass) arguments.get(0),
					(GTGraphPattern) arguments.get(1));
		case ERefactoringPackage.PROPAGATION___GET_NODES_TYPED_OVER_CLASS_FROM_NAC__ECLASS_GTNEGATIVEAPPLICATIONCONDITION:
			return getNodesTypedOverClassFromNAC((EClass) arguments.get(0),
					(GTNegativeApplicationCondition) arguments.get(1));
		case ERefactoringPackage.PROPAGATION___CLEAN_UP_AND_SAVE__ELIST_OBJECT:
			cleanUpAndSave((EList<EObject>) arguments.get(0), arguments.get(1));
			return null;
		case ERefactoringPackage.PROPAGATION___PROPAGATE_CHANGE_BIDIRECTIONAL_TO_UNIDIRECTIONAL_REFERENCE__EREFERENCE_EREFERENCE_GRAPHTRANSFORMATIONRULE:
			propagateChangeBidirectionalToUnidirectionalReference(
					(EReference) arguments.get(0),
					(EReference) arguments.get(1),
					(GraphTransformationRule) arguments.get(2));
			return null;
		case ERefactoringPackage.PROPAGATION___PROPAGATE_CHANGE_BIDIRECTIONAL_TO_UNIDIRECTIONAL_REFERENCE_NAC__EREFERENCE_GTNEGATIVEAPPLICATIONCONDITION:
			propagateChangeBidirectionalToUnidirectionalReferenceNAC(
					(EReference) arguments.get(0),
					(GTNegativeApplicationCondition) arguments.get(1));
			return null;
		case ERefactoringPackage.PROPAGATION___PROPAGATE_HIDE_DELEG_REPL_DELEG_WINHERIT_INIT__ECLASS_ECLASS_GRAPHTRANSFORMATIONRULE:
			propagateHideDeleg_ReplDelegWInheritInit((EClass) arguments.get(0),
					(EClass) arguments.get(1),
					(GraphTransformationRule) arguments.get(2));
			return null;
		case ERefactoringPackage.PROPAGATION___PROPAGATE_HIDE_DELEG_REPL_DELEG_WINHERIT__ECLASS_ECLASS_GRAPHTRANSFORMATIONRULE:
			propagateHideDeleg_ReplDelegWInherit((EClass) arguments.get(0),
					(EClass) arguments.get(1),
					(GraphTransformationRule) arguments.get(2));
			return null;
		case ERefactoringPackage.PROPAGATION___PROPAGATE_HIDE_DELEG_REPL_DELEG_WINHERIT_NAC__ECLASS_ECLASS_GTNEGATIVEAPPLICATIONCONDITION:
			propagateHideDeleg_ReplDelegWInheritNAC((EClass) arguments.get(0),
					(EClass) arguments.get(1),
					(GTNegativeApplicationCondition) arguments.get(2));
			return null;
		case ERefactoringPackage.PROPAGATION___PROPAGATE_REMOVE_MID_MAN_REPL_INHERIT_WDELEG_INIT__EREFERENCE_ECLASS_ECLASS_GRAPHTRANSFORMATIONRULE:
			propagateRemoveMidMan_ReplInheritWDelegInit(
					(EReference) arguments.get(0), (EClass) arguments.get(1),
					(EClass) arguments.get(2),
					(GraphTransformationRule) arguments.get(3));
			return null;
		case ERefactoringPackage.PROPAGATION___PROPAGATE_REMOVE_MID_MAN_REPL_INHERIT_WDELEG__EREFERENCE_ECLASS_ECLASS_GRAPHTRANSFORMATIONRULE:
			propagateRemoveMidMan_ReplInheritWDeleg(
					(EReference) arguments.get(0), (EClass) arguments.get(1),
					(EClass) arguments.get(2),
					(GraphTransformationRule) arguments.get(3));
			return null;
		case ERefactoringPackage.PROPAGATION___PROPAGATE_REMOVE_MID_MAN_REPL_INHERIT_WDELEG_NAC__EREFERENCE_ECLASS_ECLASS_GTNEGATIVEAPPLICATIONCONDITION:
			propagateRemoveMidMan_ReplInheritWDelegNAC(
					(EReference) arguments.get(0), (EClass) arguments.get(1),
					(EClass) arguments.get(2),
					(GTNegativeApplicationCondition) arguments.get(3));
			return null;
		case ERefactoringPackage.PROPAGATION___MARK_SHAPES_TO_REMOVE__GRAPHTRANSFORMATIONRULE_ELIST_ELIST:
			markShapesToRemove((GraphTransformationRule) arguments.get(0),
					(EList<EObject>) arguments.get(1),
					(EList<EObject>) arguments.get(2));
			return null;
		case ERefactoringPackage.PROPAGATION___PROPAGATE_EXTRACT_SUB_CLASS__ECLASS_ECLASS_GRAPHTRANSFORMATIONRULE:
			return propagateExtractSubClass((EClass) arguments.get(0),
					(EClass) arguments.get(1),
					(GraphTransformationRule) arguments.get(2));
		case ERefactoringPackage.PROPAGATION___PROPAGATE_INLINE_CLASS_COLLAPSE_HIERARCHY__ECLASS_ECLASS_GRAPHTRANSFORMATIONRULE_ELIST:
			return propagateInlineClass_CollapseHierarchy(
					(EClass) arguments.get(0), (EClass) arguments.get(1),
					(GraphTransformationRule) arguments.get(2),
					(EList<EObject>) arguments.get(3));
		case ERefactoringPackage.PROPAGATION___RETYPE_ELEMENTS__GTNODE_ELIST_ECLASS:
			retypeElements((GTNode) arguments.get(0),
					(EList<EObject>) arguments.get(1),
					(EClass) arguments.get(2));
			return null;
		case ERefactoringPackage.PROPAGATION___MOVE_ELEMENTS__GTNODE_GTNODE_ELIST_ECLASS_GRAPHTRANSFORMATIONRULE:
			moveElements((GTNode) arguments.get(0), (GTNode) arguments.get(1),
					(EList<EObject>) arguments.get(2),
					(EClass) arguments.get(3),
					(GraphTransformationRule) arguments.get(4));
			return null;
		case ERefactoringPackage.PROPAGATION___MOVE_SHAPE__EOBJECT_EOBJECT_STRING_GRAPHTRANSFORMATIONRULE:
			moveShape((EObject) arguments.get(0), (EObject) arguments.get(1),
					(String) arguments.get(2),
					(GraphTransformationRule) arguments.get(3));
			return null;
		case ERefactoringPackage.PROPAGATION___PROPAGATE_REPLACE_SUBCLASSES_WITH_FIELDS__ECLASS_GRAPHTRANSFORMATIONRULE:
			propagateReplaceSubclassesWithFields((EClass) arguments.get(0),
					(GraphTransformationRule) arguments.get(1));
			return null;
		case ERefactoringPackage.PROPAGATION___PROPAGATE_REMOVE_PARAMETER_INIT__STRING_STRING_GRAPHTRANSFORMATIONRULE:
			propagateRemoveParameterInit((String) arguments.get(0),
					(String) arguments.get(1),
					(GraphTransformationRule) arguments.get(2));
			return null;
		case ERefactoringPackage.PROPAGATION___PROPAGATE_REMOVE_PARAMETER__STRING_GRAPHTRANSFORMATIONRULE:
			propagateRemoveParameter((String) arguments.get(0),
					(GraphTransformationRule) arguments.get(1));
			return null;
		case ERefactoringPackage.PROPAGATION___PROPAGATE_REMOVE_PARAMETER_NAC__STRING_GTNEGATIVEAPPLICATIONCONDITION:
			propagateRemoveParameterNAC((String) arguments.get(0),
					(GTNegativeApplicationCondition) arguments.get(1));
			return null;
		case ERefactoringPackage.PROPAGATION___PROPAGATE_MOVE_ATTRIBUTE_INIT__EATTRIBUTE_ECLASS_ECLASS_GRAPHTRANSFORMATIONRULE:
			return propagateMoveAttributeInit((EAttribute) arguments.get(0),
					(EClass) arguments.get(1), (EClass) arguments.get(2),
					(GraphTransformationRule) arguments.get(3));
		case ERefactoringPackage.PROPAGATION___PROPAGATE_MOVE_ATTRIBUTE__EATTRIBUTE_ECLASS_ECLASS_GRAPHTRANSFORMATIONRULE:
			return propagateMoveAttribute((EAttribute) arguments.get(0),
					(EClass) arguments.get(1), (EClass) arguments.get(2),
					(GraphTransformationRule) arguments.get(3));
		case ERefactoringPackage.PROPAGATION___PROPAGATE_MOVE_ATTRIBUTE_NAC__EATTRIBUTE_ECLASS_ECLASS_GTNEGATIVEAPPLICATIONCONDITION:
			return propagateMoveAttributeNAC((EAttribute) arguments.get(0),
					(EClass) arguments.get(1), (EClass) arguments.get(2),
					(GTNegativeApplicationCondition) arguments.get(3));
		case ERefactoringPackage.PROPAGATION___PROPAGATE_PUSH_DOWN_ATTRIBUTE__EATTRIBUTE_ECLASS_ECLASS_GRAPHTRANSFORMATIONRULE:
			propagatePushDownAttribute((EAttribute) arguments.get(0),
					(EClass) arguments.get(1), (EClass) arguments.get(2),
					(GraphTransformationRule) arguments.get(3));
			return null;
		case ERefactoringPackage.PROPAGATION___PROPAGATE_MOVE_OPERATION__EOPERATION_ECLASS_ECLASS_GRAPHTRANSFORMATIONRULE_ELIST:
			return propagateMoveOperation((EOperation) arguments.get(0),
					(EClass) arguments.get(1), (EClass) arguments.get(2),
					(GraphTransformationRule) arguments.get(3),
					(EList<EObject>) arguments.get(4));
		case ERefactoringPackage.PROPAGATION___PROPAGATE_PUSH_DOWN_OPERATION__EOPERATION_ECLASS_ECLASS_GRAPHTRANSFORMATIONRULE:
			propagatePushDownOperation((EOperation) arguments.get(0),
					(EClass) arguments.get(1), (EClass) arguments.get(2),
					(GraphTransformationRule) arguments.get(3));
			return null;
		case ERefactoringPackage.PROPAGATION___PROPAGATE_RENAME_ELEMENT__ENAMEDELEMENT_STRING_GRAPHTRANSFORMATIONRULE:
			propagateRenameElement((ENamedElement) arguments.get(0),
					(String) arguments.get(1),
					(GraphTransformationRule) arguments.get(2));
			return null;
		case ERefactoringPackage.PROPAGATION___RETYPE_ATTRIBUTES__GTNODE_ECLASS:
			retypeAttributes((GTNode) arguments.get(0),
					(EClass) arguments.get(1));
			return null;
		case ERefactoringPackage.PROPAGATION___RETYPE_REFERENCES_TYPED_OVER_CLASS__ECLASS_GRAPHTRANSFORMATIONRULE:
			retypeReferencesTypedOverClass((EClass) arguments.get(0),
					(GraphTransformationRule) arguments.get(1));
			return null;
		case ERefactoringPackage.PROPAGATION___HANDLE_INNER_NODES__ELIST_ECLASS:
			handleInnerNodes((EList<GPUnboundNode>) arguments.get(0),
					(EClass) arguments.get(1));
			return null;
		case ERefactoringPackage.PROPAGATION___RESET_IMPLEMENTED_OPERATION__GRAPHTRANSFORMATIONRULE_ECLASS:
			resetImplementedOperation(
					(GraphTransformationRule) arguments.get(0),
					(EClass) arguments.get(1));
			return null;
		case ERefactoringPackage.PROPAGATION___UPDATE_ATTRIBUTE_VALUE__GTATTRIBUTE_ENAMEDELEMENT_STRING:
			updateAttributeValue((GTAttribute) arguments.get(0),
					(ENamedElement) arguments.get(1), (String) arguments.get(2));
			return null;
		case ERefactoringPackage.PROPAGATION___UPDATE_OPERATION_CALL_WITH_NEW_NAME__ENAMEDELEMENT_EOBJECT_STRING:
			updateOperationCallWithNewName((ENamedElement) arguments.get(0),
					(EObject) arguments.get(1), (String) arguments.get(2));
			return null;
		case ERefactoringPackage.PROPAGATION___UPDATE_OPERATION_CALLS__ELIST:
			updateOperationCalls((EList<Object>) arguments.get(0));
			return null;
		case ERefactoringPackage.PROPAGATION___UPDATE_OCL_EXPRESSIONS__ELIST_STRING_STRING:
			updateOCLExpressions((EList<Object>) arguments.get(0),
					(String) arguments.get(1), (String) arguments.get(2));
			return null;
		case ERefactoringPackage.PROPAGATION___UPDATE_OCL_EXPRESSION_WITH_NEW_NAME__STRING_STRING_STRING:
			return updateOCLExpressionWithNewName((String) arguments.get(0),
					(String) arguments.get(1), (String) arguments.get(2));
		case ERefactoringPackage.PROPAGATION___UPDATE_OCL_EXPRESSION_WITH_USER_INTERACTION__STRING_STRING_STRING_STRING:
			return updateOCLExpressionWithUserInteraction(
					(String) arguments.get(0), (String) arguments.get(1),
					(String) arguments.get(2), (String) arguments.get(3));
		case ERefactoringPackage.PROPAGATION___PROPAGATE_ECLASS_NAME_CHANGED__ECLASS_GRAPHTRANSFORMATIONRULE:
			return propagateEClassNameChanged((EClass) arguments.get(0),
					(GraphTransformationRule) arguments.get(1));
		case ERefactoringPackage.PROPAGATION___RETYPE_GT_ATTRIBUTE_IN_PATTERN__EATTRIBUTE_GRAPHTRANSFORMATIONRULE:
			retypeGTAttributeInPattern((EAttribute) arguments.get(0),
					(GraphTransformationRule) arguments.get(1));
			return null;
		case ERefactoringPackage.PROPAGATION___RETYPE_GT_ATTRIBUTE_IN_NAC__EATTRIBUTE_GTNEGATIVEAPPLICATIONCONDITION:
			retypeGTAttributeInNAC((EAttribute) arguments.get(0),
					(GTNegativeApplicationCondition) arguments.get(1));
			return null;
		case ERefactoringPackage.PROPAGATION___COMPARE_OPERATIONS__EOPERATION_EOPERATION:
			return compareOperations((EOperation) arguments.get(0),
					(EOperation) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

} // PropagationImpl
