/**
 */
package de.ubt.ai1.modGraph.example.eRefactoring.impl;

import java.lang.reflect.InvocationTargetException;
import java.util.Collection;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.ECollections;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EEnumLiteral;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EParameter;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcoreFactory;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.EcoreUtil.Copier;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;

import com.google.common.base.Objects;

import de.ubt.ai1.modGraph.example.eRefactoring.ClassType;
import de.ubt.ai1.modGraph.example.eRefactoring.ERefactoringPackage;
import de.ubt.ai1.modGraph.example.eRefactoring.Helper;
import de.ubt.ai1.modGraph.example.eRefactoring.Refactoring;
import de.ubt.ai1.modGraph.example.eRefactoring.util.GTUtil4RefactoringextractEClassNEW;
import de.ubt.ai1.modgraph.gt.ecoreFromXcore.generator.ocl.OCLHandler;
import de.ubt.ai1.modgraph.gt.failure.GTFailure;
import java.lang.Iterable;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Refactoring</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.impl.RefactoringImpl#getHelper <em>Helper</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.impl.RefactoringImpl#getReferenceToEPackage <em>Reference To EPackage</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.impl.RefactoringImpl#getReferenceToENamedElement <em>Reference To ENamed Element</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.impl.RefactoringImpl#getReferenceToEOperation <em>Reference To EOperation</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.impl.RefactoringImpl#getReferenceToEClass <em>Reference To EClass</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.impl.RefactoringImpl#getReferenceToEAttribute <em>Reference To EAttribute</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.impl.RefactoringImpl#getReferenceToEReference <em>Reference To EReference</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.impl.RefactoringImpl#getReferenceToEParameter <em>Reference To EParameter</em>}</li>
 *   <li>{@link de.ubt.ai1.modGraph.example.eRefactoring.impl.RefactoringImpl#getReferenceToEStructuralFeature <em>Reference To EStructural Feature</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RefactoringImpl extends MinimalEObjectImpl.Container implements
		Refactoring {
	/**
	 * The cached value of the '{@link #getHelper() <em>Helper</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHelper()
	 * @generated
	 * @ordered
	 */
	protected Helper helper;

	/**
	 * The cached value of the '{@link #getReferenceToEPackage() <em>Reference To EPackage</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReferenceToEPackage()
	 * @generated
	 * @ordered
	 */
	protected EList<EPackage> referenceToEPackage;

	/**
	 * The cached value of the '{@link #getReferenceToENamedElement()
	 * <em>Reference To ENamed Element</em>}' reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getReferenceToENamedElement()
	 * @generated
	 * @ordered
	 */
	protected EList<ENamedElement> referenceToENamedElement;

	/**
	 * The cached value of the '{@link #getReferenceToEOperation() <em>Reference To EOperation</em>}' reference list.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @see #getReferenceToEOperation()
	 * @generated
	 * @ordered
	 */
	protected EList<EOperation> referenceToEOperation;

	/**
	 * The cached value of the '{@link #getReferenceToEClass() <em>Reference To EClass</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReferenceToEClass()
	 * @generated
	 * @ordered
	 */
	protected EList<EClass> referenceToEClass;

	/**
	 * The cached value of the '{@link #getReferenceToEAttribute() <em>Reference To EAttribute</em>}' reference list.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @see #getReferenceToEAttribute()
	 * @generated
	 * @ordered
	 */
	protected EList<EAttribute> referenceToEAttribute;

	/**
	 * The cached value of the '{@link #getReferenceToEReference() <em>Reference To EReference</em>}' reference list.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @see #getReferenceToEReference()
	 * @generated
	 * @ordered
	 */
	protected EList<EReference> referenceToEReference;

	/**
	 * The cached value of the '{@link #getReferenceToEParameter() <em>Reference To EParameter</em>}' reference list.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @see #getReferenceToEParameter()
	 * @generated
	 * @ordered
	 */
	protected EList<EParameter> referenceToEParameter;

	/**
	 * The cached value of the '{@link #getReferenceToEStructuralFeature()
	 * <em>Reference To EStructural Feature</em>}' reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getReferenceToEStructuralFeature()
	 * @generated
	 * @ordered
	 */
	protected EList<EStructuralFeature> referenceToEStructuralFeature;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected RefactoringImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ERefactoringPackage.Literals.REFACTORING;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Helper getHelper() {
		if (helper != null && helper.eIsProxy()) {
			InternalEObject oldHelper = (InternalEObject)helper;
			helper = (Helper)eResolveProxy(oldHelper);
			if (helper != oldHelper) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ERefactoringPackage.REFACTORING__HELPER, oldHelper, helper));
			}
		}
		return helper;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Helper basicGetHelper() {
		return helper;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setHelper(Helper newHelper) {
		Helper oldHelper = helper;
		helper = newHelper;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ERefactoringPackage.REFACTORING__HELPER, oldHelper, helper));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EPackage> getReferenceToEPackage() {
		if (referenceToEPackage == null) {
			referenceToEPackage = new EObjectResolvingEList<EPackage>(EPackage.class, this, ERefactoringPackage.REFACTORING__REFERENCE_TO_EPACKAGE);
		}
		return referenceToEPackage;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ENamedElement> getReferenceToENamedElement() {
		if (referenceToENamedElement == null) {
			referenceToENamedElement = new EObjectResolvingEList<ENamedElement>(ENamedElement.class, this, ERefactoringPackage.REFACTORING__REFERENCE_TO_ENAMED_ELEMENT);
		}
		return referenceToENamedElement;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EOperation> getReferenceToEOperation() {
		if (referenceToEOperation == null) {
			referenceToEOperation = new EObjectResolvingEList<EOperation>(EOperation.class, this, ERefactoringPackage.REFACTORING__REFERENCE_TO_EOPERATION);
		}
		return referenceToEOperation;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EClass> getReferenceToEClass() {
		if (referenceToEClass == null) {
			referenceToEClass = new EObjectResolvingEList<EClass>(EClass.class, this, ERefactoringPackage.REFACTORING__REFERENCE_TO_ECLASS);
		}
		return referenceToEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EAttribute> getReferenceToEAttribute() {
		if (referenceToEAttribute == null) {
			referenceToEAttribute = new EObjectResolvingEList<EAttribute>(EAttribute.class, this, ERefactoringPackage.REFACTORING__REFERENCE_TO_EATTRIBUTE);
		}
		return referenceToEAttribute;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EReference> getReferenceToEReference() {
		if (referenceToEReference == null) {
			referenceToEReference = new EObjectResolvingEList<EReference>(EReference.class, this, ERefactoringPackage.REFACTORING__REFERENCE_TO_EREFERENCE);
		}
		return referenceToEReference;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EParameter> getReferenceToEParameter() {
		if (referenceToEParameter == null) {
			referenceToEParameter = new EObjectResolvingEList<EParameter>(EParameter.class, this, ERefactoringPackage.REFACTORING__REFERENCE_TO_EPARAMETER);
		}
		return referenceToEParameter;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EStructuralFeature> getReferenceToEStructuralFeature() {
		if (referenceToEStructuralFeature == null) {
			referenceToEStructuralFeature = new EObjectResolvingEList<EStructuralFeature>(EStructuralFeature.class, this, ERefactoringPackage.REFACTORING__REFERENCE_TO_ESTRUCTURAL_FEATURE);
		}
		return referenceToEStructuralFeature;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void renameENamedElement(final String oldName, final String newName) {
		try {
			ENamedElement elementToRename = null;
			EList<ENamedElement> _referenceToENamedElement = this.getReferenceToENamedElement();
			final Function1<ENamedElement, Boolean> _function = new Function1<ENamedElement, Boolean>() {
				public Boolean apply(final ENamedElement e) {
					String _name = e.getName();
					return Boolean.valueOf(Objects.equal(_name, oldName));
				}
			};
			Iterable<ENamedElement> _filter = IterableExtensions.<ENamedElement>filter(_referenceToENamedElement, _function);
			for (final ENamedElement _elementToRename : _filter) {
				{
					boolean _evaluateOCLCondition = OCLHandler.evaluateOCLCondition(
						"self.oclAsType(EObject).eContainer().eContents()->select(name = newName)->size()=0", _elementToRename);
					if (_evaluateOCLCondition) {
						throw new GTFailure();
					}
					elementToRename = _elementToRename;
				}
			}
			boolean _equals = Objects.equal(elementToRename, null);
			if (_equals) {
				throw new GTFailure();
			}
			final String elementToRenameNameValue = newName;
			elementToRename.setName(elementToRenameNameValue);
		}
		catch (Throwable _e) {
			throw org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void renameENamedElement(final ENamedElement element,
			final String newName) {
		EObject _eContainer = element.eContainer();
		EList<EObject> _eContents = _eContainer.eContents();
		final Function1<EObject, Boolean> _function = new Function1<EObject, Boolean>() {
			public Boolean apply(final EObject e) {
				EClass _eClass = e.eClass();
				return Boolean.valueOf(Objects.equal(_eClass, EClass.class));
			}
		};
		Iterable<EObject> _filter = IterableExtensions.<EObject>filter(_eContents, _function);
		final Function1<EObject, Boolean> _function_1 = new Function1<EObject, Boolean>() {
			public Boolean apply(final EObject e) {
				boolean _and = false;
				EClass _eClass = e.eClass();
				EClass _eClass_1 = element.eClass();
				boolean _equals = Objects.equal(_eClass, _eClass_1);
				if (!_equals) {
					_and = false;
				} else {
					String _name = ((EClass) e).getName();
					boolean _equals_1 = Objects.equal(_name, newName);
					_and = _equals_1;
				}
				return Boolean.valueOf(_and);
			}
		};
		boolean _exists = IterableExtensions.<EObject>exists(_filter, _function_1);
		if (_exists) {
			return;
		}
		else {
			element.setName(newName);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void addEParameter(final String operationName,
			final String parameterName, final EClassifier paramType) {
		EOperation op1 = null;
		EList<EOperation> _referenceToEOperation = this.getReferenceToEOperation();
		final Function1<EOperation, Boolean> _function = new Function1<EOperation, Boolean>() {
			public Boolean apply(final EOperation e) {
				String _name = e.getName();
				return Boolean.valueOf(Objects.equal(_name, operationName));
			}
		};
		Iterable<EOperation> _filter = IterableExtensions.<EOperation>filter(_referenceToEOperation, _function);
		for (final EOperation _op1 : _filter) {
			EList<EParameter> _eParameters = _op1.getEParameters();
			final Function1<EParameter, Boolean> _function_1 = new Function1<EParameter, Boolean>() {
				public Boolean apply(final EParameter e) {
					String _name = e.getName();
					return Boolean.valueOf(Objects.equal(_name, parameterName));
				}
			};
			EParameter _findFirst = IterableExtensions.<EParameter>findFirst(_eParameters, _function_1);
			boolean _notEquals = (!Objects.equal(_findFirst, null));
			boolean _not = (!_notEquals);
			if (_not) {
				op1 = _op1;
			}
		}
		final String newParameterNameValue = parameterName;
		EParameter newParameter = EcoreFactory.eINSTANCE.createEParameter();
		newParameter.setName(newParameterNameValue);
		EList<EParameter> _eParameters_1 = op1.getEParameters();
		_eParameters_1.add(newParameter);
		newParameter.setEType(paramType);
		EList<EParameter> _referenceToEParameter = this.getReferenceToEParameter();
		_referenceToEParameter.add(newParameter);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void removeEParameter(final String operationName,
			final String parameterName) {
		try {
			EOperation operation = null;
			EParameter parameter = null;
			EList<EOperation> _referenceToEOperation = this.getReferenceToEOperation();
			final Function1<EOperation, Boolean> _function = new Function1<EOperation, Boolean>() {
				public Boolean apply(final EOperation e) {
					String _name = e.getName();
					return Boolean.valueOf(Objects.equal(_name, operationName));
				}
			};
			Iterable<EOperation> _filter = IterableExtensions.<EOperation>filter(_referenceToEOperation, _function);
			for (final EOperation _operation : _filter) {
				EList<EParameter> _referenceToEParameter = this.getReferenceToEParameter();
				final Function1<EParameter, Boolean> _function_1 = new Function1<EParameter, Boolean>() {
					public Boolean apply(final EParameter e) {
						boolean _and = false;
						String _name = e.getName();
						boolean _equals = Objects.equal(_name, parameterName);
						if (!_equals) {
							_and = false;
						} else {
							EList<EParameter> _eParameters = _operation.getEParameters();
							boolean _contains = _eParameters.contains(e);
							_and = _contains;
						}
						return Boolean.valueOf(_and);
					}
				};
				Iterable<EParameter> _filter_1 = IterableExtensions.<EParameter>filter(_referenceToEParameter, _function_1);
				for (final EParameter _parameter : _filter_1) {
					{
						operation = _operation;
						parameter = _parameter;
					}
				}
			}
			boolean _equals = Objects.equal(operation, null);
			if (_equals) {
				throw new GTFailure();
			}
			EcoreUtil.remove(parameter);
		}
		catch (Throwable _e) {
			throw org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void moveEOperation(final String operationName,
			final String targetClassName, final String sourceClassName) {
		try {
			EClass sourceClass = null;
			EClass targetClass = null;
			EOperation operation = null;
			EList<EOperation> _referenceToEOperation = this.getReferenceToEOperation();
			final Function1<EOperation, Boolean> _function = new Function1<EOperation, Boolean>() {
				public Boolean apply(final EOperation e) {
					String _name = e.getName();
					return Boolean.valueOf(Objects.equal(_name, operationName));
				}
			};
			Iterable<EOperation> _filter = IterableExtensions.<EOperation>filter(_referenceToEOperation, _function);
			for (final EOperation _operation : _filter) {
				EList<EClass> _referenceToEClass = this.getReferenceToEClass();
				final Function1<EClass, Boolean> _function_1 = new Function1<EClass, Boolean>() {
					public Boolean apply(final EClass e) {
						boolean _and = false;
						String _name = e.getName();
						boolean _equals = Objects.equal(_name, sourceClassName);
						if (!_equals) {
							_and = false;
						} else {
							EList<EOperation> _eOperations = e.getEOperations();
							boolean _contains = _eOperations.contains(_operation);
							_and = _contains;
						}
						return Boolean.valueOf(_and);
					}
				};
				Iterable<EClass> _filter_1 = IterableExtensions.<EClass>filter(_referenceToEClass, _function_1);
				for (final EClass _sourceClass : _filter_1) {
					EList<EClass> _referenceToEClass_1 = this.getReferenceToEClass();
					final Function1<EClass, Boolean> _function_2 = new Function1<EClass, Boolean>() {
						public Boolean apply(final EClass e) {
							String _name = e.getName();
							return Boolean.valueOf(Objects.equal(_name, targetClassName));
						}
					};
					Iterable<EClass> _filter_2 = IterableExtensions.<EClass>filter(_referenceToEClass_1, _function_2);
					for (final EClass _targetClass : _filter_2) {
						{
							EList<EOperation> _eOperations = _targetClass.getEOperations();
							final Function1<EOperation, Boolean> _function_3 = new Function1<EOperation, Boolean>() {
								public Boolean apply(final EOperation e) {
									String _name = e.getName();
									return Boolean.valueOf(Objects.equal(_name, operationName));
								}
							};
							EOperation _findFirst = IterableExtensions.<EOperation>findFirst(_eOperations, _function_3);
							boolean _notEquals = (!Objects.equal(_findFirst, null));
							boolean _not = (!_notEquals);
							if (_not) {
								sourceClass = _sourceClass;
							}
							targetClass = _targetClass;
							operation = _operation;
						}
					}
				}
			}
			boolean _equals = Objects.equal(sourceClass, null);
			if (_equals) {
				throw new GTFailure();
			}
			EList<EOperation> _eOperations = sourceClass.getEOperations();
			_eOperations.remove(operation);
			EList<EOperation> _eOperations_1 = targetClass.getEOperations();
			_eOperations_1.add(operation);
		}
		catch (Throwable _e) {
			throw org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void moveEAttribute(final String attributeName,
			final String targetClassName, final String sourceClassName) {
		try {
			boolean _notEquals = (!Objects.equal(attributeName, null));
			boolean _not = (!_notEquals);
			if (_not) {
				throw new GTFailure();
			}
			EClass sourceClass = null;
			EClass targetClass = null;
			EAttribute attribute = null;
			EList<EClass> _referenceToEClass = this.getReferenceToEClass();
			final Function1<EClass, Boolean> _function = new Function1<EClass, Boolean>() {
				public Boolean apply(final EClass e) {
					String _name = e.getName();
					return Boolean.valueOf(Objects.equal(_name, sourceClassName));
				}
			};
			Iterable<EClass> _filter = IterableExtensions.<EClass>filter(_referenceToEClass, _function);
			for (final EClass _sourceClass : _filter) {
				EList<EClass> _referenceToEClass_1 = this.getReferenceToEClass();
				final Function1<EClass, Boolean> _function_1 = new Function1<EClass, Boolean>() {
					public Boolean apply(final EClass e) {
						String _name = e.getName();
						return Boolean.valueOf(Objects.equal(_name, targetClassName));
					}
				};
				Iterable<EClass> _filter_1 = IterableExtensions.<EClass>filter(_referenceToEClass_1, _function_1);
				for (final EClass _targetClass : _filter_1) {
					EList<EAttribute> _referenceToEAttribute = this.getReferenceToEAttribute();
					final Function1<EAttribute, Boolean> _function_2 = new Function1<EAttribute, Boolean>() {
						public Boolean apply(final EAttribute e) {
							boolean _and = false;
							String _name = e.getName();
							boolean _equals = Objects.equal(_name, attributeName);
							if (!_equals) {
								_and = false;
							} else {
								EList<EAttribute> _eAttributes = _sourceClass.getEAttributes();
								boolean _contains = _eAttributes.contains(e);
								_and = _contains;
							}
							return Boolean.valueOf(_and);
						}
					};
					Iterable<EAttribute> _filter_2 = IterableExtensions.<EAttribute>filter(_referenceToEAttribute, _function_2);
					for (final EAttribute _attribute : _filter_2) {
						{
							EList<EAttribute> _eAttributes = _targetClass.getEAttributes();
							final Function1<EAttribute, Boolean> _function_3 = new Function1<EAttribute, Boolean>() {
								public Boolean apply(final EAttribute e) {
									String _name = e.getName();
									return Boolean.valueOf(Objects.equal(_name, attributeName));
								}
							};
							EAttribute _findFirst = IterableExtensions.<EAttribute>findFirst(_eAttributes, _function_3);
							boolean _notEquals_1 = (!Objects.equal(_findFirst, null));
							boolean _not_1 = (!_notEquals_1);
							if (_not_1) {
								sourceClass = _sourceClass;
							}
							targetClass = _targetClass;
							attribute = _attribute;
						}
					}
				}
			}
			boolean _equals = Objects.equal(sourceClass, null);
			if (_equals) {
				throw new GTFailure();
			}
			EList<EStructuralFeature> _eStructuralFeatures = sourceClass.getEStructuralFeatures();
			_eStructuralFeatures.remove(attribute);
			EList<EStructuralFeature> _eStructuralFeatures_1 = targetClass.getEStructuralFeatures();
			_eStructuralFeatures_1.add(attribute);
		}
		catch (Throwable _e) {
			throw org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void inlineEClass(final String sourceClassName,
			final String targetClassName) {
		EList<EClass> _referenceToEClass = this.getReferenceToEClass();
		final Function1<EClass, Boolean> _function = new Function1<EClass, Boolean>() {
			public Boolean apply(final EClass e) {
				String _name = e.getName();
				return Boolean.valueOf(Objects.equal(_name, targetClassName));
			}
		};
		final EClass existingClass = IterableExtensions.<EClass>findFirst(_referenceToEClass, _function);
		EList<EClass> _referenceToEClass_1 = this.getReferenceToEClass();
		final Function1<EClass, Boolean> _function_1 = new Function1<EClass, Boolean>() {
			public Boolean apply(final EClass e) {
				String _name = e.getName();
				return Boolean.valueOf(Objects.equal(_name, sourceClassName));
			}
		};
		final EClass delitionClass = IterableExtensions.<EClass>findFirst(_referenceToEClass_1, _function_1);
		EList<EReference> _referenceToEReference = this.getReferenceToEReference();
		final Function1<EReference, Boolean> _function_2 = new Function1<EReference, Boolean>() {
			public Boolean apply(final EReference e) {
				EClassifier _eType = e.getEType();
				return Boolean.valueOf(_eType.equals(delitionClass));
			}
		};
		Iterable<EReference> _filter = IterableExtensions.<EReference>filter(_referenceToEReference, _function_2);
		final EList<EReference> references = ECollections.<EReference>asEList(((EReference[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter, EReference.class)));
		EList<EReference> _referenceToEReference_1 = this.getReferenceToEReference();
		final Function1<EReference, Boolean> _function_3 = new Function1<EReference, Boolean>() {
			public Boolean apply(final EReference e) {
				EList<EStructuralFeature> _eStructuralFeatures = delitionClass.getEStructuralFeatures();
				return Boolean.valueOf(_eStructuralFeatures.contains(e));
			}
		};
		Iterable<EReference> _filter_1 = IterableExtensions.<EReference>filter(_referenceToEReference_1, _function_3);
		final EList<EReference> containedReferences = ECollections.<EReference>asEList(((EReference[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter_1, EReference.class)));
		EList<EOperation> _referenceToEOperation = this.getReferenceToEOperation();
		final Function1<EOperation, Boolean> _function_4 = new Function1<EOperation, Boolean>() {
			public Boolean apply(final EOperation e) {
				EList<EOperation> _eOperations = delitionClass.getEOperations();
				return Boolean.valueOf(_eOperations.contains(e));
			}
		};
		Iterable<EOperation> _filter_2 = IterableExtensions.<EOperation>filter(_referenceToEOperation, _function_4);
		final EList<EOperation> eOperations = ECollections.<EOperation>asEList(((EOperation[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter_2, EOperation.class)));
		EList<EAttribute> _referenceToEAttribute = this.getReferenceToEAttribute();
		final Function1<EAttribute, Boolean> _function_5 = new Function1<EAttribute, Boolean>() {
			public Boolean apply(final EAttribute e) {
				EList<EStructuralFeature> _eStructuralFeatures = delitionClass.getEStructuralFeatures();
				return Boolean.valueOf(_eStructuralFeatures.contains(e));
			}
		};
		Iterable<EAttribute> _filter_3 = IterableExtensions.<EAttribute>filter(_referenceToEAttribute, _function_5);
		final EList<EAttribute> attributes = ECollections.<EAttribute>asEList(((EAttribute[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter_3, EAttribute.class)));
		EcoreUtil.remove(delitionClass);
		EList<EOperation> _eOperations = existingClass.getEOperations();
		_eOperations.addAll(eOperations);
		final Procedure1<EReference> _function_6 = new Procedure1<EReference>() {
			public void apply(final EReference e) {
				e.setEType(existingClass);
			}
		};
		IterableExtensions.<EReference>forEach(references, _function_6);
		EList<EStructuralFeature> _eStructuralFeatures = existingClass.getEStructuralFeatures();
		_eStructuralFeatures.addAll(attributes);
		EList<EStructuralFeature> _eStructuralFeatures_1 = existingClass.getEStructuralFeatures();
		_eStructuralFeatures_1.addAll(containedReferences);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --><!--
	 * 
	 * @generated NOT modified by ModGraph
	 */
	public EClass extractEClassNEW(EClass existingClass,
			String existingClassNewName, String newClassName,
			String newReferenceName,
			EList<EStructuralFeature> structuralFeaturesToMove,
			EList<EOperation> operationsToMove) throws GTFailure {
		if (!(newClassName.length() > 0))
			throw new GTFailure();
		
		GTUtil4RefactoringextractEClassNEW util = new GTUtil4RefactoringextractEClassNEW();
		util.match(existingClass, existingClassNewName, newClassName,
				newReferenceName, structuralFeaturesToMove, operationsToMove,
				this);
		EPackage aPackage = (EPackage) util.get("aPackage");
		final java.lang.String existingClassNameValue = existingClassNewName;
		final java.lang.String newClassNameValue = newClassName;
		final java.lang.String newReferenceNameValue = newReferenceName;
		existingClass.setName(existingClassNameValue);
		existingClass.getEStructuralFeatures().remove(structuralFeaturesToMove);
		existingClass.getEOperations().remove(operationsToMove);
		EClass newClass = EcoreFactory.eINSTANCE.createEClass();
		newClass.setName(newClassNameValue);
		EReference newReference = EcoreFactory.eINSTANCE.createEReference();
		newReference.setName(newReferenceNameValue);
		newClass.getEOperations().addAll(operationsToMove);
		newClass.getEStructuralFeatures().addAll(structuralFeaturesToMove);
		existingClass.getEStructuralFeatures().add(newReference);
		newReference.setEType(newClass);
		aPackage.getEClassifiers().add(newClass);
		
		return newClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void extractEClass(final String existingClassName,
			final EList<String> attributeNames,
			final EList<String> referenceNames,
			final EList<String> operationNames, final String className) {
		try {
			EClass existingClass = null;
			EList<EOperation> eOperations = null;
			EList<EReference> references = null;
			EList<EAttribute> attributes = null;
			EList<EReference> containedReferences = null;
			EList<EClass> _referenceToEClass = this.getReferenceToEClass();
			final Function1<EClass, Boolean> _function = new Function1<EClass, Boolean>() {
				public Boolean apply(final EClass e) {
					String _name = e.getName();
					return Boolean.valueOf(Objects.equal(_name, existingClassName));
				}
			};
			Iterable<EClass> _filter = IterableExtensions.<EClass>filter(_referenceToEClass, _function);
			for (final EClass _existingClass : _filter) {
				{
					EList<EReference> _referenceToEReference = this.getReferenceToEReference();
					final Function1<EReference, Boolean> _function_1 = new Function1<EReference, Boolean>() {
						public Boolean apply(final EReference e) {
							boolean _and = false;
							EClassifier _eType = e.getEType();
							boolean _equals = _eType.equals(_existingClass);
							if (!_equals) {
								_and = false;
							} else {
								String _name = e.getName();
								boolean _contains = referenceNames.contains(_name);
								_and = _contains;
							}
							return Boolean.valueOf(_and);
						}
					};
					Iterable<EReference> _filter_1 = IterableExtensions.<EReference>filter(_referenceToEReference, _function_1);
					final EList<EReference> _references = ECollections.<EReference>asEList(((EReference[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter_1, EReference.class)));
					EList<EReference> _referenceToEReference_1 = this.getReferenceToEReference();
					final Function1<EReference, Boolean> _function_2 = new Function1<EReference, Boolean>() {
						public Boolean apply(final EReference e) {
							boolean _and = false;
							EList<EStructuralFeature> _eStructuralFeatures = _existingClass.getEStructuralFeatures();
							boolean _contains = _eStructuralFeatures.contains(e);
							if (!_contains) {
								_and = false;
							} else {
								String _name = e.getName();
								boolean _contains_1 = referenceNames.contains(_name);
								_and = _contains_1;
							}
							return Boolean.valueOf(_and);
						}
					};
					Iterable<EReference> _filter_2 = IterableExtensions.<EReference>filter(_referenceToEReference_1, _function_2);
					final EList<EReference> _containedReferences = ECollections.<EReference>asEList(((EReference[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter_2, EReference.class)));
					EList<EOperation> _referenceToEOperation = this.getReferenceToEOperation();
					final Function1<EOperation, Boolean> _function_3 = new Function1<EOperation, Boolean>() {
						public Boolean apply(final EOperation e) {
							EList<EOperation> _eOperations = _existingClass.getEOperations();
							return Boolean.valueOf(_eOperations.contains(e));
						}
					};
					Iterable<EOperation> _filter_3 = IterableExtensions.<EOperation>filter(_referenceToEOperation, _function_3);
					final EList<EOperation> _eOperations = ECollections.<EOperation>asEList(((EOperation[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter_3, EOperation.class)));
					EList<EAttribute> _referenceToEAttribute = this.getReferenceToEAttribute();
					final Function1<EAttribute, Boolean> _function_4 = new Function1<EAttribute, Boolean>() {
						public Boolean apply(final EAttribute e) {
							boolean _and = false;
							EList<EStructuralFeature> _eStructuralFeatures = _existingClass.getEStructuralFeatures();
							boolean _contains = _eStructuralFeatures.contains(e);
							if (!_contains) {
								_and = false;
							} else {
								String _name = e.getName();
								boolean _contains_1 = attributeNames.contains(_name);
								_and = _contains_1;
							}
							return Boolean.valueOf(_and);
						}
					};
					Iterable<EAttribute> _filter_4 = IterableExtensions.<EAttribute>filter(_referenceToEAttribute, _function_4);
					final EList<EAttribute> _attributes = ECollections.<EAttribute>asEList(((EAttribute[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter_4, EAttribute.class)));
					existingClass = _existingClass;
					eOperations = _eOperations;
					references = _references;
					attributes = _attributes;
					containedReferences = _containedReferences;
				}
			}
			boolean _equals = Objects.equal(existingClass, null);
			if (_equals) {
				throw new GTFailure();
			}
			final String extractedClassNameValue = className;
			EList<EOperation> _eOperations = existingClass.getEOperations();
			_eOperations.removeAll(eOperations);
			final Procedure1<EReference> _function_1 = new Procedure1<EReference>() {
				public void apply(final EReference node) {
					node.setEType(null);
				}
			};
			IterableExtensions.<EReference>forEach(references, _function_1);
			EList<EStructuralFeature> _eStructuralFeatures = existingClass.getEStructuralFeatures();
			_eStructuralFeatures.removeAll(attributes);
			EList<EStructuralFeature> _eStructuralFeatures_1 = existingClass.getEStructuralFeatures();
			_eStructuralFeatures_1.removeAll(containedReferences);
			EClass extractedClass = EcoreFactory.eINSTANCE.createEClass();
			extractedClass.setName(extractedClassNameValue);
			EList<EClass> _referenceToEClass_1 = this.getReferenceToEClass();
			_referenceToEClass_1.add(extractedClass);
			EList<EOperation> _eOperations_1 = extractedClass.getEOperations();
			_eOperations_1.addAll(eOperations);
			EList<EStructuralFeature> _eStructuralFeatures_2 = extractedClass.getEStructuralFeatures();
			_eStructuralFeatures_2.addAll(attributes);
			EList<EStructuralFeature> _eStructuralFeatures_3 = extractedClass.getEStructuralFeatures();
			_eStructuralFeatures_3.addAll(containedReferences);
		}
		catch (Throwable _e) {
			throw org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void extractEClass2(final String sourceCl,
			final EList<String> attributes, final EList<String> operations,
			final String className) {
		final EClass newClass = EcoreFactory.eINSTANCE.createEClass();
		Helper _helper = this.getHelper();
		EClass sourceClass = _helper.getClass(sourceCl);
		EList<EClass> _referenceToEClass = this.getReferenceToEClass();
		_referenceToEClass.add(newClass);
		newClass.setName(className);
		boolean _isEmpty = attributes.isEmpty();
		boolean _not = (!_isEmpty);
		if (_not) {
			for (final String s : attributes) {
				try {
					String _name = newClass.getName();
					String _name_1 = sourceClass.getName();
					this.moveEAttribute(s, _name, _name_1);
				}
				catch (final Throwable _t) {
					if (_t instanceof GTFailure) {
						final GTFailure f = (GTFailure)_t;
					}
					else {
						throw Exceptions.sneakyThrow(_t);
					}
				}
			}
		}
		boolean _isEmpty_1 = operations.isEmpty();
		boolean _not_1 = (!_isEmpty_1);
		if (_not_1) {
			for (final String s2 : operations) {
				try {
					String _name_2 = newClass.getName();
					String _name_3 = sourceClass.getName();
					this.moveEOperation(s2, _name_2, _name_3);
				}
				catch (final Throwable _t_1) {
					if (_t_1 instanceof GTFailure) {
						final GTFailure f_1 = (GTFailure)_t_1;
					}
					else {
						throw Exceptions.sneakyThrow(_t_1);
					}
				}
			}
		}
		final EReference newRef = EcoreFactory.eINSTANCE.createEReference();
		String _name_4 = newClass.getName();
		newRef.setName(_name_4);
		newRef.setEType(newClass);
		EList<EStructuralFeature> _eStructuralFeatures = sourceClass.getEStructuralFeatures();
		_eStructuralFeatures.add(newRef);
		EPackage _ePackage = sourceClass.getEPackage();
		EList<EClassifier> _eClassifiers = _ePackage.getEClassifiers();
		_eClassifiers.add(newClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void pullUpEAttribute(final String attributeToPullUp,
			final String superCl) {
		Helper _helper = this.getHelper();
		EClass superClass = _helper.getClass(superCl);
		Helper _helper_1 = this.getHelper();
		EList<EClass> subClasses = _helper_1.getAllSubClasses(superClass);
		EClass sourceClass = subClasses.get(0);
		EList<EStructuralFeature> _eStructuralFeatures = superClass.getEStructuralFeatures();
		Helper _helper_2 = this.getHelper();
		EAttribute _attributeByName = _helper_2.getAttributeByName(sourceClass, attributeToPullUp);
		_eStructuralFeatures.add(_attributeByName);
		for (final EClass c : subClasses) {
			Helper _helper_3 = this.getHelper();
			_helper_3.removeAttributeByName(c, attributeToPullUp);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void pushDownEAttribute(final String attributeToPushDown,
			final String superCl) {
		final Copier copier = new Copier();
		Helper _helper = this.getHelper();
		EClass superClass = _helper.getClass(superCl);
		Helper _helper_1 = this.getHelper();
		final EAttribute b = _helper_1.getAttributeByName(superClass, attributeToPushDown);
		final EClassifier EType = b.getEType();
		final int lBound = b.getLowerBound();
		final int uBound = b.getUpperBound();
		Helper _helper_2 = this.getHelper();
		EList<EClass> _allSubClasses = _helper_2.getAllSubClasses(superClass);
		for (final EClass c : _allSubClasses) {
			{
				EObject _copy = copier.copy(b);
				EAttribute a = ((EAttribute) _copy);
				a.setEType(EType);
				a.setLowerBound(lBound);
				a.setUpperBound(uBound);
				EList<EStructuralFeature> _eStructuralFeatures = c.getEStructuralFeatures();
				_eStructuralFeatures.add(a);
			}
		}
		Helper _helper_3 = this.getHelper();
		_helper_3.removeAttributeByName(superClass, attributeToPushDown);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void pullUpEOperation(final String operationToPullUp,
			final String superCl) {
		Helper _helper = this.getHelper();
		EClass superClass = _helper.getClass(superCl);
		Helper _helper_1 = this.getHelper();
		EList<EClass> subClasses = _helper_1.getAllSubClasses(superClass);
		EClass sourceClass = subClasses.get(0);
		EList<EOperation> _eOperations = superClass.getEOperations();
		Helper _helper_2 = this.getHelper();
		EOperation _operationByName = _helper_2.getOperationByName(sourceClass, operationToPullUp);
		_eOperations.add(_operationByName);
		for (final EClass c : subClasses) {
			Helper _helper_3 = this.getHelper();
			_helper_3.removeOperationByName(c, operationToPullUp);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void pushDownEOperation(final String operationToPushDown,
			final String superCl) {
		final Copier copier = new Copier();
		Helper _helper = this.getHelper();
		EClass superClass = _helper.getClass(superCl);
		Helper _helper_1 = this.getHelper();
		final EOperation b = _helper_1.getOperationByName(superClass, operationToPushDown);
		final EClassifier EType = b.getEType();
		final int lBound = b.getLowerBound();
		final int uBound = b.getUpperBound();
		Helper _helper_2 = this.getHelper();
		EList<EClass> _allSubClasses = _helper_2.getAllSubClasses(superClass);
		for (final EClass c : _allSubClasses) {
			{
				EObject _copy = copier.copy(b);
				EOperation a = ((EOperation) _copy);
				a.setEType(EType);
				a.setLowerBound(lBound);
				a.setUpperBound(uBound);
				EList<EOperation> _eOperations = c.getEOperations();
				_eOperations.add(a);
			}
		}
		Helper _helper_3 = this.getHelper();
		_helper_3.removeOperationByName(superClass, operationToPushDown);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void extractSuperClassInit(final EList<EClass> classes,
			final String name) {
		List<EOperation> sharedOperations = new LinkedList<EOperation>();
		List<EAttribute> sharedAttributes = new LinkedList<EAttribute>();
		List<EReference> sharedReferences = new LinkedList<EReference>();
		EClass _get = classes.get(0);
		EList<EAttribute> _eAttributes = _get.getEAttributes();
		sharedAttributes.addAll(_eAttributes);
		EClass _get_1 = classes.get(0);
		EList<EOperation> _eOperations = _get_1.getEOperations();
		sharedOperations.addAll(_eOperations);
		EClass _get_2 = classes.get(0);
		EList<EReference> _eReferences = _get_2.getEReferences();
		sharedReferences.addAll(_eReferences);
		for (final EClass c : classes) {
			{
				EClass _get_3 = classes.get(0);
				EList<EAttribute> _eAttributes_1 = _get_3.getEAttributes();
				for (final EAttribute a : _eAttributes_1) {
					EList<EAttribute> _eAttributes_2 = c.getEAttributes();
					final Function1<EAttribute, Boolean> _function = new Function1<EAttribute, Boolean>() {
						public Boolean apply(final EAttribute ca) {
							boolean _and = false;
							String _name = ca.getName();
							String _name_1 = a.getName();
							boolean _equals = Objects.equal(_name, _name_1);
							if (!_equals) {
								_and = false;
							} else {
								EClassifier _eType = ca.getEType();
								EClassifier _eType_1 = a.getEType();
								boolean _equals_1 = Objects.equal(_eType, _eType_1);
								_and = _equals_1;
							}
							return Boolean.valueOf(_and);
						}
					};
					EAttribute _findFirst = IterableExtensions.<EAttribute>findFirst(_eAttributes_2, _function);
					boolean _equals = Objects.equal(_findFirst, null);
					if (_equals) {
						sharedAttributes.remove(a);
					}
				}
				EClass _get_4 = classes.get(0);
				EList<EOperation> _eOperations_1 = _get_4.getEOperations();
				for (final EOperation o : _eOperations_1) {
					EList<EOperation> _eOperations_2 = c.getEOperations();
					final Function1<EOperation, Boolean> _function_1 = new Function1<EOperation, Boolean>() {
						public Boolean apply(final EOperation co) {
							boolean _and = false;
							String _name = co.getName();
							String _name_1 = o.getName();
							boolean _equals = Objects.equal(_name, _name_1);
							if (!_equals) {
								_and = false;
							} else {
								EClassifier _eType = co.getEType();
								EClassifier _eType_1 = o.getEType();
								boolean _equals_1 = Objects.equal(_eType, _eType_1);
								_and = _equals_1;
							}
							return Boolean.valueOf(_and);
						}
					};
					EOperation _findFirst_1 = IterableExtensions.<EOperation>findFirst(_eOperations_2, _function_1);
					boolean _equals_1 = Objects.equal(_findFirst_1, null);
					if (_equals_1) {
						sharedOperations.remove(o);
					}
					else {
						EList<EOperation> _eOperations_3 = c.getEOperations();
						final Function1<EOperation, Boolean> _function_2 = new Function1<EOperation, Boolean>() {
							public Boolean apply(final EOperation co) {
								boolean _and = false;
								String _name = co.getName();
								String _name_1 = o.getName();
								boolean _equals = Objects.equal(_name, _name_1);
								if (!_equals) {
									_and = false;
								} else {
									EClassifier _eType = co.getEType();
									EClassifier _eType_1 = o.getEType();
									boolean _equals_1 = Objects.equal(_eType, _eType_1);
									_and = _equals_1;
								}
								return Boolean.valueOf(_and);
							}
						};
						EOperation _findFirst_2 = IterableExtensions.<EOperation>findFirst(_eOperations_3, _function_2);
						EList<EParameter> _eParameters = _findFirst_2.getEParameters();
						final Function1<EParameter, Boolean> _function_3 = new Function1<EParameter, Boolean>() {
							public Boolean apply(final EParameter p) {
								EList<EParameter> _eParameters = o.getEParameters();
								final Function1<EParameter, Boolean> _function = new Function1<EParameter, Boolean>() {
									public Boolean apply(final EParameter sp) {
										boolean _and = false;
										String _name = sp.getName();
										String _name_1 = p.getName();
										boolean _equals = Objects.equal(_name, _name_1);
										if (!_equals) {
											_and = false;
										} else {
											EClassifier _eType = sp.getEType();
											EClassifier _eType_1 = p.getEType();
											boolean _equals_1 = Objects.equal(_eType, _eType_1);
											_and = _equals_1;
										}
										return Boolean.valueOf(_and);
									}
								};
								EParameter _findFirst = IterableExtensions.<EParameter>findFirst(_eParameters, _function);
								return Boolean.valueOf((!Objects.equal(_findFirst, null)));
							}
						};
						boolean _forall = IterableExtensions.<EParameter>forall(_eParameters, _function_3);
						boolean _equals_2 = (_forall == false);
						if (_equals_2) {
							sharedOperations.remove(o);
						}
					}
				}
				EClass _get_5 = classes.get(0);
				EList<EReference> _eReferences_1 = _get_5.getEReferences();
				for (final EReference r : _eReferences_1) {
					EList<EReference> _eReferences_2 = c.getEReferences();
					final Function1<EReference, Boolean> _function_4 = new Function1<EReference, Boolean>() {
						public Boolean apply(final EReference cr) {
							boolean _and = false;
							String _name = cr.getName();
							boolean _equals = Objects.equal(_name, name);
							if (!_equals) {
								_and = false;
							} else {
								EClassifier _eType = cr.getEType();
								EClassifier _eType_1 = r.getEType();
								boolean _equals_1 = Objects.equal(_eType, _eType_1);
								_and = _equals_1;
							}
							return Boolean.valueOf(_and);
						}
					};
					EReference _findFirst_3 = IterableExtensions.<EReference>findFirst(_eReferences_2, _function_4);
					boolean _equals_3 = Objects.equal(_findFirst_3, null);
					if (_equals_3) {
						sharedReferences.remove(r);
					}
				}
			}
		}
		try {
			BasicEList<EAttribute> _basicEList = new BasicEList<EAttribute>(sharedAttributes);
			BasicEList<EOperation> _basicEList_1 = new BasicEList<EOperation>(sharedOperations);
			BasicEList<EReference> _basicEList_2 = new BasicEList<EReference>(sharedReferences);
			EClass newSuperClass = this.extractSuperClass(name, _basicEList, _basicEList_1, _basicEList_2, classes);
			EClass _get_3 = classes.get(0);
			EPackage _ePackage = _get_3.getEPackage();
			EList<EClassifier> _eClassifiers = _ePackage.getEClassifiers();
			_eClassifiers.add(newSuperClass);
		}
		catch (final Throwable _t) {
			if (_t instanceof GTFailure) {
				final GTFailure f = (GTFailure)_t;
			}
			else {
				throw Exceptions.sneakyThrow(_t);
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EClass extractSuperClass(final String name,
			final EList<EAttribute> sharedAttributes,
			final EList<EOperation> sharedOperations,
			final EList<EReference> sharedReferences,
			final EList<EClass> classes) {
		try {
			EClass _get = classes.get(0);
			EObject _eContainer = _get.eContainer();
			EList<EObject> _eContents = _eContainer.eContents();
			final Function1<EClassifier, Boolean> _function = new Function1<EClassifier, Boolean>() {
				public Boolean apply(final EClassifier e) {
					String _name = e.getName();
					return Boolean.valueOf(Objects.equal(_name, name));
				}
			};
			EClassifier _findFirst = IterableExtensions.<EClassifier>findFirst(((Iterable<EClassifier>)org.eclipse.xtext.xbase.lib.Conversions.doWrapArray(((EClassifier[]) ((EClassifier[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_eContents, EClassifier.class))))), _function);
			boolean _equals = Objects.equal(_findFirst, null);
			boolean _not = (!_equals);
			if (_not) {
				throw new GTFailure();
			}
			final String superClassNameValue = name;
			final EClass superClass = EcoreFactory.eINSTANCE.createEClass();
			superClass.setName(superClassNameValue);
			final Procedure1<EClass> _function_1 = new Procedure1<EClass>() {
				public void apply(final EClass e) {
					EList<EClass> _eSuperTypes = e.getESuperTypes();
					_eSuperTypes.add(superClass);
				}
			};
			IterableExtensions.<EClass>forEach(classes, _function_1);
			EList<EStructuralFeature> _eStructuralFeatures = superClass.getEStructuralFeatures();
			_eStructuralFeatures.addAll(sharedAttributes);
			EList<EOperation> _eOperations = superClass.getEOperations();
			_eOperations.addAll(sharedOperations);
			EList<EStructuralFeature> _eStructuralFeatures_1 = superClass.getEStructuralFeatures();
			_eStructuralFeatures_1.addAll(sharedReferences);
			return superClass;
		}
		catch (Throwable _e) {
			throw org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void extractSuperClass2(final EList<EClass> classes,
			final String name) {
		final Copier copier = new Copier();
		final EClass newSuperClass = EcoreFactory.eINSTANCE.createEClass();
		newSuperClass.setName(name);
		newSuperClass.setAbstract(true);
		EList<EStructuralFeature> sharedAttributes = newSuperClass.getEStructuralFeatures();
		EList<EOperation> sharedOperations = newSuperClass.getEOperations();
		EClass _get = classes.get(0);
		EList<EAttribute> checkAttributes = _get.getEAttributes();
		EClass _get_1 = classes.get(0);
		EList<EOperation> checkOperations = _get_1.getEOperations();
		int count = 0;
		for (final EAttribute a : checkAttributes) {
			{
				for (final EClass c : classes) {
					{
						EList<EAttribute> cAttributes = c.getEAttributes();
						for (final EAttribute b : cAttributes) {
							String _name = b.getName();
							String _name_1 = a.getName();
							boolean _equals = Objects.equal(_name, _name_1);
							if (_equals) {
								count = (count + 1);
								int _size = classes.size();
								boolean _equals_1 = (count == _size);
								if (_equals_1) {
									EObject _copy = copier.copy(a);
									EStructuralFeature attr = ((EStructuralFeature) _copy);
									EClassifier _eType = a.getEType();
									attr.setEType(_eType);
									int _lowerBound = a.getLowerBound();
									attr.setLowerBound(_lowerBound);
									int _upperBound = a.getUpperBound();
									attr.setUpperBound(_upperBound);
									boolean _isChangeable = a.isChangeable();
									attr.setChangeable(_isChangeable);
									sharedAttributes.add(attr);
									count = 0;
								}
							}
						}
					}
				}
				count = 0;
			}
		}
		EList<EStructuralFeature> _eStructuralFeatures = newSuperClass.getEStructuralFeatures();
		_eStructuralFeatures.addAll(sharedAttributes);
		count = 0;
		for (final EOperation a_1 : checkOperations) {
			{
				for (final EClass c : classes) {
					{
						EList<EOperation> cOperations = c.getEOperations();
						for (final EOperation b : cOperations) {
							String _name = b.getName();
							String _name_1 = a_1.getName();
							boolean _equals = Objects.equal(_name, _name_1);
							if (_equals) {
								count = (count + 1);
								int _size = classes.size();
								boolean _equals_1 = (count == _size);
								if (_equals_1) {
									EObject _copy = copier.copy(a_1);
									EOperation operation = ((EOperation) _copy);
									EClassifier _eType = a_1.getEType();
									operation.setEType(_eType);
									int _lowerBound = a_1.getLowerBound();
									operation.setLowerBound(_lowerBound);
									int _upperBound = a_1.getUpperBound();
									operation.setUpperBound(_upperBound);
									boolean _isOrdered = a_1.isOrdered();
									operation.setOrdered(_isOrdered);
									sharedOperations.add(operation);
									count = 0;
								}
							}
						}
					}
				}
				count = 0;
			}
		}
		EList<EOperation> _eOperations = newSuperClass.getEOperations();
		_eOperations.addAll(sharedOperations);
		for (final EClass c : classes) {
			{
				boolean _isEmpty = sharedAttributes.isEmpty();
				boolean _not = (!_isEmpty);
				if (_not) {
					for (final EStructuralFeature a_2 : sharedAttributes) {
						Helper _helper = this.getHelper();
						String _name = a_2.getName();
						_helper.removeAttributeByName(c, _name);
					}
				}
				boolean _isEmpty_1 = sharedOperations.isEmpty();
				boolean _not_1 = (!_isEmpty_1);
				if (_not_1) {
					for (final EOperation o : sharedOperations) {
						Helper _helper_1 = this.getHelper();
						String _name_1 = o.getName();
						_helper_1.removeOperationByName(c, _name_1);
					}
				}
				EList<EClass> _eSuperTypes = c.getESuperTypes();
				_eSuperTypes.add(newSuperClass);
			}
		}
		EList<EClass> _referenceToEClass = this.getReferenceToEClass();
		_referenceToEClass.add(newSuperClass);
		EClass _get_2 = classes.get(0);
		EPackage _ePackage = _get_2.getEPackage();
		EList<EClassifier> _eClassifiers = _ePackage.getEClassifiers();
		_eClassifiers.add(newSuperClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void extractSubClass(final String superClass, final String name,
			final EList<String> operations, final EList<String> attributes) {
		final EClass newClass = EcoreFactory.eINSTANCE.createEClass();
		newClass.setName(name);
		EList<EClass> _referenceToEClass = this.getReferenceToEClass();
		_referenceToEClass.add(newClass);
		Helper _helper = this.getHelper();
		EClass superCl = _helper.getClass(superClass);
		boolean _isEmpty = attributes.isEmpty();
		boolean _not = (!_isEmpty);
		if (_not) {
			for (final String s : attributes) {
				try {
					String _name = newClass.getName();
					String _name_1 = superCl.getName();
					this.moveEAttribute(s, _name, _name_1);
				}
				catch (final Throwable _t) {
					if (_t instanceof GTFailure) {
						final GTFailure f = (GTFailure)_t;
					}
					else {
						throw Exceptions.sneakyThrow(_t);
					}
				}
			}
		}
		boolean _isEmpty_1 = operations.isEmpty();
		boolean _not_1 = (!_isEmpty_1);
		if (_not_1) {
			for (final String s2 : operations) {
				try {
					String _name_2 = newClass.getName();
					String _name_3 = superCl.getName();
					this.moveEOperation(s2, _name_2, _name_3);
				}
				catch (final Throwable _t_1) {
					if (_t_1 instanceof GTFailure) {
						final GTFailure f_1 = (GTFailure)_t_1;
					}
					else {
						throw Exceptions.sneakyThrow(_t_1);
					}
				}
			}
		}
		EList<EClass> _eSuperTypes = newClass.getESuperTypes();
		_eSuperTypes.add(superCl);
		EPackage _ePackage = superCl.getEPackage();
		EList<EClassifier> _eClassifiers = _ePackage.getEClassifiers();
		_eClassifiers.add(newClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void hideDelegate(final String serverName,
			final String delegateName, final String clientName) {
		EList<EClass> _referenceToEClass = this.getReferenceToEClass();
		final Function1<EClass, Boolean> _function = new Function1<EClass, Boolean>() {
			public Boolean apply(final EClass e) {
				String _name = e.getName();
				return Boolean.valueOf(Objects.equal(_name, serverName));
			}
		};
		final EClass server = IterableExtensions.<EClass>findFirst(_referenceToEClass, _function);
		EList<EClass> _referenceToEClass_1 = this.getReferenceToEClass();
		final Function1<EClass, Boolean> _function_1 = new Function1<EClass, Boolean>() {
			public Boolean apply(final EClass e) {
				String _name = e.getName();
				return Boolean.valueOf(Objects.equal(_name, clientName));
			}
		};
		final EClass client = IterableExtensions.<EClass>findFirst(_referenceToEClass_1, _function_1);
		EList<EClass> _referenceToEClass_2 = this.getReferenceToEClass();
		final Function1<EClass, Boolean> _function_2 = new Function1<EClass, Boolean>() {
			public Boolean apply(final EClass e) {
				String _name = e.getName();
				return Boolean.valueOf(Objects.equal(_name, delegateName));
			}
		};
		final EClass delegate = IterableExtensions.<EClass>findFirst(_referenceToEClass_2, _function_2);
		EList<EReference> _referenceToEReference = this.getReferenceToEReference();
		final Function1<EReference, Boolean> _function_3 = new Function1<EReference, Boolean>() {
			public Boolean apply(final EReference e) {
				boolean _and = false;
				EList<EStructuralFeature> _eStructuralFeatures = client.getEStructuralFeatures();
				boolean _contains = _eStructuralFeatures.contains(e);
				if (!_contains) {
					_and = false;
				} else {
					EClassifier _eType = e.getEType();
					boolean _equals = _eType.equals(delegate);
					_and = _equals;
				}
				return Boolean.valueOf(_and);
			}
		};
		final EReference c2dRef = IterableExtensions.<EReference>findFirst(_referenceToEReference, _function_3);
		EList<EReference> _referenceToEReference_1 = this.getReferenceToEReference();
		final Function1<EReference, Boolean> _function_4 = new Function1<EReference, Boolean>() {
			public Boolean apply(final EReference e) {
				boolean _and = false;
				EList<EStructuralFeature> _eStructuralFeatures = client.getEStructuralFeatures();
				boolean _contains = _eStructuralFeatures.contains(e);
				if (!_contains) {
					_and = false;
				} else {
					EClassifier _eType = e.getEType();
					boolean _equals = _eType.equals(server);
					_and = _equals;
				}
				return Boolean.valueOf(_and);
			}
		};
		final EReference c2sRef = IterableExtensions.<EReference>findFirst(_referenceToEReference_1, _function_4);
		EList<EReference> _referenceToEReference_2 = this.getReferenceToEReference();
		final Function1<EReference, Boolean> _function_5 = new Function1<EReference, Boolean>() {
			public Boolean apply(final EReference e) {
				boolean _and = false;
				EList<EStructuralFeature> _eStructuralFeatures = server.getEStructuralFeatures();
				boolean _contains = _eStructuralFeatures.contains(e);
				if (!_contains) {
					_and = false;
				} else {
					EClassifier _eType = e.getEType();
					boolean _equals = _eType.equals(delegate);
					_and = _equals;
				}
				return Boolean.valueOf(_and);
			}
		};
		final EReference s2dRef = IterableExtensions.<EReference>findFirst(_referenceToEReference_2, _function_5);
		boolean _and = false;
		boolean _notEquals = (!Objects.equal(c2sRef, null));
		if (!_notEquals) {
			_and = false;
		} else {
			boolean _notEquals_1 = (!Objects.equal(s2dRef, null));
			_and = _notEquals_1;
		}
		if (_and) {
			EcoreUtil.remove(c2dRef);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void removeMiddleMan(String serverName, String delegateName,
			String clientName) {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void replaceDelegationWithInheritance(final String delegateName,
			final String superClassName) {
		EList<EClass> _referenceToEClass = this.getReferenceToEClass();
		final Function1<EClass, Boolean> _function = new Function1<EClass, Boolean>() {
			public Boolean apply(final EClass e) {
				String _name = e.getName();
				return Boolean.valueOf(Objects.equal(_name, delegateName));
			}
		};
		final EClass delegate = IterableExtensions.<EClass>findFirst(_referenceToEClass, _function);
		EList<EClass> _referenceToEClass_1 = this.getReferenceToEClass();
		final Function1<EClass, Boolean> _function_1 = new Function1<EClass, Boolean>() {
			public Boolean apply(final EClass e) {
				String _name = e.getName();
				return Boolean.valueOf(Objects.equal(_name, superClassName));
			}
		};
		final EClass superClass = IterableExtensions.<EClass>findFirst(_referenceToEClass_1, _function_1);
		EList<EReference> _referenceToEReference = this.getReferenceToEReference();
		final Function1<EReference, Boolean> _function_2 = new Function1<EReference, Boolean>() {
			public Boolean apply(final EReference e) {
				boolean _and = false;
				EList<EStructuralFeature> _eStructuralFeatures = delegate.getEStructuralFeatures();
				boolean _contains = _eStructuralFeatures.contains(e);
				if (!_contains) {
					_and = false;
				} else {
					EClassifier _eType = e.getEType();
					boolean _equals = _eType.equals(superClass);
					_and = _equals;
				}
				return Boolean.valueOf(_and);
			}
		};
		final EReference deletionReference = IterableExtensions.<EReference>findFirst(_referenceToEReference, _function_2);
		EcoreUtil.remove(deletionReference);
		EList<EClass> _eSuperTypes = delegate.getESuperTypes();
		_eSuperTypes.add(superClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void replaceInheritanceWithDelegation(final String subClassName,
			final String superClassName) {
		EList<EClass> _referenceToEClass = this.getReferenceToEClass();
		final Function1<EClass, Boolean> _function = new Function1<EClass, Boolean>() {
			public Boolean apply(final EClass e) {
				String _name = e.getName();
				return Boolean.valueOf(Objects.equal(_name, subClassName));
			}
		};
		final EClass sourceClass = IterableExtensions.<EClass>findFirst(_referenceToEClass, _function);
		EList<EClass> _referenceToEClass_1 = this.getReferenceToEClass();
		final Function1<EClass, Boolean> _function_1 = new Function1<EClass, Boolean>() {
			public Boolean apply(final EClass e) {
				boolean _and = false;
				String _name = e.getName();
				boolean _equals = Objects.equal(_name, superClassName);
				if (!_equals) {
					_and = false;
				} else {
					EList<EClass> _eSuperTypes = sourceClass.getESuperTypes();
					boolean _contains = _eSuperTypes.contains(e);
					_and = _contains;
				}
				return Boolean.valueOf(_and);
			}
		};
		final EClass targetClass = IterableExtensions.<EClass>findFirst(_referenceToEClass_1, _function_1);
		String _name = sourceClass.getName();
		String _plus = (_name + "To");
		String _name_1 = targetClass.getName();
		final String newReferenceNameValue = (_plus + _name_1);
		EList<EClass> _eSuperTypes = sourceClass.getESuperTypes();
		_eSuperTypes.remove(targetClass);
		EReference newReference = EcoreFactory.eINSTANCE.createEReference();
		newReference.setName(newReferenceNameValue);
		EList<EStructuralFeature> _eStructuralFeatures = sourceClass.getEStructuralFeatures();
		_eStructuralFeatures.add(newReference);
		newReference.setEType(targetClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void changeBidirectionalToUnidirectionalReference(
			final String sourceClassName, final String targetClassName) {
		try {
			EClass sourceClass = null;
			EClass targetClass = null;
			EReference reference1 = null;
			EReference reference2 = null;
			EList<EClass> _referenceToEClass = this.getReferenceToEClass();
			final Function1<EClass, Boolean> _function = new Function1<EClass, Boolean>() {
				public Boolean apply(final EClass e) {
					String _name = e.getName();
					return Boolean.valueOf(Objects.equal(_name, targetClassName));
				}
			};
			Iterable<EClass> _filter = IterableExtensions.<EClass>filter(_referenceToEClass, _function);
			for (final EClass _targetClass : _filter) {
				EList<EClass> _referenceToEClass_1 = this.getReferenceToEClass();
				final Function1<EClass, Boolean> _function_1 = new Function1<EClass, Boolean>() {
					public Boolean apply(final EClass e) {
						String _name = e.getName();
						return Boolean.valueOf(Objects.equal(_name, sourceClassName));
					}
				};
				Iterable<EClass> _filter_1 = IterableExtensions.<EClass>filter(_referenceToEClass_1, _function_1);
				for (final EClass _sourceClass : _filter_1) {
					EList<EReference> _referenceToEReference = this.getReferenceToEReference();
					final Function1<EReference, Boolean> _function_2 = new Function1<EReference, Boolean>() {
						public Boolean apply(final EReference e) {
							boolean _and = false;
							EList<EReference> _eReferences = _targetClass.getEReferences();
							boolean _contains = _eReferences.contains(e);
							if (!_contains) {
								_and = false;
							} else {
								EClass _eReferenceType = e.getEReferenceType();
								boolean _equals = _eReferenceType.equals(_sourceClass);
								_and = _equals;
							}
							return Boolean.valueOf(_and);
						}
					};
					Iterable<EReference> _filter_2 = IterableExtensions.<EReference>filter(_referenceToEReference, _function_2);
					for (final EReference _reference2 : _filter_2) {
						EList<EReference> _eReferences = _sourceClass.getEReferences();
						final Function1<EReference, Boolean> _function_3 = new Function1<EReference, Boolean>() {
							public Boolean apply(final EReference e) {
								boolean _and = false;
								boolean _and_1 = false;
								EReference _eOpposite = _reference2.getEOpposite();
								boolean _equals = _eOpposite.equals(e);
								if (!_equals) {
									_and_1 = false;
								} else {
									EClass _eReferenceType = e.getEReferenceType();
									boolean _equals_1 = _eReferenceType.equals(_targetClass);
									_and_1 = _equals_1;
								}
								if (!_and_1) {
									_and = false;
								} else {
									EReference _eOpposite_1 = e.getEOpposite();
									boolean _equals_2 = _eOpposite_1.equals(_reference2);
									_and = _equals_2;
								}
								return Boolean.valueOf(_and);
							}
						};
						Iterable<EReference> _filter_3 = IterableExtensions.<EReference>filter(_eReferences, _function_3);
						for (final EReference _reference1 : _filter_3) {
							{
								sourceClass = _sourceClass;
								targetClass = _targetClass;
								reference1 = _reference1;
								reference2 = _reference2;
							}
						}
					}
				}
			}
			boolean _equals = Objects.equal(sourceClass, null);
			if (_equals) {
				throw new GTFailure();
			}
			EcoreUtil.remove(reference2);
		}
		catch (Throwable _e) {
			throw org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void changeBidirectionalToUnidirectionalReferenceREF(
			final EReference ref) {
		EReference _eOpposite = ref.getEOpposite();
		boolean _notEquals = (!Objects.equal(_eOpposite, null));
		if (_notEquals) {
			EcoreUtil.remove(ref);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void changeUnidirectionalToBidirectionalReference(
			final String class1Name, final String class2Name) {
		try {
			EClass class1 = null;
			EClass class2 = null;
			EReference reference1 = null;
			EList<EClass> _referenceToEClass = this.getReferenceToEClass();
			final Function1<EClass, Boolean> _function = new Function1<EClass, Boolean>() {
				public Boolean apply(final EClass e) {
					String _name = e.getName();
					return Boolean.valueOf(Objects.equal(_name, class1Name));
				}
			};
			Iterable<EClass> _filter = IterableExtensions.<EClass>filter(_referenceToEClass, _function);
			for (final EClass _class1 : _filter) {
				EList<EClass> _referenceToEClass_1 = this.getReferenceToEClass();
				final Function1<EClass, Boolean> _function_1 = new Function1<EClass, Boolean>() {
					public Boolean apply(final EClass e) {
						String _name = e.getName();
						return Boolean.valueOf(Objects.equal(_name, class2Name));
					}
				};
				Iterable<EClass> _filter_1 = IterableExtensions.<EClass>filter(_referenceToEClass_1, _function_1);
				for (final EClass _class2 : _filter_1) {
					EList<EReference> _eReferences = _class1.getEReferences();
					final Function1<EReference, Boolean> _function_2 = new Function1<EReference, Boolean>() {
						public Boolean apply(final EReference e) {
							EClassifier _eType = e.getEType();
							return Boolean.valueOf(_eType.equals(_class2));
						}
					};
					Iterable<EReference> _filter_2 = IterableExtensions.<EReference>filter(_eReferences, _function_2);
					for (final EReference _reference1 : _filter_2) {
						EReference _eOpposite = _reference1.getEOpposite();
						boolean _notEquals = (!Objects.equal(_eOpposite, null));
						boolean _not = (!_notEquals);
						if (_not) {
							class1 = _class1;
							class2 = _class2;
							reference1 = _reference1;
						}
					}
				}
			}
			boolean _equals = Objects.equal(class1, null);
			if (_equals) {
				throw new GTFailure();
			}
			final String reference2NameValue = ((class1Name + "to") + class2Name);
			EReference reference2 = EcoreFactory.eINSTANCE.createEReference();
			reference2.setName(reference2NameValue);
			reference2.setEOpposite(reference1);
			reference1.setEOpposite(reference2);
			EList<EStructuralFeature> _eStructuralFeatures = class2.getEStructuralFeatures();
			_eStructuralFeatures.add(reference2);
			EList<EReference> _referenceToEReference = this.getReferenceToEReference();
			_referenceToEReference.add(reference2);
			reference2.setEType(class1);
		}
		catch (Throwable _e) {
			throw org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void collapseHierararchy(final ClassType classType,
			final String superClass, final String subClass) {
		Helper _helper = this.getHelper();
		EClass superCl = _helper.getClass(superClass);
		Helper _helper_1 = this.getHelper();
		EClass subCl = _helper_1.getClass(subClass);
		boolean _equals = Objects.equal(classType, ClassType.SUPER_CLASS);
		if (_equals) {
			try {
				this.removeSuper(superCl, subCl);
			}
			catch (final Throwable _t) {
				if (_t instanceof GTFailure) {
					final GTFailure f = (GTFailure)_t;
				}
				else {
					throw Exceptions.sneakyThrow(_t);
				}
			}
		}
		boolean _equals_1 = Objects.equal(classType, ClassType.SUB_CLASS);
		if (_equals_1) {
			try {
				this.removeSub(superCl, subCl);
			}
			catch (final Throwable _t_1) {
				if (_t_1 instanceof GTFailure) {
					final GTFailure f_1 = (GTFailure)_t_1;
				}
				else {
					throw Exceptions.sneakyThrow(_t_1);
				}
			}
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void removeSuper(final EClass superClass, final EClass subClass) {
		try {
			boolean _and = false;
			boolean _notEquals = (!Objects.equal(superClass, null));
			if (!_notEquals) {
				_and = false;
			} else {
				boolean _notEquals_1 = (!Objects.equal(subClass, null));
				_and = _notEquals_1;
			}
			boolean _not = (!_and);
			if (_not) {
				throw new GTFailure();
			}
			EList<EStructuralFeature> structuralFeatures = null;
			EList<EOperation> operations = null;
			EList<EReference> externalReferences = null;
			final EList<EStructuralFeature> _structuralFeatures = superClass.getEStructuralFeatures();
			final EList<EOperation> _operations = superClass.getEOperations();
			EList<EReference> _referenceToEReference = this.getReferenceToEReference();
			final Function1<EReference, Boolean> _function = new Function1<EReference, Boolean>() {
				public Boolean apply(final EReference e) {
					EClassifier _eType = e.getEType();
					return Boolean.valueOf(_eType.equals(superClass));
				}
			};
			Iterable<EReference> _filter = IterableExtensions.<EReference>filter(_referenceToEReference, _function);
			final EList<EReference> _externalReferences = ECollections.<EReference>asEList(((EReference[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter, EReference.class)));
			structuralFeatures = _structuralFeatures;
			operations = _operations;
			externalReferences = _externalReferences;
			boolean _equals = Objects.equal(structuralFeatures, null);
			if (_equals) {
				throw new GTFailure();
			}
			EcoreUtil.remove(superClass);
			final Procedure1<EReference> _function_1 = new Procedure1<EReference>() {
				public void apply(final EReference e) {
					e.setEType(subClass);
				}
			};
			IterableExtensions.<EReference>forEach(externalReferences, _function_1);
			EList<EStructuralFeature> _eStructuralFeatures = subClass.getEStructuralFeatures();
			_eStructuralFeatures.addAll(structuralFeatures);
			EList<EOperation> _eOperations = subClass.getEOperations();
			_eOperations.addAll(operations);
		}
		catch (Throwable _e) {
			throw org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void removeSub(final EClass superClass, final EClass subClass) {
		try {
			boolean _and = false;
			boolean _notEquals = (!Objects.equal(superClass, null));
			if (!_notEquals) {
				_and = false;
			} else {
				boolean _notEquals_1 = (!Objects.equal(subClass, null));
				_and = _notEquals_1;
			}
			boolean _not = (!_and);
			if (_not) {
				throw new GTFailure();
			}
			EList<EStructuralFeature> structuralFeatures = null;
			EList<EOperation> operations = null;
			EList<EReference> externalReferences = null;
			final EList<EOperation> _operations = subClass.getEOperations();
			final EList<EStructuralFeature> _structuralFeatures = subClass.getEStructuralFeatures();
			EList<EReference> _referenceToEReference = this.getReferenceToEReference();
			final Function1<EReference, Boolean> _function = new Function1<EReference, Boolean>() {
				public Boolean apply(final EReference e) {
					EClassifier _eType = e.getEType();
					return Boolean.valueOf(_eType.equals(subClass));
				}
			};
			Iterable<EReference> _filter = IterableExtensions.<EReference>filter(_referenceToEReference, _function);
			final EList<EReference> _externalReferences = ECollections.<EReference>asEList(((EReference[])org.eclipse.xtext.xbase.lib.Conversions.unwrapArray(_filter, EReference.class)));
			structuralFeatures = _structuralFeatures;
			operations = _operations;
			externalReferences = _externalReferences;
			EcoreUtil.remove(subClass);
			EList<EStructuralFeature> _eStructuralFeatures = superClass.getEStructuralFeatures();
			_eStructuralFeatures.addAll(structuralFeatures);
			EList<EOperation> _eOperations = superClass.getEOperations();
			_eOperations.addAll(operations);
			final Procedure1<EReference> _function_1 = new Procedure1<EReference>() {
				public void apply(final EReference e) {
					e.setEType(superClass);
				}
			};
			IterableExtensions.<EReference>forEach(externalReferences, _function_1);
		}
		catch (Throwable _e) {
			throw org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void changeValueToReference(final String class1Name,
			final String class2Name) {
		try {
			boolean _or = false;
			boolean _or_1 = false;
			boolean _or_2 = false;
			boolean _notEquals = (!Objects.equal(class1Name, null));
			if (_notEquals) {
				_or_2 = true;
			} else {
				boolean _notEquals_1 = (!Objects.equal(class1Name, ""));
				_or_2 = _notEquals_1;
			}
			if (_or_2) {
				_or_1 = true;
			} else {
				boolean _notEquals_2 = (!Objects.equal(class2Name, null));
				_or_1 = _notEquals_2;
			}
			if (_or_1) {
				_or = true;
			} else {
				boolean _notEquals_3 = (!Objects.equal(class2Name, ""));
				_or = _notEquals_3;
			}
			boolean _not = (!_or);
			if (_not) {
				throw new GTFailure();
			}
			EClass class1 = null;
			EClass class2 = null;
			EReference reference = null;
			EList<EClass> _referenceToEClass = this.getReferenceToEClass();
			final Function1<EClass, Boolean> _function = new Function1<EClass, Boolean>() {
				public Boolean apply(final EClass e) {
					String _name = e.getName();
					return Boolean.valueOf(Objects.equal(_name, class2Name));
				}
			};
			Iterable<EClass> _filter = IterableExtensions.<EClass>filter(_referenceToEClass, _function);
			for (final EClass _class2 : _filter) {
				EList<EClass> _referenceToEClass_1 = this.getReferenceToEClass();
				final Function1<EClass, Boolean> _function_1 = new Function1<EClass, Boolean>() {
					public Boolean apply(final EClass e) {
						String _name = e.getName();
						return Boolean.valueOf(Objects.equal(_name, class1Name));
					}
				};
				Iterable<EClass> _filter_1 = IterableExtensions.<EClass>filter(_referenceToEClass_1, _function_1);
				for (final EClass _class1 : _filter_1) {
					EList<EReference> _eReferences = class1.getEReferences();
					final Function1<EReference, Boolean> _function_2 = new Function1<EReference, Boolean>() {
						public Boolean apply(final EReference e) {
							boolean _and = false;
							boolean _isContainment = e.isContainment();
							boolean _equals = (_isContainment == true);
							if (!_equals) {
								_and = false;
							} else {
								EClassifier _eType = e.getEType();
								boolean _equals_1 = _eType.equals(_class2);
								_and = _equals_1;
							}
							return Boolean.valueOf(_and);
						}
					};
					Iterable<EReference> _filter_2 = IterableExtensions.<EReference>filter(_eReferences, _function_2);
					for (final EReference _reference : _filter_2) {
						{
							class1 = _class1;
							class2 = _class2;
							reference = _reference;
						}
					}
				}
			}
			boolean _equals = Objects.equal(class1, null);
			if (_equals) {
				throw new GTFailure();
			}
		}
		catch (Throwable _e) {
			throw org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void changeReferenceToValue(final String nameClass1,
			final String nameClass2) {
		try {
			EClass class1 = null;
			EClass class2 = null;
			EReference reference = null;
			EList<EClass> _referenceToEClass = this.getReferenceToEClass();
			final Function1<EClass, Boolean> _function = new Function1<EClass, Boolean>() {
				public Boolean apply(final EClass e) {
					String _name = e.getName();
					return Boolean.valueOf(Objects.equal(_name, nameClass1));
				}
			};
			Iterable<EClass> _filter = IterableExtensions.<EClass>filter(_referenceToEClass, _function);
			for (final EClass _class1 : _filter) {
				EList<EClass> _referenceToEClass_1 = this.getReferenceToEClass();
				final Function1<EClass, Boolean> _function_1 = new Function1<EClass, Boolean>() {
					public Boolean apply(final EClass e) {
						String _name = e.getName();
						return Boolean.valueOf(Objects.equal(_name, nameClass2));
					}
				};
				Iterable<EClass> _filter_1 = IterableExtensions.<EClass>filter(_referenceToEClass_1, _function_1);
				for (final EClass _class2 : _filter_1) {
					EList<EReference> _referenceToEReference = this.getReferenceToEReference();
					final Function1<EReference, Boolean> _function_2 = new Function1<EReference, Boolean>() {
						public Boolean apply(final EReference e) {
							boolean _and = false;
							EList<EReference> _eReferences = _class1.getEReferences();
							boolean _contains = _eReferences.contains(e);
							if (!_contains) {
								_and = false;
							} else {
								EList<EReference> _eReferences_1 = _class2.getEReferences();
								boolean _contains_1 = _eReferences_1.contains(e);
								_and = _contains_1;
							}
							return Boolean.valueOf(_and);
						}
					};
					Iterable<EReference> _filter_2 = IterableExtensions.<EReference>filter(_referenceToEReference, _function_2);
					for (final EReference _reference : _filter_2) {
						{
							class1 = _class1;
							class2 = _class2;
							reference = _reference;
						}
					}
				}
			}
			boolean _equals = Objects.equal(class1, null);
			if (_equals) {
				throw new GTFailure();
			}
			reference.setContainment(true);
		}
		catch (Throwable _e) {
			throw org.eclipse.xtext.xbase.lib.Exceptions.sneakyThrow(_e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void replaceSubclassWithFields(final String superClass) {
		Helper _helper = this.getHelper();
		EClass superCl = _helper.getClass(superClass);
		Helper _helper_1 = this.getHelper();
		EList<EClass> subClasses = _helper_1.getAllSubClasses(superCl);
		EEnum newEnum = EcoreFactory.eINSTANCE.createEEnum();
		newEnum.setName((superClass + "Type"));
		EList<ENamedElement> _referenceToENamedElement = this.getReferenceToENamedElement();
		_referenceToENamedElement.add(newEnum);
		int i = 0;
		for (final EClass c : subClasses) {
			{
				EEnumLiteral newEnumLiteral = EcoreFactory.eINSTANCE.createEEnumLiteral();
				String _name = c.getName();
				String _upperCase = _name.toUpperCase();
				newEnumLiteral.setLiteral(_upperCase);
				newEnumLiteral.setValue(i);
				String _name_1 = c.getName();
				String _upperCase_1 = _name_1.toUpperCase();
				newEnumLiteral.setName(_upperCase_1);
				EList<EEnumLiteral> _eLiterals = newEnum.getELiterals();
				_eLiterals.add(newEnumLiteral);
				i = (i + 1);
			}
		}
		EAttribute opParam = EcoreFactory.eINSTANCE.createEAttribute();
		opParam.setEType(newEnum);
		opParam.setName((("_" + superClass) + "Type"));
		EList<EStructuralFeature> _eStructuralFeatures = superCl.getEStructuralFeatures();
		_eStructuralFeatures.add(opParam);
		EList<EClass> _referenceToEClass = this.getReferenceToEClass();
		_referenceToEClass.removeAll(subClasses);
		EPackage _ePackage = superCl.getEPackage();
		EList<EClassifier> _eClassifiers = _ePackage.getEClassifiers();
		_eClassifiers.removeAll(subClasses);
		EPackage _ePackage_1 = superCl.getEPackage();
		EList<EClassifier> _eClassifiers_1 = _ePackage_1.getEClassifiers();
		_eClassifiers_1.add(newEnum);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ERefactoringPackage.REFACTORING__HELPER:
				if (resolve) return getHelper();
				return basicGetHelper();
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EPACKAGE:
				return getReferenceToEPackage();
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_ENAMED_ELEMENT:
				return getReferenceToENamedElement();
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EOPERATION:
				return getReferenceToEOperation();
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_ECLASS:
				return getReferenceToEClass();
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EATTRIBUTE:
				return getReferenceToEAttribute();
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EREFERENCE:
				return getReferenceToEReference();
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EPARAMETER:
				return getReferenceToEParameter();
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_ESTRUCTURAL_FEATURE:
				return getReferenceToEStructuralFeature();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ERefactoringPackage.REFACTORING__HELPER:
				setHelper((Helper)newValue);
				return;
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EPACKAGE:
				getReferenceToEPackage().clear();
				getReferenceToEPackage().addAll((Collection<? extends EPackage>)newValue);
				return;
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_ENAMED_ELEMENT:
				getReferenceToENamedElement().clear();
				getReferenceToENamedElement().addAll((Collection<? extends ENamedElement>)newValue);
				return;
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EOPERATION:
				getReferenceToEOperation().clear();
				getReferenceToEOperation().addAll((Collection<? extends EOperation>)newValue);
				return;
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_ECLASS:
				getReferenceToEClass().clear();
				getReferenceToEClass().addAll((Collection<? extends EClass>)newValue);
				return;
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EATTRIBUTE:
				getReferenceToEAttribute().clear();
				getReferenceToEAttribute().addAll((Collection<? extends EAttribute>)newValue);
				return;
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EREFERENCE:
				getReferenceToEReference().clear();
				getReferenceToEReference().addAll((Collection<? extends EReference>)newValue);
				return;
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EPARAMETER:
				getReferenceToEParameter().clear();
				getReferenceToEParameter().addAll((Collection<? extends EParameter>)newValue);
				return;
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_ESTRUCTURAL_FEATURE:
				getReferenceToEStructuralFeature().clear();
				getReferenceToEStructuralFeature().addAll((Collection<? extends EStructuralFeature>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ERefactoringPackage.REFACTORING__HELPER:
				setHelper((Helper)null);
				return;
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EPACKAGE:
				getReferenceToEPackage().clear();
				return;
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_ENAMED_ELEMENT:
				getReferenceToENamedElement().clear();
				return;
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EOPERATION:
				getReferenceToEOperation().clear();
				return;
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_ECLASS:
				getReferenceToEClass().clear();
				return;
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EATTRIBUTE:
				getReferenceToEAttribute().clear();
				return;
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EREFERENCE:
				getReferenceToEReference().clear();
				return;
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EPARAMETER:
				getReferenceToEParameter().clear();
				return;
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_ESTRUCTURAL_FEATURE:
				getReferenceToEStructuralFeature().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ERefactoringPackage.REFACTORING__HELPER:
				return helper != null;
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EPACKAGE:
				return referenceToEPackage != null && !referenceToEPackage.isEmpty();
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_ENAMED_ELEMENT:
				return referenceToENamedElement != null && !referenceToENamedElement.isEmpty();
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EOPERATION:
				return referenceToEOperation != null && !referenceToEOperation.isEmpty();
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_ECLASS:
				return referenceToEClass != null && !referenceToEClass.isEmpty();
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EATTRIBUTE:
				return referenceToEAttribute != null && !referenceToEAttribute.isEmpty();
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EREFERENCE:
				return referenceToEReference != null && !referenceToEReference.isEmpty();
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_EPARAMETER:
				return referenceToEParameter != null && !referenceToEParameter.isEmpty();
			case ERefactoringPackage.REFACTORING__REFERENCE_TO_ESTRUCTURAL_FEATURE:
				return referenceToEStructuralFeature != null && !referenceToEStructuralFeature.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments)
			throws InvocationTargetException {
		switch (operationID) {
		case ERefactoringPackage.REFACTORING___RENAME_ENAMED_ELEMENT__STRING_STRING:
			renameENamedElement((String) arguments.get(0),
					(String) arguments.get(1));
			return null;
		case ERefactoringPackage.REFACTORING___RENAME_ENAMED_ELEMENT__ENAMEDELEMENT_STRING:
			renameENamedElement((ENamedElement) arguments.get(0),
					(String) arguments.get(1));
			return null;
		case ERefactoringPackage.REFACTORING___ADD_EPARAMETER__STRING_STRING_ECLASSIFIER:
			addEParameter((String) arguments.get(0), (String) arguments.get(1),
					(EClassifier) arguments.get(2));
			return null;
		case ERefactoringPackage.REFACTORING___REMOVE_EPARAMETER__STRING_STRING:
			removeEParameter((String) arguments.get(0),
					(String) arguments.get(1));
			return null;
		case ERefactoringPackage.REFACTORING___MOVE_EOPERATION__STRING_STRING_STRING:
			moveEOperation((String) arguments.get(0),
					(String) arguments.get(1), (String) arguments.get(2));
			return null;
		case ERefactoringPackage.REFACTORING___MOVE_EATTRIBUTE__STRING_STRING_STRING:
			moveEAttribute((String) arguments.get(0),
					(String) arguments.get(1), (String) arguments.get(2));
			return null;
		case ERefactoringPackage.REFACTORING___INLINE_ECLASS__STRING_STRING:
			inlineEClass((String) arguments.get(0), (String) arguments.get(1));
			return null;
		case ERefactoringPackage.REFACTORING___EXTRACT_ECLASS__STRING_ELIST_ELIST_ELIST_STRING:
			extractEClass((String) arguments.get(0),
					(EList<String>) arguments.get(1),
					(EList<String>) arguments.get(2),
					(EList<String>) arguments.get(3), (String) arguments.get(4));
			return null;
		case ERefactoringPackage.REFACTORING___EXTRACT_ECLASS2__STRING_ELIST_ELIST_STRING:
			extractEClass2((String) arguments.get(0),
					(EList<String>) arguments.get(1),
					(EList<String>) arguments.get(2), (String) arguments.get(3));
			return null;
		case ERefactoringPackage.REFACTORING___PULL_UP_EATTRIBUTE__STRING_STRING:
			pullUpEAttribute((String) arguments.get(0),
					(String) arguments.get(1));
			return null;
		case ERefactoringPackage.REFACTORING___PUSH_DOWN_EATTRIBUTE__STRING_STRING:
			pushDownEAttribute((String) arguments.get(0),
					(String) arguments.get(1));
			return null;
		case ERefactoringPackage.REFACTORING___PULL_UP_EOPERATION__STRING_STRING:
			pullUpEOperation((String) arguments.get(0),
					(String) arguments.get(1));
			return null;
		case ERefactoringPackage.REFACTORING___PUSH_DOWN_EOPERATION__STRING_STRING:
			pushDownEOperation((String) arguments.get(0),
					(String) arguments.get(1));
			return null;
		case ERefactoringPackage.REFACTORING___EXTRACT_SUPER_CLASS_INIT__ELIST_STRING:
			extractSuperClassInit((EList<EClass>) arguments.get(0),
					(String) arguments.get(1));
			return null;
		case ERefactoringPackage.REFACTORING___EXTRACT_SUPER_CLASS__STRING_ELIST_ELIST_ELIST_ELIST:
			return extractSuperClass((String) arguments.get(0),
					(EList<EAttribute>) arguments.get(1),
					(EList<EOperation>) arguments.get(2),
					(EList<EReference>) arguments.get(3),
					(EList<EClass>) arguments.get(4));
		case ERefactoringPackage.REFACTORING___EXTRACT_SUPER_CLASS2__ELIST_STRING:
			extractSuperClass2((EList<EClass>) arguments.get(0),
					(String) arguments.get(1));
			return null;
		case ERefactoringPackage.REFACTORING___EXTRACT_SUB_CLASS__STRING_STRING_ELIST_ELIST:
			extractSubClass((String) arguments.get(0),
					(String) arguments.get(1),
					(EList<String>) arguments.get(2),
					(EList<String>) arguments.get(3));
			return null;
		case ERefactoringPackage.REFACTORING___HIDE_DELEGATE__STRING_STRING_STRING:
			hideDelegate((String) arguments.get(0), (String) arguments.get(1),
					(String) arguments.get(2));
			return null;
		case ERefactoringPackage.REFACTORING___REMOVE_MIDDLE_MAN__STRING_STRING_STRING:
			removeMiddleMan((String) arguments.get(0),
					(String) arguments.get(1), (String) arguments.get(2));
			return null;
		case ERefactoringPackage.REFACTORING___REPLACE_DELEGATION_WITH_INHERITANCE__STRING_STRING:
			replaceDelegationWithInheritance((String) arguments.get(0),
					(String) arguments.get(1));
			return null;
		case ERefactoringPackage.REFACTORING___REPLACE_INHERITANCE_WITH_DELEGATION__STRING_STRING:
			replaceInheritanceWithDelegation((String) arguments.get(0),
					(String) arguments.get(1));
			return null;
		case ERefactoringPackage.REFACTORING___CHANGE_BIDIRECTIONAL_TO_UNIDIRECTIONAL_REFERENCE__STRING_STRING:
			changeBidirectionalToUnidirectionalReference(
					(String) arguments.get(0), (String) arguments.get(1));
			return null;
		case ERefactoringPackage.REFACTORING___CHANGE_BIDIRECTIONAL_TO_UNIDIRECTIONAL_REFERENCE_REF__EREFERENCE:
			changeBidirectionalToUnidirectionalReferenceREF((EReference) arguments
					.get(0));
			return null;
		case ERefactoringPackage.REFACTORING___CHANGE_UNIDIRECTIONAL_TO_BIDIRECTIONAL_REFERENCE__STRING_STRING:
			changeUnidirectionalToBidirectionalReference(
					(String) arguments.get(0), (String) arguments.get(1));
			return null;
		case ERefactoringPackage.REFACTORING___COLLAPSE_HIERARARCHY__CLASSTYPE_STRING_STRING:
			collapseHierararchy((ClassType) arguments.get(0),
					(String) arguments.get(1), (String) arguments.get(2));
			return null;
		case ERefactoringPackage.REFACTORING___REMOVE_SUPER__ECLASS_ECLASS:
			removeSuper((EClass) arguments.get(0), (EClass) arguments.get(1));
			return null;
		case ERefactoringPackage.REFACTORING___REMOVE_SUB__ECLASS_ECLASS:
			removeSub((EClass) arguments.get(0), (EClass) arguments.get(1));
			return null;
		case ERefactoringPackage.REFACTORING___CHANGE_VALUE_TO_REFERENCE__STRING_STRING:
			changeValueToReference((String) arguments.get(0),
					(String) arguments.get(1));
			return null;
		case ERefactoringPackage.REFACTORING___CHANGE_REFERENCE_TO_VALUE__STRING_STRING:
			changeReferenceToValue((String) arguments.get(0),
					(String) arguments.get(1));
			return null;
		case ERefactoringPackage.REFACTORING___REPLACE_SUBCLASS_WITH_FIELDS__STRING:
			replaceSubclassWithFields((String) arguments.get(0));
			return null;
		}
		return super.eInvoke(operationID, arguments);
	}

	@Override
	public void extractEClassNEW(EClass existingClass, String newClassName,
			String newReferenceName,
			EList<EStructuralFeature> structuralFeaturesToMove,
			EList<EOperation> operationsToMove) throws GTFailure {
		// TODO Auto-generated method stub

	}

} // RefactoringImpl
